#!/usr/bin/env python

func_arg_list = [[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], [0, 1], [0, 1], [0, 1], [3, 0], [3, 0], [2, 0], [1, 0], [1, 0], [4, 0], [3, 0], [5, 0], [2, 0], [2, 0], [2, 0], [3, 0], [0, 0]]

cvt_dict = {
    'evheight_lu' : 0,   #  -422
    'vbase' : 1,   #  0
    'tvheight_num' : 2,   #  908
    'evheight' : 3,   #  1062
    'tvheight' : 4,   #  1140
    'ecvheight' : 5,   #  1450
    'estemtc' : 6,   #  218
    'cvt_7' : 7,   #  130
    'cvt_8' : 8,   #  139
    'estemt' : 9,   #  207
    'estemw' : 10,   #  240
    'tstemw' : 11,   #  240
    'ecstemw' : 12,   #  253
    'cvt_13' : 13,   #  233
    'cvt_14' : 14,   #  242
    'cvt_15' : 15,   #  214
    'cvt_16' : 16,   #  188
    'cvt_17' : 17,   #  216
    'cvt_18' : 18,   #  210
    'cvt_19' : 19,   #  175
    'cvt_20' : 20,   #  177
    'cvt_21' : 21,   #  231
    'cvt_22' : 22,   #  113
    'cvt_23' : 23,   #  133
#USER LAND
    'tvheight_num_shoot' : 24,  # 908+24=932
    'evheight_shoot' : 25,      # 1062+24=1086
    'tvheight_shoot' : 26,      # 1140+24=1164
    'ecvheight_shoot' : 27,     # 1450+27=1477
    'headstem'  : 28,    # 140
    'headdia'   : 29,    # 430
    'headstemplushole' : 30,    # 290 
    'estemwc'   : 31,   # 260
    }

pseudo_fpgm = """
                           #--- PUSHB_1   0         ;PUSH Bytes
FDEF            0          ;Function DEFinition
                           #--- PUSHB_1   0         ;PUSH Bytes
SZP0            0          ;Set Zone Pointer 0
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM_1 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   74        ;PUSH Bytes
SROUND          74         ;Super ROUND
EIF                        ;    End IF
                           #--- PUSHB_1   0         ;PUSH Bytes
SWAP            0 &_arg_1  ;SWAP the top two elements on the stack
MIAP[rnd]       &_SWAP_1 &_SWAP_2 ;Move Indirect Absolute Point
RTG                        ;Round To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
RTDG                       ;Round To Double Grid
EIF                        ;    End IF
MPPEM                      ;Measure Pixels Per EM
                           #--- PUSHB_1   42        ;PUSH Bytes
LT              42 &_MPPEM_1 ; Less Than
IF              &_LT_1     ;   IF test
RDTG                       ;Round Down To Grid
EIF                        ;    End IF
DUP             &_arg_2    ;DUPlicate top stack element
MDRP[rp0,rnd,grey] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SZP0            1          ;Set Zone Pointer 0
MDAP[no-rnd]    &_DUP_2    ;Move Direct Absolute Point
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   1         ;PUSH Bytes
FDEF            1          ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_DUP_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   2         ;PUSH Bytes
FDEF            2          ;Function DEFinition
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;Greater Than
IF              &_GT_1     ;   IF test
RCVT            &_arg_2    ;Read Control Value Table entry
SWAP            &_RCVT_1 &_arg_3 ;SWAP the top two elements on the stack
EIF                        ;    End IF
POP             &_SWAP_1   ;POP top stack element
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=1: &_SWAP_2
#------------------
#STACK_REMAIN=RETURN : &_f2_retval_1
#------------------

                           #--- PUSHB_1   3         ;PUSH Bytes
FDEF            3          ;Function DEFinition
ROUND[Black]    &_arg_1    ;ROUND value
RTG                        ;Round To Grid
DUP             &_ROUND_1  ;DUPlicate top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
LT              64 &_DUP_1 ; Less Than
IF              &_LT_1     ;   IF test
POP             &_DUP_2    ;POP top stack element
                           #--- PUSHB_1   64        ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=1: 64
#------------------
#STACK_REMAIN=RETURN : &_f3_retval_1
#------------------

                           #--- PUSHB_1   4         ;PUSH Bytes
FDEF            4          ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
POP             &_arg_1    ;POP top stack element
SWAP            &_arg_2 &_arg_3 ;SWAP the top two elements on the stack
POP             &_SWAP_1   ;POP top stack element
ROFF                       ; Round OFF
IF              &_SWAP_2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg_4    ;Move Direct Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_arg_1 ;Greater Than
IF              &_GT_1     ;   IF test
IF              &_arg_2    ;   IF test
MIRP[rp0,min,rnd,black] &_arg_3 &_arg_4 ;Move Indirect Relative Point
ELSE                       ;ELSE clause
MIRP[min,rnd,black] &_arg_3 &_arg_4 ;Move Indirect Relative Point
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg_2 &_arg_3 ;SWAP the top two elements on the stack
POP             &_SWAP_1   ;POP top stack element
                           #--- PUSHB_1   5         ;PUSH Bytes
CALL            5          ;CALL function
IF              &_f5_retval_1 ;   IF test
                           #--- PUSHB_1   70        ;PUSH Bytes
SROUND          70         ;Super ROUND
EIF                        ;    End IF
IF              &_SWAP_2   ;   IF test
MDRP[rp0,min,rnd,black] &_arg_4    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_arg_4    ;Move Direct Relative Point
EIF                        ;    End IF
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   5         ;PUSH Bytes
FDEF            5          ;Function DEFinition
GFV                        ;Get Freedom Vector
NOT             &_GFV_1    ;logical NOT
AND             &_NOT_1 &_GFV_2 ;logical AND
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_AND_1
#------------------
#STACK_REMAIN=RETURN : &_f5_retval_1
#------------------

                           #--- PUSHB_1   6         ;PUSH Bytes
FDEF            6          ;Function DEFinition
                           #--- PUSHB_2   34 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO_1 34 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   32        ;PUSH Bytes
GETINFO         32         ;GET INFOrmation
NOT             &_GETINFO_1 ;logical NOT
NOT             &_NOT_1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#------------------
#STACK_REMAIN=RETURN : &_f6_retval_1
#------------------

                           #--- PUSHB_1   7         ;PUSH Bytes
FDEF            7          ;Function DEFinition
                           #--- PUSHB_2   36 1      ;PUSH Bytes
GETINFO         1          ;GET INFOrmation
LT              &_GETINFO_1 36 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
GETINFO         64         ;GET INFOrmation
NOT             &_GETINFO_1 ;logical NOT
NOT             &_NOT_1    ;logical NOT
ELSE                       ;ELSE clause
                           #--- PUSHB_1   0         ;PUSH Bytes
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=1: &_NOT_1
#------------------
#STACK_REMAIN=RETURN : &_f7_retval_1
#------------------

                           #--- PUSHB_1   8         ;PUSH Bytes
FDEF            8          ;Function DEFinition
SRP2            &_arg_1    ;Set Reference Point 2
SRP1            &_arg_2    ;Set Reference Point 1
DUP             &_arg_3    ;DUPlicate top stack element
IP              &_DUP_1    ;Interpolate Point
MDAP[rnd]       &_DUP_2    ;Move Direct Absolute Point
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   9         ;PUSH Bytes
FDEF            9          ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
RDTG                       ;Round Down To Grid
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
MDRP[rnd,grey]  &_DUP_1    ;Move Direct Relative Point
ELSE                       ;ELSE clause
MDRP[min,rnd,black] &_DUP_2    ;Move Direct Relative Point
EIF                        ;    End IF
DUP             &_DUP_2    ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[grid]        &_CINDEX_1 &_DUP_1 ;Measure Distance
SWAP            &_MD_1 &_DUP_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[orig]        &_DUP_1 &_DUP_2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD_1   ; Less Than
IF              &_LT_1     ;   IF test
ROLL            &_SWAP_2 &_arg_2 &_arg_3 ;ROLL the top three stack elements
NEG             &_ROLL_1   ;    NEGate
ROLL            &_NEG_1 &_ROLL_2 &_ROLL_3 ;ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;  SUBtract
DUP             &_SUB_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_DUP_1  ; Less Than
IF              &_LT_1     ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
ROLL            &_arg_2 &_arg_3 &_arg_4 ;ROLL the top three stack elements
ROLL            &_ROLL_1 &_ROLL_2 &_ROLL_3 ;ROLL the top three stack elements
SUB             &_ROLL_1 &_ROLL_2 ;  SUBtract
DUP             &_SUB_1    ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_DUP_1  ;Greater Than
IF              &_GT_1     ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_5    ;POP top stack element
POP             &_arg_6    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
RTG                        ;Round To Grid
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   10        ;PUSH Bytes
FDEF            10         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
POP             &_arg_1    ;POP top stack element
SRP0            &_arg_2    ;Set Reference Point 0
ELSE                       ;ELSE clause
SRP0            &_arg_1    ;Set Reference Point 0
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   11        ;PUSH Bytes
FDEF            11         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
CALL            12 &_DUP_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   12        ;PUSH Bytes
FDEF            12         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
DUP             &_ROUND_1  ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
ABS             &_DUP_1    ;ABSolute value
DIV             &_ABS_1 &_DUP_2 ;    DIVide
SHPIX           &_DIV_1 &_DUP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=1:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   13        ;PUSH Bytes
FDEF            13         ;Function DEFinition
SRP2            &_arg_1    ;Set Reference Point 2
SRP1            &_arg_2    ;Set Reference Point 1
DUP             &_arg_3    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
IP              &_DUP_1    ;Interpolate Point
MDAP[rnd]       &_DUP_2    ;Move Direct Absolute Point
DUP             &_DUP_2    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_4 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
ROLL            &_GC_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
GC[cur]         &_ROLL_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_ROLL_2 ;  SUBtract
SWAP            &_SUB_1 &_ROLL_3 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
MD[orig]        &_SWAP_1 &_SWAP_2 ;Measure Distance
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_MD_1   ; Less Than
IF              &_LT_1     ;   IF test
SWAP            &_ROLL_3 &_ROLL_3 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
GT              0 &_SWAP_1 ;Greater Than
IF              &_GT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
SHPIX           64 &_SWAP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
SWAP            &_arg_5 &_arg_6 ;SWAP the top two elements on the stack
                           #--- PUSHB_1   0         ;PUSH Bytes
LT              0 &_SWAP_1 ; Less Than
IF              &_LT_1     ;   IF test
                           #--- PUSHB_1   64        ;PUSH Bytes
NEG             64         ;    NEGate
SHPIX           &_NEG_1 &_SWAP_2 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_7    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=4:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   14        ;PUSH Bytes
FDEF            14         ;Function DEFinition
                           #--- PUSHB_1   6         ;PUSH Bytes
CALL            6          ;CALL function
IF              &_f6_retval_1 ;   IF test
RTDG                       ;Round To Double Grid
MDRP[rp0,rnd,white] &_arg_1    ;Move Direct Relative Point
RTG                        ;Round To Grid
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
ELSE                       ;ELSE clause
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
ROLL            &_DUP_2 &_arg_2 &_arg_3 ;ROLL the top three stack elements
MPPEM                      ;Measure Pixels Per EM
GT              &_MPPEM_1 &_ROLL_1 ;Greater Than
IF              &_GT_1     ;   IF test
DUP             &_ROLL_2   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_3 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
MD[grid]        &_SWAP_1 &_SWAP_2 ;Measure Distance
DUP             &_MD_1     ;DUPlicate top stack element
                           #--- PUSHB_1   0         ;PUSH Bytes
NEQ             0 &_DUP_1  ; Not EQual
IF              &_NEQ_1    ;   IF test
SHPIX           &_DUP_2 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   15        ;PUSH Bytes
FDEF            15         ;Function DEFinition
SWAP            &_arg_1 &_arg_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
DUP             &_DUP_2    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
SWAP            &_DUP_2 &_SWAP_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
MPPEM                      ;Measure Pixels Per EM
GTEQ            &_MPPEM_1 &_DUP_2 ;Greater Than or EQual
ELSE                       ;ELSE clause
POP             &_GTEQ_1   ;POP top stack element
                           #--- PUSHB_1   1         ;PUSH Bytes
EIF                        ;    End IF
IF              &_GTEQ_1   ;   IF test
ROLL            &_SWAP_2 &_arg_3 &_arg_4 ;ROLL the top three stack elements
                           #--- PUSHB_1   4         ;PUSH Bytes
MINDEX          4          ;Move the INDEXed element to the top of the stack
MD[grid]        &_ROLL_1 &_ROLL_2 ;Measure Distance
SWAP            &_MD_1 &_ROLL_3 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_arg_5 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
DUP             &_SWAP_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_SWAP_2 ;ROLL the top three stack elements
MD[grid]        &_ROLL_1 &_ROLL_2 ;Measure Distance
ROLL            &_MD_1 &_ROLL_3 &_ROLL_3 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;  SUBtract
SHPIX           &_SUB_1 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
POP             &_arg_6    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             1          ;POP top stack element
POP             &_SWAP_2   ;POP top stack element
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
POP             &_arg_5    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=5:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   16        ;PUSH Bytes
FDEF            16         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,min,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_DUP_2 &_arg_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   17        ;PUSH Bytes
FDEF            17         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDRP[rp0,white] &_DUP_1    ;Move Direct Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
CALL            18 &_DUP_2 &_arg_2 ;CALL function
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   18        ;PUSH Bytes
FDEF            18         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
MDAP[rnd]       &_DUP_1    ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
CALL            7          ;CALL function
NOT             &_f7_retval_1 ;logical NOT
IF              &_NOT_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
DUP             &_DUP_1    ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SUB             &_GC_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
ROLL            &_ROUND_1 &_DUP_2 &_arg_2 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
GC[orig]        &_DUP_1    ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_DUP_2 ;SWAP the top two elements on the stack
GC[cur]         &_SWAP_1   ;Get Coordinate projected onto the projection vector
SWAP            &_GC_1 &_SWAP_2 ;SWAP the top two elements on the stack
SUB             &_SWAP_1 &_SWAP_2 ;  SUBtract
ROUND[White]    &_SUB_1    ;ROUND value
ADD             &_ROUND_1 &_ROLL_2 ;       ADD
DUP             &_ADD_1    ;DUPlicate top stack element
IF              &_DUP_1    ;   IF test
DUP             &_DUP_2    ;DUPlicate top stack element
ABS             &_DUP_1    ;ABSolute value
DIV             &_ABS_1 &_DUP_2 ;    DIVide
SHPIX           &_DIV_1 &_ROLL_3 ;SHift point by a PIXel amount
ELSE                       ;ELSE clause
POP             &_arg_3    ;POP top stack element
POP             &_arg_4    ;POP top stack element
EIF                        ;    End IF
ELSE                       ;ELSE clause
POP             &_arg_2    ;POP top stack element
POP             &_arg_3    ;POP top stack element
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=2:
#RET_COUNT=0: 
#------------------

                           #--- PUSHB_1   19        ;PUSH Bytes
FDEF            19         ;Function DEFinition
DUP             &_arg_1    ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_arg_2 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
SDPVTL[orthog]  &_ROLL_1 &_ROLL_2 ;Set Dual Projection Vector To Line
DUP             &_ROLL_3   ;DUPlicate top stack element
                           #--- PUSHB_1   3         ;PUSH Bytes
CINDEX          3          ;Copy the INDEXed element to the top of the stack
MD[orig]        &_CINDEX_1 &_DUP_1 ;Measure Distance
ABS             &_MD_1     ;ABSolute value
SWAP            &_ABS_1 &_DUP_2 ;SWAP the top two elements on the stack
ROLL            &_SWAP_1 &_SWAP_2 &_ROLL_3 ;ROLL the top three stack elements
SPVTL[orthog]   &_ROLL_1 &_ROLL_2 ;Set Projection Vector To Line
                           #--- PUSHB_1   32        ;PUSH Bytes
LT              32 &_ROLL_3 ; Less Than
IF              &_LT_1     ;   IF test
ALIGNRP         &_arg_3    ;ALIGN to Reference Point
ELSE                       ;ELSE clause
MDRP[grey]      &_arg_3    ;Move Direct Relative Point
EIF                        ;    End IF
ENDF                       ;END Function definition
#ARG_COUNT=3:
#RET_COUNT=0: 
#------------------

ENDF                       ;END Function definition
#ARG_COUNT=0:
#RET_COUNT=0: 
#------------------
"""



pseudo_code_dict = {
    '.notdef': """
                           #--- NPUSHB    14 1 7 0 24 4 7 4 7 0 24 4 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            4 24 0 7 4 ;CALL function
MDAP[rnd]       7          ;Move Direct Absolute Point
CALL            4 24 0 7 1 ;CALL function
                           #--- NPUSHB    17 9 1 3 10 0 13 4 5 1 4 4 10 0 13 4 0 8 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
CALL            4 13 0 10 4 ;CALL function
SRP0            4          ;Set Reference Point 0
CALL            1 5        ;CALL function
CALL            4 13 0 10 3 ;CALL function
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'A': """
                           #--- NPUSHB    14 3 6 3 10 5 6 13 6 5 0 0 5 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 5      ;CALL function
SHP[rp1]        0          ;SHift Point using reference point
CALL            0 5 6      ;CALL function
CALL            13 6 5 10 3 ;CALL function
MIRP[min,black] estemtc 3  ;Move Indirect Relative Point
                           #--- PUSHB_3   12 1 11   ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
CALL            1 12       ;CALL function
                           #--- PUSHB_3   9 6 10    ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            10         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'B': """
                           #--- NPUSHB    17 15 9 15 32 0 1 13 23 6 1 5 0 24 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemtc 24 ;Move Indirect Relative Point
CALL            0 5 1      ;CALL function
MIRP[min,black] estemtc 23 ;Move Indirect Relative Point
CALL            13 1 0 32 15 ;CALL function
MIRP[min,black] estemt 15  ;Move Indirect Relative Point
                           #--- NPUSHB    9 5 32 19 28 15 24 12 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 24 33 24 12 0 11 11 32 28 28 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   28 32 11 34 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       34         ;Move Direct Absolute Point
MDRP[rp0,min,white] 11         ;Move Direct Relative Point
MIRP[rp0,min,white] 32 28      ;Move Indirect Relative Point
SHPIX           -6 28      ;SHift point by a PIXel amount
MDAP[rnd]       28         ;Move Direct Absolute Point
MIRP[min,black] 32 11      ;Move Indirect Relative Point
SRP0            11         ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 24 ;Move Indirect Relative Point
SRP1            33         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 24 ;Move Indirect Relative Point
SHP[rp2]        15         ;SHift Point using reference point
SRP0            28         ;Set Reference Point 0
MDRP[rp0,rnd,grey] 19         ;Move Direct Relative Point
MIRP[min,black] 32 5       ;Move Indirect Relative Point
                           #--- PUSHB_7   5 23 8 15 11 32 24 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            24         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
IP              11         ;Interpolate Point
SRP1            15         ;Set Reference Point 1
IP              8          ;Interpolate Point
SRP2            23         ;Set Reference Point 2
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'C': """
                           #--- NPUSHB    24 64 17 14 9 17 10 10 17 6 10 5 0 64 23 1 9 23 4 10 23 6 4 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 4      ;CALL function
MIRP[min,black] estemtc 23 ;Move Indirect Relative Point
CALL            10 4 23    ;CALL function
CALL            9 1 23 64  ;CALL function
CALL            0 5 10     ;CALL function
MIRP[min,black] estemtc 17 ;Move Indirect Relative Point
CALL            10 10 17   ;CALL function
CALL            9 14 17 64 ;CALL function
                           #--- PUSHB_4   20 12 7 7 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    13 7 20 26 20 12 7 1 13 1 10 14 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   0 10 1 27 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       27         ;Move Direct Absolute Point
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 0   ;Move Indirect Relative Point
SHPIX           -6 0       ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
ALIGNRP         14         ;ALIGN to Reference Point
MIRP[min,black] estemw 1   ;Move Indirect Relative Point
SHP[rp2]        13         ;SHift Point using reference point
SRP0            1          ;Set Reference Point 0
MDRP[rp0,min,white] 7          ;Move Direct Relative Point
MIRP[min,white] ecstemw 20 ;Move Indirect Relative Point
SRP1            26         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
IP              7          ;Interpolate Point
SHPIX           -18 7      ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 20 ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'D': """
                           #--- NPUSHB    10 17 6 1 5 0 9 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemtc 9  ;Move Indirect Relative Point
CALL            0 5 1      ;CALL function
MIRP[min,black] estemtc 17 ;Move Indirect Relative Point
                           #--- PUSHB_4   9 12 0 0  ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 9 18 9 12 0 5 5 32 13 13 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   13 32 5 19 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       19         ;Move Direct Absolute Point
MDRP[rp0,min,white] 5          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 13      ;Move Indirect Relative Point
SHPIX           -6 13      ;SHift point by a PIXel amount
MDAP[rnd]       13         ;Move Direct Absolute Point
MIRP[min,black] 32 5       ;Move Indirect Relative Point
SRP0            5          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 9  ;Move Indirect Relative Point
SRP1            18         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 9  ;Move Indirect Relative Point
                           #--- PUSHB_3   5 17 9    ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            9          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'E': """
                           #--- NPUSHB    17 5 6 5 8 0 1 13 4 6 1 5 0 9 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemtc 9  ;Move Indirect Relative Point
CALL            0 5 1      ;CALL function
MIRP[min,black] estemtc 4  ;Move Indirect Relative Point
CALL            13 1 0 8 5 ;CALL function
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   5 9 12 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    9 0 9 12 9 12 0 3 11 13 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       13         ;Move Direct Absolute Point
MDRP[rp0,min,rnd,white] 11         ;Move Direct Relative Point
ALIGNRP         3          ;ALIGN to Reference Point
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 9  ;Move Indirect Relative Point
SRP1            12         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 9  ;Move Indirect Relative Point
SHP[rp2]        5          ;SHift Point using reference point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'F': """
                           #--- NPUSHB    15 5 6 5 8 0 1 13 4 6 1 5 0 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 5 1      ;CALL function
MIRP[min,black] estemtc 4  ;Move Indirect Relative Point
CALL            13 1 0 8 5 ;CALL function
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   5 9 12 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    8 0 9 10 9 12 0 3 11 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
MDRP[rp0,min,rnd,white] 3          ;Move Direct Relative Point
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 9  ;Move Indirect Relative Point
SRP1            10         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 9  ;Move Indirect Relative Point
SHP[rp2]        5          ;SHift Point using reference point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'G': """
                           #--- NPUSHB    24 29 6 29 30 5 11 13 64 18 15 9 18 11 10 18 6 11 5 0 24 6 5 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 5      ;CALL function
MIRP[min,black] estemtc 24 ;Move Indirect Relative Point
CALL            0 5 11     ;CALL function
MIRP[min,black] estemtc 18 ;Move Indirect Relative Point
CALL            10 11 18   ;CALL function
CALL            9 15 18 64 ;CALL function
CALL            13 11 5 30 29 ;CALL function
MIRP[min,black] estemtc 29 ;Move Indirect Relative Point
                           #--- NPUSHB    8 14 32 15 28 21 32 8 8 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 8 21 31 21 32 8 2 2 12 28 28 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   28 12 2 32 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       32         ;Move Direct Absolute Point
MDRP[rp0,min,white] 2          ;Move Direct Relative Point
MIRP[rp0,min,white] ecstemw 28 ;Move Indirect Relative Point
SHPIX           -6 28      ;SHift point by a PIXel amount
MDAP[rnd]       28         ;Move Direct Absolute Point
MIRP[min,black] ecstemw 2  ;Move Indirect Relative Point
SRP0            2          ;Set Reference Point 0
MDRP[rp0,min,white] 8          ;Move Direct Relative Point
MIRP[min,white] 32 21      ;Move Indirect Relative Point
SRP1            31         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
IP              8          ;Interpolate Point
SHPIX           -18 8      ;SHift point by a PIXel amount
MDAP[rnd]       8          ;Move Direct Absolute Point
MIRP[min,black] 32 21      ;Move Indirect Relative Point
SRP0            28         ;Set Reference Point 0
MDRP[rp0,rnd,grey] 15         ;Move Direct Relative Point
MIRP[min,black] 32 14      ;Move Indirect Relative Point
                           #--- PUSHB_4   8 21 18 30 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            30         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
IP              21         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'H': """
                           #--- NPUSHB    15 3 6 3 10 0 1 13 5 1 5 0 7 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        7          ;SHift Point using reference point
CALL            0 5 1      ;CALL function
SHP[rp1]        5          ;SHift Point using reference point
CALL            13 1 0 10 3 ;CALL function
MIRP[min,black] estemtc 3  ;Move Indirect Relative Point
                           #--- PUSHB_5   3 11 12 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    12 0 11 12 11 12 0 7 7 12 4 8 8 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   8 12 7 13 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       13         ;Move Direct Absolute Point
MDRP[rp0,min,white] 7          ;Move Direct Relative Point
MIRP[rp0,min,white] ecstemw 8  ;Move Indirect Relative Point
SHPIX           -6 8       ;SHift point by a PIXel amount
MDAP[rnd]       8          ;Move Direct Absolute Point
ALIGNRP         4          ;ALIGN to Reference Point
MIRP[min,black] ecstemw 7  ;Move Indirect Relative Point
SRP0            7          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 11 ;Move Indirect Relative Point
SRP1            12         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 11 ;Move Indirect Relative Point
SHP[rp2]        3          ;SHift Point using reference point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'I': """
                           #--- NPUSHB    12 9 6 9 7 5 0 0 3 9 2 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 2      ;CALL function
MIRP[min,black] estemt 3   ;Move Indirect Relative Point
SHP[rp2]        0          ;SHift Point using reference point
CALL            0 5 7      ;CALL function
MIRP[min,black] estemt 6   ;Move Indirect Relative Point
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_4   11 12 4 4 ;PUSH Bytes
                           #--- PUSHW_1   -12       ;PUSH Words
                           #--- PUSHB_5   4 11 12 11 13 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       13         ;Move Direct Absolute Point
MDRP[rp0,min,white] 11         ;Move Direct Relative Point
SRP1            12         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
IP              4          ;Interpolate Point
SHPIX           -12 4      ;SHift point by a PIXel amount
MDAP[rnd]       4          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 11 ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'J': """
                           #--- NPUSHB    17 16 9 17 5 0 64 11 7 9 11 4 10 11 6 4 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 4      ;CALL function
MIRP[min,black] estemtc 11 ;Move Indirect Relative Point
CALL            10 4 11    ;CALL function
CALL            9 7 11 64  ;CALL function
CALL            0 5 17     ;CALL function
MIRP[min,black] estemt 16  ;Move Indirect Relative Point
                           #--- PUSHB_4   8 12 7 7  ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 7 8 18 8 12 7 1 1 12 14 14 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   14 12 1 19 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       19         ;Move Direct Absolute Point
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[rp0,min,white] ecstemw 14 ;Move Indirect Relative Point
SHPIX           -6 14      ;SHift point by a PIXel amount
MDAP[rnd]       14         ;Move Direct Absolute Point
MIRP[min,black] ecstemw 1  ;Move Indirect Relative Point
SRP0            1          ;Set Reference Point 0
MDRP[rp0,min,white] 7          ;Move Direct Relative Point
MIRP[min,white] ecstemw 8  ;Move Indirect Relative Point
SRP1            18         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
IP              7          ;Interpolate Point
SHPIX           -18 7      ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 8  ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'K': """
                           #--- NPUSHB    8 9 6 5 0 0 5 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 5      ;CALL function
SHP[rp1]        0          ;SHift Point using reference point
CALL            0 5 6      ;CALL function
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_5   8 4 12 5 5 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 5 4 12 4 12 5 0 0 32 1 1 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   1 32 0 13 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       13         ;Move Direct Absolute Point
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 1       ;Move Indirect Relative Point
SHPIX           -6 1       ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] 32 0       ;Move Indirect Relative Point
SRP0            0          ;Set Reference Point 0
MDRP[rp0,min,white] 5          ;Move Direct Relative Point
MIRP[min,white] ecstemw 4  ;Move Indirect Relative Point
SRP1            12         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
IP              5          ;Interpolate Point
SHPIX           -18 5      ;SHift point by a PIXel amount
MDAP[rnd]       5          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 4  ;Move Indirect Relative Point
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_4   2 8 6 5   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            5          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
IP              8          ;Interpolate Point
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'L': """
                           #--- NPUSHB    8 1 5 0 3 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemtc 3  ;Move Indirect Relative Point
CALL            0 5 1      ;CALL function
                           #--- PUSHB_4   3 12 0 0  ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    8 0 3 6 3 12 0 5 7 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       7          ;Move Direct Absolute Point
MDRP[rp0,min,rnd,white] 5          ;Move Direct Relative Point
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 3  ;Move Indirect Relative Point
SRP1            6          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 3  ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'M': """
                           #--- NPUSHB    9 4 1 5 0 6 9 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        9          ;SHift Point using reference point
SHP[rp1]        6          ;SHift Point using reference point
CALL            0 5 1      ;CALL function
SHP[rp1]        4          ;SHift Point using reference point
                           #--- NPUSHB    10 9 10 3 7 12 2 12 12 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    12 0 12 13 12 12 0 6 6 12 4 7 7 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   7 12 6 14 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       14         ;Move Direct Absolute Point
MDRP[rp0,min,white] 6          ;Move Direct Relative Point
MIRP[rp0,min,white] ecstemw 7  ;Move Indirect Relative Point
SHPIX           -6 7       ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
ALIGNRP         4          ;ALIGN to Reference Point
MIRP[min,black] ecstemw 6  ;Move Indirect Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 12 ;Move Indirect Relative Point
SRP1            13         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 12 ;Move Indirect Relative Point
SHP[rp2]        2          ;SHift Point using reference point
SRP1            12         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              3          ;Interpolate Point
IP              10         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_5   3 8 11 1 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              11         ;Interpolate Point
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'N': """
                           #--- NPUSHB    8 4 1 5 0 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        6          ;SHift Point using reference point
CALL            0 5 1      ;CALL function
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_5   2 9 12 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    12 0 9 10 9 12 0 6 6 12 7 3 3 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   3 12 6 11 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
MDRP[rp0,min,white] 6          ;Move Direct Relative Point
MIRP[rp0,min,white] ecstemw 3  ;Move Indirect Relative Point
SHPIX           -6 3       ;SHift point by a PIXel amount
MDAP[rnd]       3          ;Move Direct Absolute Point
ALIGNRP         7          ;ALIGN to Reference Point
MIRP[min,black] ecstemw 6  ;Move Indirect Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 9  ;Move Indirect Relative Point
SRP1            10         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 9  ;Move Indirect Relative Point
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_4   3 8 1 0   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              8          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'NULL': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   8 9       ;PUSH Bytes
MIRP[min,black] estemt 8   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 5 0     ;PUSH Bytes
CALL            0 5 3      ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   10        ;PUSH Bytes
MDAP[rnd]       10         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_2   6 10      ;PUSH Bytes
MIRP[min,black] estemw 6   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_2   5 10      ;PUSH Bytes
MIRP[min,black] estemw 5   ;Move Indirect Relative Point
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   3 8       ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'O': """
                           #--- NPUSHB    10 21 6 3 5 0 15 6 9 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 9      ;CALL function
MIRP[min,black] estemtc 15 ;Move Indirect Relative Point
CALL            0 5 3      ;CALL function
MIRP[min,black] estemtc 21 ;Move Indirect Relative Point
                           #--- PUSHB_4   12 32 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 12 24 12 32 0 6 6 32 18 18 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   18 32 6 25 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       25         ;Move Direct Absolute Point
MDRP[rp0,min,white] 6          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 18      ;Move Indirect Relative Point
SHPIX           -6 18      ;SHift point by a PIXel amount
MDAP[rnd]       18         ;Move Direct Absolute Point
MIRP[min,black] 32 6       ;Move Indirect Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] 32 12      ;Move Indirect Relative Point
SRP1            24         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] 32 12      ;Move Indirect Relative Point
                           #--- PUSHB_4   6 0 21 15 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            15         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'P': """
                           #--- NPUSHB    15 9 6 9 11 0 1 13 19 6 1 5 0 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 5 1      ;CALL function
MIRP[min,black] estemtc 19 ;Move Indirect Relative Point
CALL            13 1 0 11 9 ;CALL function
MIRP[min,black] estemtc 9  ;Move Indirect Relative Point
                           #--- PUSHB_5   11 10 12 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 10 20 10 12 0 5 5 32 15 15 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   15 32 5 21 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       21         ;Move Direct Absolute Point
MDRP[rp0,min,white] 5          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 15      ;Move Indirect Relative Point
SHPIX           -6 15      ;SHift point by a PIXel amount
MDAP[rnd]       15         ;Move Direct Absolute Point
MIRP[min,black] 32 5       ;Move Indirect Relative Point
SRP0            5          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 10 ;Move Indirect Relative Point
SRP1            20         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 10 ;Move Indirect Relative Point
SHP[rp2]        11         ;SHift Point using reference point
                           #--- PUSHB_3   5 19 11   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            11         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Q': """
                           #--- NPUSHB    23 47 9 47 39 0 6 13 30 6 6 5 0 14 9 0 1 0 42 6 19 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        19         ;SHift Point using reference point
MIRP[min,black] estemtc 42 ;Move Indirect Relative Point
CALL            0 1 0      ;CALL function
MIRP[min,black] estemt 14  ;Move Indirect Relative Point
CALL            0 5 6      ;CALL function
MIRP[min,black] estemtc 30 ;Move Indirect Relative Point
CALL            13 6 0 39 47 ;CALL function
MIRP[min,black] estemt 47  ;Move Indirect Relative Point
                           #--- PUSHB_4   33 32 3 3 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 3 33 52 33 32 3 9 9 32 27 27 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   27 32 9 53 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       53         ;Move Direct Absolute Point
MDRP[rp0,min,white] 9          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 27      ;Move Indirect Relative Point
SHPIX           -6 27      ;SHift point by a PIXel amount
MDAP[rnd]       27         ;Move Direct Absolute Point
MIRP[min,black] 32 9       ;Move Indirect Relative Point
SRP0            9          ;Set Reference Point 0
MDRP[rp0,min,white] 3          ;Move Direct Relative Point
MIRP[min,white] 32 33      ;Move Indirect Relative Point
SRP1            52         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
IP              3          ;Interpolate Point
SHPIX           -18 3      ;SHift point by a PIXel amount
MDAP[rnd]       3          ;Move Direct Absolute Point
MIRP[min,black] 32 33      ;Move Indirect Relative Point
                           #--- NPUSHB    17 9 27 3 33 4 30 24 39 16 36 47 12 42 17 21 14 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
IP              21         ;Interpolate Point
IP              17         ;Interpolate Point
SRP1            42         ;Set Reference Point 1
IP              12         ;Interpolate Point
SRP2            47         ;Set Reference Point 2
IP              36         ;Interpolate Point
IP              16         ;Interpolate Point
SRP1            39         ;Set Reference Point 1
IP              24         ;Interpolate Point
SRP2            30         ;Set Reference Point 2
SLOOP           4          ;Set LOOP variable
IP              33 3 27 9  ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'R': """
                           #--- NPUSHB    16 1 6 1 14 3 4 13 22 6 4 5 0 12 3 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 3      ;CALL function
SHP[rp1]        12         ;SHift Point using reference point
CALL            0 5 4      ;CALL function
MIRP[min,black] estemtc 22 ;Move Indirect Relative Point
CALL            13 4 3 14 1 ;CALL function
MIRP[min,black] estemtc 1  ;Move Indirect Relative Point
                           #--- PUSHB_5   14 2 12 3 3 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 3 2 23 2 12 3 8 8 32 18 18 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   18 32 8 24 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       24         ;Move Direct Absolute Point
MDRP[rp0,min,white] 8          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 18      ;Move Indirect Relative Point
SHPIX           -6 18      ;SHift point by a PIXel amount
MDAP[rnd]       18         ;Move Direct Absolute Point
MIRP[min,black] 32 8       ;Move Indirect Relative Point
SRP0            8          ;Set Reference Point 0
MDRP[rp0,min,white] 3          ;Move Direct Relative Point
MIRP[min,white] ecstemw 2  ;Move Indirect Relative Point
SRP1            23         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
IP              3          ;Interpolate Point
SHPIX           -18 3      ;SHift point by a PIXel amount
MDAP[rnd]       3          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 2  ;Move Indirect Relative Point
SHP[rp2]        14         ;SHift Point using reference point
                           #--- PUSHB_5   8 22 11 14 1 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            1          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
IP              11         ;Interpolate Point
SRP1            22         ;Set Reference Point 1
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'S': """
                           #--- NPUSHB    24 64 24 21 9 24 17 10 24 6 17 5 0 64 4 0 9 4 37 10 4 6 37 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 37     ;CALL function
MIRP[min,black] estemtc 4  ;Move Indirect Relative Point
CALL            10 37 4    ;CALL function
CALL            9 0 4 64   ;CALL function
CALL            0 5 17     ;CALL function
MIRP[min,black] estemtc 24 ;Move Indirect Relative Point
CALL            10 17 24   ;CALL function
CALL            9 21 24 64 ;CALL function
                           #--- NPUSHB    12 20 12 21 7 27 12 14 0 1 12 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 1 40 1 12 0 34 34 32 7 7 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   7 32 34 41 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       41         ;Move Direct Absolute Point
MDRP[rp0,min,white] 34         ;Move Direct Relative Point
MIRP[rp0,min,white] 32 7       ;Move Indirect Relative Point
SHPIX           -6 7       ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] 32 34      ;Move Indirect Relative Point
SRP0            34         ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] ecstemw 1  ;Move Indirect Relative Point
SRP1            40         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 1  ;Move Indirect Relative Point
SRP0            0          ;Set Reference Point 0
MDRP[rp0,rnd,grey] 14         ;Move Direct Relative Point
MIRP[min,black] ecstemw 27 ;Move Indirect Relative Point
SRP0            7          ;Set Reference Point 0
MDRP[rp0,rnd,grey] 21         ;Move Direct Relative Point
MIRP[min,black] ecstemw 20 ;Move Indirect Relative Point
                           #--- PUSHB_4   14 34 24 4 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            4          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
IP              34         ;Interpolate Point
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'T': """
                           #--- NPUSHB    9 5 2 6 3 5 0 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 5 3      ;CALL function
MIRP[min,black] estemtc 2  ;Move Indirect Relative Point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- NPUSHB    12 2 2 0 8 7 12 0 0 5 8 5 9 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       9          ;Move Direct Absolute Point
MDRP[min,rnd,white] 5          ;Move Direct Relative Point
SRP1            8          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
IP              0          ;Interpolate Point
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 7  ;Move Indirect Relative Point
SRP1            8          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
IP              2          ;Interpolate Point
MDAP[rnd]       2          ;Move Direct Absolute Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'U': """
                           #--- NPUSHB    9 0 9 5 0 14 6 5 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 5      ;CALL function
MIRP[min,black] estemtc 14 ;Move Indirect Relative Point
CALL            0 5 9      ;CALL function
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_4   11 12 8 8 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 8 11 18 11 12 8 2 2 12 17 17 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   17 12 2 19 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       19         ;Move Direct Absolute Point
MDRP[rp0,min,white] 2          ;Move Direct Relative Point
MIRP[rp0,min,white] ecstemw 17 ;Move Indirect Relative Point
SHPIX           -6 17      ;SHift point by a PIXel amount
MDAP[rnd]       17         ;Move Direct Absolute Point
MIRP[min,black] ecstemw 2  ;Move Indirect Relative Point
SRP0            2          ;Set Reference Point 0
MDRP[rp0,min,white] 8          ;Move Direct Relative Point
MIRP[min,white] ecstemw 11 ;Move Indirect Relative Point
SRP1            18         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
IP              8          ;Interpolate Point
SHPIX           -18 8      ;SHift point by a PIXel amount
MDAP[rnd]       8          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 11 ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'V': """
                           #--- PUSHB_7   4 1 5 0 0 1 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 5 1      ;CALL function
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_4   2 32 1 1  ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 1 2 7 2 32 1 5 5 32 4 4 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   4 32 5 8  ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
MDRP[rp0,min,white] 5          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 4       ;Move Indirect Relative Point
SHPIX           -6 4       ;SHift point by a PIXel amount
MDAP[rnd]       4          ;Move Direct Absolute Point
MIRP[min,black] 32 5       ;Move Indirect Relative Point
SRP0            5          ;Set Reference Point 0
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[min,white] 32 2       ;Move Indirect Relative Point
SRP1            7          ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
IP              1          ;Interpolate Point
SHPIX           -18 1      ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] 32 2       ;Move Indirect Relative Point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'W': """
                           #--- NPUSHB    11 4 5 7 1 5 0 10 12 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        12         ;SHift Point using reference point
SHP[rp1]        10         ;SHift Point using reference point
CALL            0 5 1      ;CALL function
SHP[rp1]        7          ;SHift Point using reference point
SHP[rp1]        5          ;SHift Point using reference point
SHP[rp1]        4          ;SHift Point using reference point
                           #--- NPUSHB    16 0 12 11 10 9 6 5 4 3 9 7 2 2 32 1 1 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 1 2 13 2 32 1 8 8 32 7 7 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   7 32 8 14 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       14         ;Move Direct Absolute Point
MDRP[rp0,min,white] 8          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 7       ;Move Indirect Relative Point
SHPIX           -6 7       ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] 32 8       ;Move Indirect Relative Point
SRP0            8          ;Set Reference Point 0
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[min,white] 32 2       ;Move Indirect Relative Point
SRP1            13         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
IP              1          ;Interpolate Point
SHPIX           -18 1      ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] 32 2       ;Move Indirect Relative Point
SRP1            2          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
SLOOP           9          ;Set LOOP variable
IP              3 4 5 6 9 10 11 12 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'X': """
                           #--- NPUSHB    8 9 6 5 0 0 4 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 4      ;CALL function
SHP[rp1]        0          ;SHift Point using reference point
CALL            0 5 6      ;CALL function
SHP[rp1]        9          ;SHift Point using reference point
                           #--- PUSHB_4   3 32 4 4  ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 4 3 12 3 32 4 0 0 32 1 1 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   1 32 0 13 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       13         ;Move Direct Absolute Point
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 1       ;Move Indirect Relative Point
SHPIX           -6 1       ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] 32 0       ;Move Indirect Relative Point
SRP0            0          ;Set Reference Point 0
MDRP[rp0,min,white] 4          ;Move Direct Relative Point
MIRP[min,white] 32 3       ;Move Indirect Relative Point
SRP1            12         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              4          ;Interpolate Point
SHPIX           -18 4      ;SHift point by a PIXel amount
MDAP[rnd]       4          ;Move Direct Absolute Point
MIRP[min,black] 32 3       ;Move Indirect Relative Point
                           #--- PUSHB_4   2 8 6 4   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            4          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
IP              8          ;Interpolate Point
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Y': """
                           #--- PUSHB_7   5 2 5 0 0 1 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 5 2      ;CALL function
SHP[rp1]        5          ;SHift Point using reference point
                           #--- NPUSHB    10 8 12 0 0 5 2 3 32 2 2 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 2 3 9 3 32 2 6 6 32 5 5 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   5 32 6 10 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       10         ;Move Direct Absolute Point
MDRP[rp0,min,white] 6          ;Move Direct Relative Point
MIRP[rp0,min,white] 32 5       ;Move Indirect Relative Point
SHPIX           -6 5       ;SHift point by a PIXel amount
MDAP[rnd]       5          ;Move Direct Absolute Point
MIRP[min,black] 32 6       ;Move Indirect Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[rp0,min,white] 2          ;Move Direct Relative Point
MIRP[min,white] 32 3       ;Move Indirect Relative Point
SRP1            9          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              2          ;Interpolate Point
SHPIX           -18 2      ;SHift point by a PIXel amount
MDAP[rnd]       2          ;Move Direct Absolute Point
MIRP[min,black] 32 3       ;Move Indirect Relative Point
SRP1            2          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
IP              0          ;Interpolate Point
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] ecstemw 8  ;Move Indirect Relative Point
                           #--- PUSHB_3   4 2 0     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'Z': """
                           #--- NPUSHB    10 3 6 4 5 0 7 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemtc 7  ;Move Indirect Relative Point
CALL            0 5 4      ;CALL function
MIRP[min,black] estemtc 3  ;Move Indirect Relative Point
                           #--- NPUSHB    8 9 6 3 1 7 32 1 1 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 1 7 10 7 32 1 6 6 31 2 2 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   2 31 6 11 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
MDRP[rp0,min,white] 6          ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 2  ;Move Indirect Relative Point
SHPIX           -6 2       ;SHift point by a PIXel amount
MDAP[rnd]       2          ;Move Direct Absolute Point
MIRP[min,black] estemwc 6  ;Move Indirect Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[min,white] 32 7       ;Move Indirect Relative Point
SRP1            10         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              1          ;Interpolate Point
SHPIX           -18 1      ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] 32 7       ;Move Indirect Relative Point
SRP0            1          ;Set Reference Point 0
MDRP[grey]      3          ;Move Direct Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[grey]      9          ;Move Direct Relative Point
                           #--- PUSHB_4   1 6 3 7   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            7          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              6          ;Interpolate Point
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'a': """
                           #--- NPUSHB    20 16 9 16 34 7 27 13 20 9 27 3 0 43 9 7 1 0 1 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 1      ;CALL function
CALL            0 1 7      ;CALL function
MIRP[min,black] estemt 43  ;Move Indirect Relative Point
CALL            0 3 27     ;CALL function
MIRP[min,black] estemt 20  ;Move Indirect Relative Point
CALL            13 27 7 34 16 ;CALL function
MIRP[min,black] estemt 16  ;Move Indirect Relative Point
                           #--- NPUSHB    8 23 10 24 10 40 31 10 10 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    12 10 40 47 40 31 10 31 31 10 16 46 46 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   46 10 31 48 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       48         ;Move Direct Absolute Point
MDRP[rp0,min,white] 31         ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 46  ;Move Indirect Relative Point
SHPIX           -6 46      ;SHift point by a PIXel amount
MDAP[rnd]       46         ;Move Direct Absolute Point
ALIGNRP         16         ;ALIGN to Reference Point
MIRP[min,black] estemw 31  ;Move Indirect Relative Point
SRP0            31         ;Set Reference Point 0
MDRP[rp0,min,white] 10         ;Move Direct Relative Point
MIRP[min,white] estemwc 40 ;Move Indirect Relative Point
SRP1            47         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
IP              10         ;Interpolate Point
SHPIX           -18 10     ;SHift point by a PIXel amount
MDAP[rnd]       10         ;Move Direct Absolute Point
MIRP[min,black] estemwc 40 ;Move Indirect Relative Point
SRP0            10         ;Set Reference Point 0
MDRP[rp0,rnd,grey] 24         ;Move Direct Relative Point
MIRP[min,black] estemw 23  ;Move Indirect Relative Point
                           #--- PUSHB_4   13 14 36 37 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[no-rnd]    37         ;Move Direct Absolute Point
MDAP[no-rnd]    36         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
                           #--- PUSHB_5   64 13 14 36 37 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[no-rnd]    37         ;Move Direct Absolute Point
MDAP[no-rnd]    36         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
SMD             64         ;Set Minimum Distance
                           #--- NPUSHB    10 1 31 4 7 23 27 46 24 40 10 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            10         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
IP              24         ;Interpolate Point
SRP1            46         ;Set Reference Point 1
IP              27         ;Interpolate Point
IP              23         ;Interpolate Point
IP              7          ;Interpolate Point
SRP1            4          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
IP              1          ;Interpolate Point
                           #--- NPUSHB    11 23 24 30 20 16 31 10 34 4 43 1 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            1          ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
IP              4          ;Interpolate Point
SRP1            34         ;Set Reference Point 1
IP              10         ;Interpolate Point
IP              31         ;Interpolate Point
SRP1            16         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
IP              30         ;Interpolate Point
IP              24         ;Interpolate Point
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'acute': """
                           #--- PUSHB_6   2 6 0 11 4 1 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
CALL            4 11 0 6 2 ;CALL function
                           #--- NPUSHB    9 5 1 3 12 0 10 4 1 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
CALL            4 10 0 12 3 ;CALL function
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii00208': """
                           #--- NPUSHB    11 2 8 0 64 4 2 8 0 64 4 1 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
CALL            4 64 0 8 2 ;CALL function
CALL            4 64 0 8 2 ;CALL function
                           #--- PUSHB_3   5 1 4     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii299': """
                           #--- NPUSHB    15 64 4 6 9 4 7 10 7 7 0 24 4 4 4 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 4 4      ;CALL function
CALL            4 24 0 7 7 ;CALL function
CALL            10 7 4     ;CALL function
CALL            9 6 4 64   ;CALL function
                           #--- PUSHB_7   5 10 0 13 4 6 11 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
CALL            4 13 0 10 5 ;CALL function
                           #--- PUSHB_3   0 7 4     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            4          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii300': """
                           #--- NPUSHB    15 64 3 1 9 3 9 10 9 7 0 24 4 3 4 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 4 3      ;CALL function
CALL            4 24 0 7 9 ;CALL function
CALL            10 9 3     ;CALL function
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_7   0 10 0 13 4 1 11 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
CALL            4 13 0 10 0 ;CALL function
                           #--- PUSHB_3   6 9 3     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            3          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'afii61664': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    12 1 10 0 13 4 1 10 0 13 4 2 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
CALL            4 13 0 10 1 ;CALL function
CALL            4 13 0 10 1 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ampersand': """
                           #--- NPUSHB    10 39 9 11 5 0 44 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemtc 44 ;Move Indirect Relative Point
CALL            0 5 11     ;CALL function
MIRP[min,black] estemt 39  ;Move Indirect Relative Point
                           #--- NPUSHB    31 17 31 47 14 0 11 16 44 48 5 36 6 42 51 55 1 14 10 36 1 51 42 10 8 51 3 8 51 10 3 54 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       54         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
MIRP[min,black] estemw 51  ;Move Indirect Relative Point
CALL            8 3 51 8   ;CALL function
MIRP[min,black] estemw 42  ;Move Indirect Relative Point
SRP0            51         ;Set Reference Point 0
CALL            1 36       ;CALL function
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
CALL            1 55       ;CALL function
SRP1            51         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
IP              6          ;Interpolate Point
SRP1            36         ;Set Reference Point 1
SLOOP           5          ;Set LOOP variable
IP              48 44 16 11 0 ;Interpolate Point
SRP2            14         ;Set Reference Point 2
IP              47         ;Interpolate Point
IP              31         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- NPUSHB    12 3 8 14 24 34 48 6 39 27 31 44 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
IP              31         ;Interpolate Point
IP              27         ;Interpolate Point
SRP1            39         ;Set Reference Point 1
SLOOP           6          ;Set LOOP variable
IP              48 34 24 14 8 3 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'asciicircum': """
                           #--- NPUSHB    10 1 9 0 0 0 1 9 0 0 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 0      ;CALL function
MIRP[min,black] estemt 1   ;Move Indirect Relative Point
CALL            0 0 0      ;CALL function
MIRP[min,black] estemt 1   ;Move Indirect Relative Point
                           #--- PUSHB_3   5 1 4     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'asciitilde': """
                           #--- NPUSHB    11 0 16 6 9 4 21 8 12 4 6 21 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       21         ;Move Direct Absolute Point
MIRP[min,black] estemtc 4  ;Move Indirect Relative Point
SHP[rp2]        12         ;SHift Point using reference point
CALL            8 21 4 9   ;CALL function
MIRP[min,black] estemtc 16 ;Move Indirect Relative Point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   25 1 24   ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       24         ;Move Direct Absolute Point
CALL            1 25       ;CALL function
                           #--- PUSHB_6   1 4 9 13 21 16 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            16         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
IP              13         ;Interpolate Point
SRP1            9          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
IP              1          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'asterisk': """
                           #--- NPUSHB    8 24 12 9 0 33 4 26 11 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
SHP[rp1]        26         ;SHift Point using reference point
CALL            4 33 0 9 12 ;CALL function
SHP[rp2]        24         ;SHift Point using reference point
                           #--- NPUSHB    12 2 20 17 34 1 20 10 0 22 4 17 33 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       33         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
CALL            4 22 0 10 20 ;CALL function
CALL            1 34       ;CALL function
SRP1            17         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
IP              2          ;Interpolate Point
                           #--- PUSHB_4   15 22 12 11 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            11         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
IP              22         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'at': """
                           #--- NPUSHB    28 64 30 34 9 30 37 10 30 6 37 57 6 12 8 3 0 24 6 43 5 0 18 51 6 49 2 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 2      ;CALL function
SHP[rp1]        49         ;SHift Point using reference point
MIRP[min,black] estemtc 51 ;Move Indirect Relative Point
SHP[rp2]        18         ;SHift Point using reference point
CALL            0 5 43     ;CALL function
MIRP[min,black] estemtc 24 ;Move Indirect Relative Point
CALL            0 3 8      ;CALL function
SHP[rp1]        12         ;SHift Point using reference point
MIRP[min,black] estemtc 57 ;Move Indirect Relative Point
MDAP[rnd]       37         ;Move Direct Absolute Point
MIRP[min,black] estemtc 30 ;Move Indirect Relative Point
CALL            10 37 30   ;CALL function
CALL            9 34 30 64 ;CALL function
                           #--- NPUSHB    42 33 46 13 21 12 11 49 16 0 2 24 30 37 43 8 7 54 60 64 1 46 10 21 1 16 16 10 0 22 4 54 1 60 60 10 5 1 27 27 10 40 63 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       63         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 40         ;Move Direct Relative Point
MIRP[min,black] estemw 27  ;Move Indirect Relative Point
SRP0            27         ;Set Reference Point 0
CALL            1 5        ;CALL function
MIRP[min,black] estemw 60  ;Move Indirect Relative Point
SRP0            60         ;Set Reference Point 0
CALL            1 54       ;CALL function
CALL            4 22 0 10 16 ;CALL function
SRP0            16         ;Set Reference Point 0
CALL            1 21       ;CALL function
MIRP[min,black] estemw 46  ;Move Indirect Relative Point
CALL            1 64       ;CALL function
SRP1            60         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
SLOOP           7          ;Set LOOP variable
IP              8 43 37 30 24 2 0 ;Interpolate Point
SRP1            16         ;Set Reference Point 1
IP              49         ;Interpolate Point
IP              11         ;Interpolate Point
IP              12         ;Interpolate Point
SRP2            21         ;Set Reference Point 2
IP              13         ;Interpolate Point
SRP1            46         ;Set Reference Point 1
IP              33         ;Interpolate Point
                           #--- NPUSHB    13 11 8 16 5 21 27 40 46 6 57 0 51 2 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            2          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
IP              0          ;Interpolate Point
SRP1            57         ;Set Reference Point 1
SLOOP           6          ;Set LOOP variable
IP              46 40 27 21 5 16 ;Interpolate Point
SRP2            8          ;Set Reference Point 2
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'b': """
                           #--- NPUSHB    16 26 6 7 3 0 2 5 0 20 6 13 1 0 1 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 1      ;CALL function
CALL            0 1 13     ;CALL function
MIRP[min,black] estemtc 20 ;Move Indirect Relative Point
CALL            0 5 2      ;CALL function
CALL            0 3 7      ;CALL function
MIRP[min,black] estemtc 26 ;Move Indirect Relative Point
                           #--- PUSHB_6   16 17 4 10 1 1 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 1 4 29 4 10 1 10 10 31 23 23 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   23 31 10 30 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       30         ;Move Direct Absolute Point
MDRP[rp0,min,white] 10         ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 23 ;Move Indirect Relative Point
SHPIX           -6 23      ;SHift point by a PIXel amount
MDAP[rnd]       23         ;Move Direct Absolute Point
MIRP[min,black] estemwc 10 ;Move Indirect Relative Point
SRP0            10         ;Set Reference Point 0
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[min,white] estemw 4   ;Move Indirect Relative Point
SRP1            29         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
IP              1          ;Interpolate Point
SHPIX           -18 1      ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] estemw 4   ;Move Indirect Relative Point
SHP[rp2]        17         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
                           #--- NPUSHB    8 4 7 10 17 26 16 20 1 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            1          ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
IP              16         ;Interpolate Point
SRP1            26         ;Set Reference Point 1
IP              17         ;Interpolate Point
IP              10         ;Interpolate Point
SRP2            7          ;Set Reference Point 2
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'backslash': """
                           #--- PUSHB_4   3 0 1 0   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        3          ;SHift Point using reference point
                           #--- NPUSHB    19 1 2 1 0 15 2 3 2 3 54 5 1 3 12 0 7 4 1 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
CALL            4 7 0 12 3 ;CALL function
CALL            1 5        ;CALL function
SMD             54         ;Set Minimum Distance
SDPVTL[orthog]  3 2        ;Set Dual Projection Vector To Line
SRP0            3          ;Set Reference Point 0
MDRP[grey]      2          ;Move Direct Relative Point
MIRP[rp0,min,black] cvt_15 0   ;Move Indirect Relative Point
SFVTCA[y-axis]             ;Set Freedom Vector To Coordinate Axis
MDRP[grey]      1          ;Move Direct Relative Point
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
MDAP[no-rnd]    2          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
                           #--- PUSHB_3   64 0 2    ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[no-rnd]    2          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bar': """
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 0      ;CALL function
                           #--- NPUSHB    8 5 1 3 10 3 10 0 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
MIRP[min,black] estemw 3   ;Move Indirect Relative Point
MIRP[min,black] estemw 3   ;Move Indirect Relative Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'braceleft': """
                           #--- NPUSHB    14 16 9 19 9 8 0 50 4 8 33 9 1 0 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 1      ;CALL function
MIRP[min,black] estemt 33  ;Move Indirect Relative Point
MDAP[rnd]       8          ;Move Direct Absolute Point
CALL            4 50 0 8 9 ;CALL function
MDAP[rnd]       19         ;Move Direct Absolute Point
MIRP[min,black] estemt 16  ;Move Indirect Relative Point
                           #--- NPUSHB    19 26 30 4 36 1 17 64 30 0 9 30 4 10 22 30 10 12 4 35 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       35         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
SHP[rp2]        12         ;SHift Point using reference point
MIRP[min,black] estemw 30  ;Move Indirect Relative Point
SHP[rp2]        22         ;SHift Point using reference point
CALL            10 4 30    ;CALL function
CALL            9 0 30 64  ;CALL function
SHP[rp2]        17         ;SHift Point using reference point
CALL            1 36       ;CALL function
SRP1            4          ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
IP              26         ;Interpolate Point
                           #--- NPUSHB    9 13 24 19 26 9 4 29 8 33 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            33         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
IP              29         ;Interpolate Point
IP              4          ;Interpolate Point
SRP1            9          ;Set Reference Point 1
IP              26         ;Interpolate Point
SRP2            19         ;Set Reference Point 2
IP              24         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'braceright': """
                           #--- NPUSHB    14 18 9 17 26 8 0 50 4 27 1 9 0 0 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 0      ;CALL function
MIRP[min,black] estemt 1   ;Move Indirect Relative Point
MDAP[rnd]       27         ;Move Direct Absolute Point
CALL            4 50 0 8 26 ;CALL function
MDAP[rnd]       17         ;Move Direct Absolute Point
MIRP[min,black] estemt 18  ;Move Indirect Relative Point
                           #--- NPUSHB    19 9 31 5 36 1 17 64 5 0 9 5 31 10 22 31 10 12 5 35 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       35         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
SHP[rp2]        12         ;SHift Point using reference point
MIRP[min,black] estemw 31  ;Move Indirect Relative Point
SHP[rp2]        22         ;SHift Point using reference point
CALL            10 31 5    ;CALL function
CALL            9 0 5 64   ;CALL function
SHP[rp2]        17         ;SHift Point using reference point
CALL            1 36       ;CALL function
SRP1            5          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
IP              9          ;Interpolate Point
                           #--- NPUSHB    9 12 22 17 9 26 7 31 27 1 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            1          ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
IP              31         ;Interpolate Point
IP              7          ;Interpolate Point
SRP1            26         ;Set Reference Point 1
IP              9          ;Interpolate Point
SRP2            17         ;Set Reference Point 2
IP              22         ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bracketleft': """
                           #--- NPUSHB    8 5 9 7 4 9 2 5 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 5 2      ;CALL function
MIRP[min,black] estemt 4   ;Move Indirect Relative Point
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] estemt 5   ;Move Indirect Relative Point
                           #--- NPUSHB    18 9 1 3 7 12 0 11 4 5 10 2 7 12 0 11 4 0 8 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
CALL            4 11 0 12 7 ;CALL function
SHP[rp2]        2          ;SHift Point using reference point
MIRP[min,black] estemw 5   ;Move Indirect Relative Point
CALL            4 11 0 12 7 ;CALL function
SHP[rp2]        3          ;SHift Point using reference point
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bracketright': """
                           #--- NPUSHB    8 2 9 1 5 9 6 5 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 5 6      ;CALL function
MIRP[min,black] estemt 5   ;Move Indirect Relative Point
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] estemt 2   ;Move Indirect Relative Point
                           #--- NPUSHB    21 9 1 5 5 12 0 11 4 0 3 3 10 0 0 12 0 11 4 5 1 8 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
SHP[rp2]        5          ;SHift Point using reference point
CALL            4 11 0 12 0 ;CALL function
SRP0            0          ;Set Reference Point 0
MIRP[min,black] estemw 3   ;Move Indirect Relative Point
MDAP[rnd]       3          ;Move Direct Absolute Point
SRP0            0          ;Set Reference Point 0
CALL            4 11 0 12 5 ;CALL function
MDAP[rnd]       5          ;Move Direct Absolute Point
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'brokenbar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    16 9 1 4 10 0 22 4 0 4 10 0 22 4 1 5 8 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
SHP[rp2]        1          ;SHift Point using reference point
CALL            4 22 0 10 4 ;CALL function
SHP[rp2]        0          ;SHift Point using reference point
CALL            4 22 0 10 4 ;CALL function
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'bullet': """
                           #--- NPUSHB    11 8 6 0 7 4 8 6 0 7 4 4 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            4 7 0 6 8  ;CALL function
CALL            4 7 0 6 8  ;CALL function
                           #--- NPUSHB    14 12 1 0 12 0 7 4 0 12 0 7 4 6 11 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
CALL            4 7 0 12 0 ;CALL function
CALL            4 7 0 12 0 ;CALL function
CALL            1 12       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'c': """
                           #--- NPUSHB    24 64 17 13 9 17 10 10 17 6 10 3 0 64 23 1 9 23 4 10 23 6 4 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 4      ;CALL function
MIRP[min,black] estemtc 23 ;Move Indirect Relative Point
CALL            10 4 23    ;CALL function
CALL            9 1 23 64  ;CALL function
CALL            0 3 10     ;CALL function
MIRP[min,black] estemtc 17 ;Move Indirect Relative Point
CALL            10 10 17   ;CALL function
CALL            9 13 17 64 ;CALL function
                           #--- PUSHB_4   20 31 7 7 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    13 7 20 26 20 31 7 1 13 1 6 14 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   0 6 1 27  ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       27         ;Move Direct Absolute Point
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[rp0,min,white] estemtc 0  ;Move Indirect Relative Point
SHPIX           -6 0       ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
ALIGNRP         14         ;ALIGN to Reference Point
MIRP[min,black] estemtc 1  ;Move Indirect Relative Point
SHP[rp2]        13         ;SHift Point using reference point
SRP0            1          ;Set Reference Point 0
MDRP[rp0,min,white] 7          ;Move Direct Relative Point
MIRP[min,white] estemwc 20 ;Move Indirect Relative Point
SRP1            26         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
IP              7          ;Interpolate Point
SHPIX           -18 7      ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] estemwc 20 ;Move Indirect Relative Point
                           #--- PUSHB_3   7 17 23   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            23         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'cedilla': """
                           #--- NPUSHB    11 10 8 0 64 4 9 14 8 6 0 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 6      ;CALL function
MIRP[min,black] cvt_8 14   ;Move Indirect Relative Point
DUP             9          ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 64 0 8 10 ;CALL function
                           #--- NPUSHB    9 22 1 3 10 0 22 4 17 21 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       21         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 17         ;Move Direct Relative Point
CALL            4 22 0 10 3 ;CALL function
CALL            1 22       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'cent': """
                           #--- NPUSHB    26 11 8 8 19 8 30 1 9 13 9 5 0 64 28 1 9 28 20 10 29 20 8 2 28 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 28     ;CALL function
SHP[rp1]        2          ;SHift Point using reference point
MIRP[min,black] cvt_8 20   ;Move Indirect Relative Point
SHP[rp2]        29         ;SHift Point using reference point
CALL            10 20 28   ;CALL function
CALL            9 1 28 64  ;CALL function
CALL            0 5 9      ;CALL function
CALL            13 9 1 30 8 ;CALL function
SHP[rp1]        19         ;SHift Point using reference point
MIRP[min,black] cvt_8 8    ;Move Indirect Relative Point
SHP[rp2]        11         ;SHift Point using reference point
                           #--- NPUSHB    29 37 1 14 64 0 25 9 0 1 10 10 19 0 10 0 13 4 8 29 1 1 33 33 10 0 30 4 5 36 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       36         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
CALL            4 30 0 10 33 ;CALL function
SRP0            33         ;Set Reference Point 0
CALL            1 1        ;CALL function
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        8          ;SHift Point using reference point
CALL            4 13 0 10 0 ;CALL function
SHP[rp2]        19         ;SHift Point using reference point
SHP[rp2]        10         ;SHift Point using reference point
CALL            10 1 0     ;CALL function
CALL            9 25 0 64  ;CALL function
SHP[rp2]        14         ;SHift Point using reference point
CALL            1 37       ;CALL function
                           #--- NPUSHB    12 14 8 5 16 15 23 24 5 30 25 20 28 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            28         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
IP              25         ;Interpolate Point
SRP1            30         ;Set Reference Point 1
SLOOP           5          ;Set LOOP variable
IP              24 23 15 16 5 ;Interpolate Point
SRP2            8          ;Set Reference Point 2
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'colon': """
                           #--- NPUSHB    10 0 6 1 3 0 5 6 4 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 4      ;CALL function
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
CALL            0 3 1      ;CALL function
MIRP[min,black] estemtc 0  ;Move Indirect Relative Point
                           #--- NPUSHB    10 9 1 7 12 2 7 12 0 4 8 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
SHP[rp2]        0          ;SHift Point using reference point
MIRP[min,black] ecstemw 7  ;Move Indirect Relative Point
SHP[rp2]        2          ;SHift Point using reference point
MIRP[min,black] ecstemw 7  ;Move Indirect Relative Point
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'comma': """
                           #--- NPUSHB    8 1 6 0 41 4 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            4 41 0 6 1 ;CALL function
                           #--- NPUSHB    19 6 3 10 12 1 10 10 10 0 22 4 3 3 12 0 21 4 0 11 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
CALL            4 21 0 12 3 ;CALL function
SRP0            3          ;Set Reference Point 0
CALL            4 22 0 10 10 ;CALL function
MDAP[rnd]       10         ;Move Direct Absolute Point
CALL            1 12       ;CALL function
SRP1            10         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'copyright': """
                           #--- NPUSHB    37 9 7 0 56 4 15 51 9 0 33 4 24 47 27 8 47 8 27 21 7 0 56 4 3 37 9 0 33 4 36 3 0 41 8 33 4 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 4 33     ;CALL function
MIRP[min,black] cvt_8 41   ;Move Indirect Relative Point
CALL            0 3 36     ;CALL function
CALL            4 33 0 9 37 ;CALL function
MDAP[rnd]       3          ;Move Direct Absolute Point
CALL            4 56 0 7 21 ;CALL function
MDAP[rnd]       27         ;Move Direct Absolute Point
MIRP[min,black] cvt_8 47   ;Move Indirect Relative Point
CALL            8 27 47 24 ;CALL function
CALL            4 33 0 9 51 ;CALL function
MDAP[rnd]       15         ;Move Direct Absolute Point
CALL            4 56 0 7 9 ;CALL function
                           #--- NPUSHB    36 9 3 15 21 24 27 33 36 8 12 44 53 1 0 10 0 13 4 12 1 44 44 10 0 22 4 30 1 18 18 10 0 13 4 6 52 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       52         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
CALL            4 13 0 10 18 ;CALL function
SRP0            18         ;Set Reference Point 0
CALL            1 30       ;CALL function
CALL            4 22 0 10 44 ;CALL function
SRP0            44         ;Set Reference Point 0
CALL            1 12       ;CALL function
CALL            4 13 0 10 0 ;CALL function
CALL            1 53       ;CALL function
SRP1            44         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
SLOOP           8          ;Set LOOP variable
IP              36 33 27 24 21 15 3 9 ;Interpolate Point
                           #--- NPUSHB    9 6 12 18 0 30 44 6 37 51 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            51         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
SLOOP           6          ;Set LOOP variable
IP              44 30 0 18 12 6 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'currency': """
                           #--- NPUSHB    10 18 8 42 36 8 0 22 14 4 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 4 14     ;CALL function
SHP[rp1]        22         ;SHift Point using reference point
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] cvt_8 36   ;Move Indirect Relative Point
MDAP[rnd]       42         ;Move Direct Absolute Point
MIRP[min,black] cvt_8 18   ;Move Indirect Relative Point
                           #--- NPUSHB    30 24 30 27 3 15 21 33 4 39 6 12 45 9 49 1 27 10 0 13 4 39 1 45 45 10 0 13 4 9 48 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       48         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
CALL            4 13 0 10 45 ;CALL function
SRP0            45         ;Set Reference Point 0
CALL            1 39       ;CALL function
CALL            4 13 0 10 27 ;CALL function
CALL            1 49       ;CALL function
SRP1            9          ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
IP              12         ;Interpolate Point
IP              6          ;Interpolate Point
SRP1            39         ;Set Reference Point 1
SLOOP           4          ;Set LOOP variable
IP              33 21 15 3 ;Interpolate Point
SRP2            27         ;Set Reference Point 2
IP              30         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- NPUSHB    16 13 23 14 15 21 18 6 12 24 30 4 42 3 33 36 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
IP              33         ;Interpolate Point
IP              3          ;Interpolate Point
SRP1            42         ;Set Reference Point 1
SLOOP           4          ;Set LOOP variable
IP              30 24 12 6 ;Interpolate Point
SRP2            18         ;Set Reference Point 2
IP              21         ;Interpolate Point
IP              15         ;Interpolate Point
SRP1            14         ;Set Reference Point 1
IP              23         ;Interpolate Point
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'd': """
                           #--- NPUSHB    16 20 6 10 3 0 14 5 0 26 6 4 1 0 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 1 4      ;CALL function
MIRP[min,black] estemtc 26 ;Move Indirect Relative Point
CALL            0 5 14     ;CALL function
CALL            0 3 10     ;CALL function
MIRP[min,black] estemtc 20 ;Move Indirect Relative Point
                           #--- PUSHB_4   23 31 7 7 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    13 7 23 29 23 31 7 16 16 10 1 17 13 13 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   13 10 16 30 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       30         ;Move Direct Absolute Point
MDRP[rp0,min,white] 16         ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 13  ;Move Indirect Relative Point
SHPIX           -6 13      ;SHift point by a PIXel amount
MDAP[rnd]       13         ;Move Direct Absolute Point
ALIGNRP         17         ;ALIGN to Reference Point
ALIGNRP         1          ;ALIGN to Reference Point
MIRP[min,black] estemw 16  ;Move Indirect Relative Point
SRP0            16         ;Set Reference Point 0
MDRP[rp0,min,white] 7          ;Move Direct Relative Point
MIRP[min,white] estemwc 23 ;Move Indirect Relative Point
SRP1            29         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
IP              7          ;Interpolate Point
SHPIX           -18 7      ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] estemwc 23 ;Move Indirect Relative Point
                           #--- NPUSHB    8 13 10 7 17 20 1 26 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
IP              1          ;Interpolate Point
SRP1            20         ;Set Reference Point 1
IP              17         ;Interpolate Point
IP              7          ;Interpolate Point
SRP2            10         ;Set Reference Point 2
IP              13         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dagger': """
                           #--- PUSHB_7   0 5 7 10 6 4 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 4 6      ;CALL function
SHP[rp1]        10         ;SHift Point using reference point
MIRP[min,black] cvt_7 5    ;Move Indirect Relative Point
SHP[rp2]        0          ;SHift Point using reference point
                           #--- NPUSHB    11 13 1 9 2 10 0 13 4 7 3 12 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       12         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
SHP[rp2]        7          ;SHift Point using reference point
CALL            4 13 0 10 2 ;CALL function
SHP[rp2]        9          ;SHift Point using reference point
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'daggerdbl': """
                           #--- NPUSHB    10 14 11 7 16 8 18 6 7 0 5 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       5          ;Move Direct Absolute Point
SHP[rp1]        0          ;SHift Point using reference point
MIRP[min,black] cvt_7 6    ;Move Indirect Relative Point
SHP[rp2]        18         ;SHift Point using reference point
MDAP[rnd]       8          ;Move Direct Absolute Point
SHP[rp1]        16         ;SHift Point using reference point
MIRP[min,black] cvt_7 11   ;Move Indirect Relative Point
SHP[rp2]        14         ;SHift Point using reference point
                           #--- NPUSHB    13 21 1 13 17 1 10 0 13 4 7 11 4 20 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       20         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
SHP[rp2]        11         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
CALL            4 13 0 10 1 ;CALL function
SHP[rp2]        17         ;SHift Point using reference point
SHP[rp2]        13         ;SHift Point using reference point
CALL            1 21       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'degree': """
                           #--- NPUSHB    8 6 8 18 0 8 12 2 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 2 12     ;CALL function
MIRP[min,black] cvt_8 0    ;Move Indirect Relative Point
MDAP[rnd]       18         ;Move Direct Absolute Point
MIRP[min,black] cvt_8 6    ;Move Indirect Relative Point
                           #--- NPUSHB    21 6 0 15 21 25 1 9 10 0 13 4 15 1 21 21 10 0 13 4 3 24 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       24         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
CALL            4 13 0 10 21 ;CALL function
SRP0            21         ;Set Reference Point 0
CALL            1 15       ;CALL function
CALL            4 13 0 10 9 ;CALL function
CALL            1 25       ;CALL function
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_4   9 3 18 12 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'desc.uni0E0D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   11 8 0 66 4 ;PUSH Bytes
CALL            4 66 0 8 11 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   6 7 0 71 4 ;PUSH Bytes
CALL            4 71 0 7 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   27 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   9 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 9 ;CALL function
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   21 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   0 11      ;PUSH Bytes
IP              11         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_4   9 3 21 27 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 21 3 9  ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   14 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'desc.uni0E10': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 3       ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   51 7      ;PUSH Bytes
MIRP[min,black] cvt_7 51   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp1]        27         ;SHift Point using reference point
                           #--- PUSHB_2   14 7      ;PUSH Bytes
MIRP[min,black] cvt_7 14   ;Move Indirect Relative Point
                           #--- PUSHB_5   39 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 39 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_5   35 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 35 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   61        ;PUSH Bytes
MDAP[rnd]       61         ;Move Direct Absolute Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
                           #--- PUSHB_5   58 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 58 ;CALL function
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP0            58         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_5   48 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 48 ;CALL function
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP0            48         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_5   38 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 38 ;CALL function
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP0            38         ;Set Reference Point 0
                           #--- PUSHB_5   26 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   62 1      ;PUSH Bytes
CALL            1 62       ;CALL function
                           #--- PUSHB_2   32 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_6   4 8 14 21 19 53 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              53 19 21 14 8 4 ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_2   23 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_7   2 1 25 29 35 39 45 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              45 39 35 29 25 1 2 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   51 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_3   2 6 26    ;PUSH Bytes
IP              26         ;Interpolate Point
IP              6          ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   55        ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
                           #--- PUSHB_6   21 11 24 25 53 58 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              58 53 25 24 11 21 ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   19 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_2   45 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_4   32 42 18 48 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              48 18 42 32 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dieresis': """
                           #--- PUSHB_7   6 9 2 6 9 0 5 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       5          ;Move Direct Absolute Point
SHP[rp1]        0          ;SHift Point using reference point
MIRP[min,black] estemt 6   ;Move Indirect Relative Point
SHP[rp2]        2          ;SHift Point using reference point
MIRP[min,black] estemt 6   ;Move Indirect Relative Point
                           #--- NPUSHB    17 9 1 0 10 0 30 4 1 1 4 4 10 0 30 4 5 8 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
CALL            4 30 0 10 4 ;CALL function
SRP0            4          ;Set Reference Point 0
CALL            1 1        ;CALL function
CALL            4 30 0 10 0 ;CALL function
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dollar': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    46 22 23 45 50 1 23 10 0 30 4 24 31 10 0 47 4 45 1 0 19 27 42 0 10 0 30 4 10 17 35 1 1 39 7 10 0 39 4 5 39 10 0 39 4 14 49 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       49         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
CALL            4 39 0 10 39 ;CALL function
DUP             5          ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 39 0 10 7 ;CALL function
SRP0            39         ;Set Reference Point 0
CALL            1 1        ;CALL function
SHP[rp2]        35         ;SHift Point using reference point
SHP[rp2]        17         ;SHift Point using reference point
SHP[rp2]        10         ;SHift Point using reference point
CALL            4 30 0 10 0 ;CALL function
SHP[rp2]        42         ;SHift Point using reference point
SHP[rp2]        27         ;SHift Point using reference point
SHP[rp2]        19         ;SHift Point using reference point
SRP0            0          ;Set Reference Point 0
CALL            1 45       ;CALL function
CALL            4 47 0 10 31 ;CALL function
DUP             24         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 30 0 10 23 ;CALL function
CALL            1 50       ;CALL function
SRP1            45         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'dottedcircle': """
                           #--- NPUSHB    57 4 7 10 140 7 146 162 128 7 168 134 113 40 7 121 46 101 7 107 52 7 58 89 7 95 63 7 71 78 84 8 78 7 84 158 3 0 154 3 0 28 7 34 3 0 25 4 0 16 7 22 157 157 7 151 4 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 4 151    ;CALL function
MIRP[min,black] cvt_7 157  ;Move Indirect Relative Point
SRP0            157        ;Set Reference Point 0
DUP             22         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
MIRP[min,black] cvt_7 16   ;Move Indirect Relative Point
CALL            0 4 25     ;CALL function
CALL            0 3 34     ;CALL function
MIRP[min,black] cvt_7 28   ;Move Indirect Relative Point
CALL            0 3 154    ;CALL function
CALL            0 3 158    ;CALL function
MDAP[rnd]       84         ;Move Direct Absolute Point
MIRP[min,black] cvt_7 78   ;Move Indirect Relative Point
CALL            8 84 78 71 ;CALL function
MIRP[min,black] cvt_7 63   ;Move Indirect Relative Point
DUP             95         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
MIRP[min,black] cvt_7 89   ;Move Indirect Relative Point
MDAP[rnd]       58         ;Move Direct Absolute Point
MIRP[min,black] cvt_7 52   ;Move Indirect Relative Point
DUP             107        ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
MIRP[min,black] cvt_7 101  ;Move Indirect Relative Point
MDAP[rnd]       46         ;Move Direct Absolute Point
SHP[rp1]        121        ;SHift Point using reference point
MIRP[min,black] cvt_7 40   ;Move Indirect Relative Point
SHP[rp2]        113        ;SHift Point using reference point
MDAP[rnd]       134        ;Move Direct Absolute Point
SHP[rp1]        168        ;SHift Point using reference point
MIRP[min,black] cvt_7 128  ;Move Indirect Relative Point
SHP[rp2]        162        ;SHift Point using reference point
MDAP[rnd]       146        ;Move Direct Absolute Point
MIRP[min,black] cvt_7 140  ;Move Indirect Relative Point
DUP             10         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
MIRP[min,black] cvt_7 4    ;Move Indirect Relative Point
                           #--- NPUSHB    154 113 121 128 130 4 117 101 134 104 107 124 125 140 4 143 146 97 89 92 95 151 154 157 85 147 28 34 81 75 16 19 22 63 71 67 13 4 10 52 58 4 7 166 40 46 163 169 4 43 160 171 1 117 10 0 13 4 109 11 143 104 10 0 13 4 97 137 92 10 0 13 4 85 85 10 0 13 4 92 143 137 8 143 10 0 13 4 137 1 154 154 10 0 13 4 147 1 81 30 81 10 0 13 4 24 75 1 67 19 10 0 13 4 13 67 10 0 13 4 59 1 7 166 10 0 13 4 160 160 10 0 13 4 166 7 0 8 54 7 10 0 13 4 48 0 11 43 43 10 0 13 4 37 170 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       170        ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 37         ;Move Direct Relative Point
CALL            4 13 0 10 43 ;CALL function
SRP0            43         ;Set Reference Point 0
CALL            11 0       ;CALL function
SHP[rp2]        48         ;SHift Point using reference point
CALL            4 13 0 10 7 ;CALL function
SHP[rp2]        54         ;SHift Point using reference point
CALL            8 0 7 166  ;CALL function
CALL            4 13 0 10 160 ;CALL function
MDAP[rnd]       160        ;Move Direct Absolute Point
CALL            4 13 0 10 166 ;CALL function
SRP0            7          ;Set Reference Point 0
CALL            1 59       ;CALL function
CALL            4 13 0 10 67 ;CALL function
DUP             13         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 13 0 10 19 ;CALL function
SRP0            67         ;Set Reference Point 0
CALL            1 75       ;CALL function
SHP[rp2]        24         ;SHift Point using reference point
CALL            4 13 0 10 81 ;CALL function
SHP[rp2]        30         ;SHift Point using reference point
SRP0            81         ;Set Reference Point 0
CALL            1 147      ;CALL function
CALL            4 13 0 10 154 ;CALL function
SRP0            154        ;Set Reference Point 0
CALL            1 137      ;CALL function
CALL            4 13 0 10 143 ;CALL function
CALL            8 137 143 92 ;CALL function
CALL            4 13 0 10 85 ;CALL function
MDAP[rnd]       85         ;Move Direct Absolute Point
CALL            4 13 0 10 92 ;CALL function
SRP0            137        ;Set Reference Point 0
DUP             97         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 13 0 10 104 ;CALL function
SRP0            143        ;Set Reference Point 0
CALL            11 109     ;CALL function
CALL            4 13 0 10 117 ;CALL function
CALL            1 171      ;CALL function
SRP1            160        ;Set Reference Point 1
SRP2            43         ;Set Reference Point 2
SLOOP           4          ;Set LOOP variable
IP              169 163 46 40 ;Interpolate Point
SRP1            166        ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
SLOOP           4          ;Set LOOP variable
IP              58 52 10 4 ;Interpolate Point
SRP1            13         ;Set Reference Point 1
SRP2            67         ;Set Reference Point 2
IP              71         ;Interpolate Point
IP              63         ;Interpolate Point
IP              22         ;Interpolate Point
SRP1            19         ;Set Reference Point 1
IP              16         ;Interpolate Point
SRP1            75         ;Set Reference Point 1
SRP2            81         ;Set Reference Point 2
IP              34         ;Interpolate Point
IP              28         ;Interpolate Point
SRP1            147        ;Set Reference Point 1
SRP2            85         ;Set Reference Point 2
IP              157        ;Interpolate Point
SRP1            154        ;Set Reference Point 1
IP              151        ;Interpolate Point
IP              95         ;Interpolate Point
SRP2            92         ;Set Reference Point 2
IP              89         ;Interpolate Point
SRP1            97         ;Set Reference Point 1
IP              146        ;Interpolate Point
SRP2            143        ;Set Reference Point 2
SLOOP           4          ;Set LOOP variable
IP              140 125 124 107 ;Interpolate Point
SRP1            104        ;Set Reference Point 1
IP              134        ;Interpolate Point
IP              101        ;Interpolate Point
SRP2            117        ;Set Reference Point 2
SLOOP           4          ;Set LOOP variable
IP              130 128 121 113 ;Interpolate Point
                           #--- NPUSHB    40 13 24 31 147 4 16 19 12 34 157 0 7 137 143 4 4 146 109 117 40 46 49 55 97 104 4 101 58 67 59 89 85 92 78 75 71 74 81 95 84 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            84         ;Set Reference Point 1
SRP2            95         ;Set Reference Point 2
IP              81         ;Interpolate Point
IP              74         ;Interpolate Point
SRP1            71         ;Set Reference Point 1
IP              75         ;Interpolate Point
SRP2            78         ;Set Reference Point 2
IP              92         ;Interpolate Point
IP              85         ;Interpolate Point
SRP1            89         ;Set Reference Point 1
IP              59         ;Interpolate Point
IP              67         ;Interpolate Point
SRP1            58         ;Set Reference Point 1
SRP2            101        ;Set Reference Point 2
SLOOP           4          ;Set LOOP variable
IP              104 97 55 49 ;Interpolate Point
SRP1            46         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
IP              117        ;Interpolate Point
IP              109        ;Interpolate Point
SRP1            146        ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
SLOOP           4          ;Set LOOP variable
IP              143 137 7 0 ;Interpolate Point
SRP1            157        ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
IP              12         ;Interpolate Point
IP              19         ;Interpolate Point
SRP1            16         ;Set Reference Point 1
SLOOP           4          ;Set LOOP variable
IP              147 31 24 13 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'e': """
                           #--- NPUSHB    24 21 9 21 15 4 10 13 25 6 10 3 0 64 18 1 9 18 4 10 18 6 4 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 4      ;CALL function
MIRP[min,black] estemtc 18 ;Move Indirect Relative Point
CALL            10 4 18    ;CALL function
CALL            9 1 18 64  ;CALL function
CALL            0 3 10     ;CALL function
MIRP[min,black] estemtc 25 ;Move Indirect Relative Point
CALL            13 10 4 15 21 ;CALL function
MIRP[min,black] estemt 21  ;Move Indirect Relative Point
                           #--- PUSHB_5   21 15 31 7 7 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    13 7 15 28 15 31 7 14 1 14 10 0 22 22 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   22 10 14 29 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       29         ;Move Direct Absolute Point
MDRP[rp0,min,white] 14         ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 22  ;Move Indirect Relative Point
SHPIX           -6 22      ;SHift point by a PIXel amount
MDAP[rnd]       22         ;Move Direct Absolute Point
ALIGNRP         0          ;ALIGN to Reference Point
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
SHP[rp2]        1          ;SHift Point using reference point
SRP0            14         ;Set Reference Point 0
MDRP[rp0,min,white] 7          ;Move Direct Relative Point
MIRP[min,white] estemwc 15 ;Move Indirect Relative Point
SRP1            28         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
IP              7          ;Interpolate Point
SHPIX           -18 7      ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] estemwc 15 ;Move Indirect Relative Point
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_3   7 21 15   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            15         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'eight': """
                           #--- NPUSHB    18 42 6 0 23 4 24 2 0 30 9 12 5 0 36 9 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemt 36  ;Move Indirect Relative Point
CALL            0 5 12     ;CALL function
MIRP[min,black] estemt 30  ;Move Indirect Relative Point
CALL            0 2 24     ;CALL function
CALL            4 23 0 6 42 ;CALL function
                           #--- NPUSHB    12 15 10 27 39 33 10 9 3 45 10 3 3 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 3 45 48 45 10 3 21 21 10 39 39 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   39 10 21 49 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       49         ;Move Direct Absolute Point
MDRP[rp0,min,white] 21         ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 39  ;Move Indirect Relative Point
SHPIX           -6 39      ;SHift point by a PIXel amount
MDAP[rnd]       39         ;Move Direct Absolute Point
MIRP[min,black] estemw 21  ;Move Indirect Relative Point
SRP0            21         ;Set Reference Point 0
MDRP[rp0,min,white] 3          ;Move Direct Relative Point
MIRP[min,white] estemw 45  ;Move Indirect Relative Point
SRP1            48         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
IP              3          ;Interpolate Point
SHPIX           -18 3      ;SHift point by a PIXel amount
MDAP[rnd]       3          ;Move Direct Absolute Point
MIRP[min,black] estemw 45  ;Move Indirect Relative Point
SRP0            3          ;Set Reference Point 0
MDRP[rp0,grey]  9          ;Move Direct Relative Point
MIRP[min,black] estemw 33  ;Move Indirect Relative Point
SRP0            39         ;Set Reference Point 0
MDRP[rp0,grey]  27         ;Move Direct Relative Point
MIRP[min,black] estemw 15  ;Move Indirect Relative Point
                           #--- NPUSHB    10 15 9 30 18 6 24 3 21 42 36 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
IP              21         ;Interpolate Point
IP              3          ;Interpolate Point
SRP1            24         ;Set Reference Point 1
IP              6          ;Interpolate Point
IP              18         ;Interpolate Point
SRP2            30         ;Set Reference Point 2
IP              9          ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ellipsis': """
                           #--- NPUSHB    14 10 6 9 1 0 2 6 10 6 0 4 9 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 9      ;CALL function
SHP[rp1]        4          ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
MIRP[min,black] estemtc 10 ;Move Indirect Relative Point
SHP[rp2]        6          ;SHift Point using reference point
SHP[rp2]        2          ;SHift Point using reference point
CALL            0 1 9      ;CALL function
MIRP[min,black] estemtc 10 ;Move Indirect Relative Point
                           #--- NPUSHB    25 13 1 0 10 0 30 4 1 1 4 4 10 0 30 4 5 1 8 8 10 0 30 4 9 12 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       12         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
CALL            4 30 0 10 8 ;CALL function
SRP0            8          ;Set Reference Point 0
CALL            1 5        ;CALL function
CALL            4 30 0 10 4 ;CALL function
SRP0            4          ;Set Reference Point 0
CALL            1 1        ;CALL function
CALL            4 30 0 10 0 ;CALL function
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'emdash': """
                           #--- NPUSHB    11 2 6 0 42 4 2 6 0 42 4 1 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
CALL            4 42 0 6 2 ;CALL function
CALL            4 42 0 6 2 ;CALL function
                           #--- PUSHB_3   5 1 4     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'endash': """
                           #--- PUSHB_5   2 6 2 6 1 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] estemtc 2  ;Move Indirect Relative Point
MIRP[min,black] estemtc 2  ;Move Indirect Relative Point
                           #--- PUSHB_3   5 1 4     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'enspace': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   35 9      ;PUSH Bytes
MIRP[min,black] estemt 35  ;Move Indirect Relative Point
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   39 8      ;PUSH Bytes
MIRP[min,black] cvt_8 39   ;Move Indirect Relative Point
                           #--- PUSHB_3   37 4 0    ;PUSH Bytes
CALL            0 4 37     ;CALL function
                           #--- PUSHB_3   31 4 0    ;PUSH Bytes
CALL            0 4 31     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   45 15 21 31 13 ;PUSH Bytes
CALL            13 31 21 15 45 ;CALL function
                           #--- PUSHB_2   45 8      ;PUSH Bytes
MIRP[min,black] cvt_8 45   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   13 10     ;PUSH Bytes
MIRP[min,black] estemw 13  ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   42 1      ;PUSH Bytes
CALL            1 42       ;CALL function
                           #--- PUSHB_5   18 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   35 10     ;PUSH Bytes
MIRP[min,black] estemw 35  ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   13 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   8 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_5   9 15 21 39 45 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              45 39 21 15 9 ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   5 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_3   18 42 48  ;PUSH Bytes
IP              48         ;Interpolate Point
IP              42         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_2   15 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_3   10 27 28  ;PUSH Bytes
IP              28         ;Interpolate Point
IP              27         ;Interpolate Point
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'equal': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] estemtc 6  ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 6       ;PUSH Bytes
MIRP[min,black] estemtc 2  ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'exclamdbl': """
                           #--- PUSHB_5   2 7 2 7 1 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 1 4     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'f': """
                           #--- NPUSHB    17 17 3 9 19 3 2 0 8 13 13 9 8 5 0 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 5 8      ;CALL function
MIRP[min,black] estemt 13  ;Move Indirect Relative Point
CALL            13 8 0 2 3 ;CALL function
SHP[rp1]        19         ;SHift Point using reference point
MIRP[min,black] estemt 3   ;Move Indirect Relative Point
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_6   17 21 10 4 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -12       ;PUSH Words
                           #--- PUSHB_5   0 21 22 21 23 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       23         ;Move Direct Absolute Point
MDRP[rp0,min,white] 21         ;Move Direct Relative Point
SRP1            22         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -12 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
ALIGNRP         4          ;ALIGN to Reference Point
MIRP[min,black] estemw 21  ;Move Indirect Relative Point
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_3   11 13 3   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            3          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'five': """
                           #--- NPUSHB    24 22 6 22 10 28 15 13 18 9 15 5 0 64 4 0 9 4 28 10 4 6 28 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 28     ;CALL function
MIRP[min,black] estemtc 4  ;Move Indirect Relative Point
CALL            10 28 4    ;CALL function
CALL            9 0 4 64   ;CALL function
CALL            0 5 15     ;CALL function
MIRP[min,black] estemt 18  ;Move Indirect Relative Point
CALL            13 15 28 10 22 ;CALL function
MIRP[min,black] estemtc 22 ;Move Indirect Relative Point
                           #--- NPUSHB    9 17 25 19 14 0 1 10 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 1 31 1 10 0 25 25 31 7 7 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   7 31 25 32 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       32         ;Move Direct Absolute Point
MDRP[rp0,min,white] 25         ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 7  ;Move Indirect Relative Point
SHPIX           -6 7       ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] estemwc 25 ;Move Indirect Relative Point
SRP0            25         ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] estemw 1   ;Move Indirect Relative Point
SRP1            31         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] estemw 1   ;Move Indirect Relative Point
SRP0            0          ;Set Reference Point 0
MDRP[rp0,grey]  14         ;Move Direct Relative Point
MDRP[grey]      19         ;Move Direct Relative Point
SRP0            25         ;Set Reference Point 0
MDRP[grey]      17         ;Move Direct Relative Point
                           #--- PUSHB_7   19 22 13 14 25 10 4 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            4          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
IP              25         ;Interpolate Point
IP              14         ;Interpolate Point
IP              13         ;Interpolate Point
SRP1            22         ;Set Reference Point 1
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'four': """
                           #--- NPUSHB    15 8 2 9 6 2 13 0 4 13 4 5 0 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 5 4      ;CALL function
CALL            13 4 0 13 2 ;CALL function
SHP[rp1]        6          ;SHift Point using reference point
MIRP[min,black] estemt 2   ;Move Indirect Relative Point
SHP[rp2]        8          ;SHift Point using reference point
                           #--- NPUSHB    10 13 2 10 14 6 10 10 11 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -12       ;PUSH Words
                           #--- PUSHB_5   0 10 14 10 15 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       15         ;Move Direct Absolute Point
MDRP[rp0,min,white] 10         ;Move Direct Relative Point
SRP1            14         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -12 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
ALIGNRP         11         ;ALIGN to Reference Point
MIRP[min,black] estemw 10  ;Move Indirect Relative Point
SHP[rp2]        6          ;SHift Point using reference point
SRP1            14         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
IP              2          ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_5   12 4 3 13 2 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            2          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
IP              3          ;Interpolate Point
SRP1            4          ;Set Reference Point 1
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'fraction': """
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 2      ;CALL function
                           #--- PUSHB_3   5 1 4     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'g': """
                           #--- NPUSHB    25 33 6 9 3 0 13 3 0 64 26 22 9 26 18 10 26 6 18 0 0 39 6 3 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 3      ;CALL function
MIRP[min,black] estemtc 39 ;Move Indirect Relative Point
CALL            0 0 18     ;CALL function
MIRP[min,black] estemtc 26 ;Move Indirect Relative Point
CALL            10 18 26   ;CALL function
CALL            9 22 26 64 ;CALL function
CALL            0 3 13     ;CALL function
CALL            0 3 9      ;CALL function
MIRP[min,black] estemtc 33 ;Move Indirect Relative Point
                           #--- NPUSHB    8 23 6 22 6 36 31 6 6 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    13 6 36 42 36 31 6 15 15 10 12 30 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   0 10 15 43 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       43         ;Move Direct Absolute Point
MDRP[rp0,min,white] 15         ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 0   ;Move Indirect Relative Point
SHPIX           -6 0       ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
ALIGNRP         30         ;ALIGN to Reference Point
ALIGNRP         12         ;ALIGN to Reference Point
MIRP[min,black] estemw 15  ;Move Indirect Relative Point
SRP0            15         ;Set Reference Point 0
MDRP[rp0,min,white] 6          ;Move Direct Relative Point
MIRP[min,white] estemwc 36 ;Move Indirect Relative Point
SRP1            42         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
IP              6          ;Interpolate Point
SHPIX           -18 6      ;SHift point by a PIXel amount
MDAP[rnd]       6          ;Move Direct Absolute Point
MIRP[min,black] estemwc 36 ;Move Indirect Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[rp0,rnd,grey] 22         ;Move Direct Relative Point
MIRP[min,black] estemtc 23 ;Move Indirect Relative Point
                           #--- PUSHB_7   12 13 6 33 0 39 3 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            3          ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
IP              0          ;Interpolate Point
SRP1            33         ;Set Reference Point 1
IP              6          ;Interpolate Point
SRP2            13         ;Set Reference Point 2
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'grave': """
                           #--- NPUSHB    8 1 6 0 22 4 3 5 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 5 3      ;CALL function
CALL            4 22 0 6 1 ;CALL function
                           #--- NPUSHB    9 5 1 0 12 0 10 4 2 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
CALL            4 10 0 12 0 ;CALL function
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'greater': """
                           #--- NPUSHB    17 64 9 13 9 9 16 10 9 6 16 5 0 26 6 25 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 25     ;CALL function
MIRP[min,black] estemtc 26 ;Move Indirect Relative Point
CALL            0 5 16     ;CALL function
MIRP[min,black] estemtc 9  ;Move Indirect Relative Point
CALL            10 16 9    ;CALL function
CALL            9 13 9 64  ;CALL function
                           #--- NPUSHB    30 22 19 6 4 9 16 0 25 14 12 13 29 1 19 10 6 1 24 0 10 24 12 1 25 1 12 12 10 13 28 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       28         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
MIRP[min,black] estemw 12  ;Move Indirect Relative Point
SRP0            12         ;Set Reference Point 0
CALL            1 25       ;CALL function
SHP[rp2]        1          ;SHift Point using reference point
MIRP[min,black] ecstemw 24 ;Move Indirect Relative Point
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
SRP0            24         ;Set Reference Point 0
CALL            1 6        ;CALL function
MIRP[min,black] estemw 19  ;Move Indirect Relative Point
CALL            1 29       ;CALL function
SRP1            13         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
IP              14         ;Interpolate Point
SRP1            25         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
IP              16         ;Interpolate Point
IP              9          ;Interpolate Point
IP              4          ;Interpolate Point
SRP1            6          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
IP              22         ;Interpolate Point
                           #--- PUSHB_4   0 21 9 26 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            26         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
IP              21         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'guillemotleft': """
                           #--- PUSHB_3   10 4 0    ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 4 10     ;CALL function
                           #--- PUSHB_3   15 1 14   ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       14         ;Move Direct Absolute Point
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'guilsinglleft': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    15 0 3 5 6 1 8 1 4 6 12 0 8 4 1 7 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       7          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
CALL            4 8 0 12 6 ;CALL function
SHP[rp2]        4          ;SHift Point using reference point
CALL            1 8        ;CALL function
SRP1            1          ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
IP              5          ;Interpolate Point
IP              3          ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'guilsinglright': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- NPUSHB    13 3 0 1 8 1 0 12 0 8 4 4 1 7 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       7          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
SHP[rp2]        4          ;SHift Point using reference point
CALL            4 8 0 12 0 ;CALL function
CALL            1 8        ;CALL function
SRP1            1          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
IP              3          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'h': """
                           #--- NPUSHB    12 15 6 6 3 0 1 5 0 10 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        10         ;SHift Point using reference point
CALL            0 5 1      ;CALL function
CALL            0 3 6      ;CALL function
MIRP[min,black] estemtc 15 ;Move Indirect Relative Point
                           #--- PUSHB_5   18 3 10 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 3 20 3 10 0 9 9 10 12 12 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   12 10 9 21 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       21         ;Move Direct Absolute Point
MDRP[rp0,min,white] 9          ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 12  ;Move Indirect Relative Point
SHPIX           -6 12      ;SHift point by a PIXel amount
MDAP[rnd]       12         ;Move Direct Absolute Point
MIRP[min,black] estemw 9   ;Move Indirect Relative Point
SRP0            9          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] estemw 3   ;Move Indirect Relative Point
SRP1            20         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] estemw 3   ;Move Indirect Relative Point
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_3   3 6 15    ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            15         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'hyphen': """
                           #--- NPUSHB    11 2 6 0 31 4 2 6 0 31 4 1 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
CALL            4 31 0 6 2 ;CALL function
CALL            4 31 0 6 2 ;CALL function
                           #--- NPUSHB    10 5 1 0 12 0 8 4 1 1 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 1        ;CALL function
CALL            4 8 0 12 0 ;CALL function
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'i': """
                           #--- NPUSHB    14 5 3 0 0 6 0 42 4 1 5 0 4 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 4      ;CALL function
CALL            0 5 1      ;CALL function
CALL            4 42 0 6 0 ;CALL function
CALL            0 3 5      ;CALL function
                           #--- PUSHB_6   3 7 10 0 4 4 ;PUSH Bytes
                           #--- PUSHW_1   -12       ;PUSH Words
                           #--- PUSHB_5   4 7 8 7 9 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       9          ;Move Direct Absolute Point
MDRP[rp0,min,white] 7          ;Move Direct Relative Point
SRP1            8          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              4          ;Interpolate Point
SHPIX           -12 4      ;SHift point by a PIXel amount
MDAP[rnd]       4          ;Move Direct Absolute Point
ALIGNRP         0          ;ALIGN to Reference Point
MIRP[min,black] estemw 7   ;Move Indirect Relative Point
SHP[rp2]        3          ;SHift Point using reference point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'j': """
                           #--- NPUSHB    16 11 3 0 0 6 0 42 4 1 5 0 7 6 16 0 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 16     ;CALL function
MIRP[min,black] estemtc 7  ;Move Indirect Relative Point
CALL            0 5 1      ;CALL function
CALL            4 42 0 6 0 ;CALL function
CALL            0 3 11     ;CALL function
                           #--- PUSHB_6   3 13 10 0 10 10 ;PUSH Bytes
                           #--- PUSHW_1   -12       ;PUSH Words
                           #--- PUSHB_5   10 13 18 13 19 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       19         ;Move Direct Absolute Point
MDRP[rp0,min,white] 13         ;Move Direct Relative Point
SRP1            18         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
IP              10         ;Interpolate Point
SHPIX           -12 10     ;SHift point by a PIXel amount
MDAP[rnd]       10         ;Move Direct Absolute Point
ALIGNRP         0          ;ALIGN to Reference Point
MIRP[min,black] estemw 13  ;Move Indirect Relative Point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_5   5 11 4 7 16 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            16         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              4          ;Interpolate Point
SRP1            11         ;Set Reference Point 1
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'k': """
                           #--- NPUSHB    10 4 3 0 1 5 0 7 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        7          ;SHift Point using reference point
CALL            0 5 1      ;CALL function
CALL            0 3 4      ;CALL function
                           #--- PUSHB_5   3 11 10 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 11 12 11 10 0 7 7 31 8 8 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   8 31 7 13 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       13         ;Move Direct Absolute Point
MDRP[rp0,min,white] 7          ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 8  ;Move Indirect Relative Point
SHPIX           -6 8       ;SHift point by a PIXel amount
MDAP[rnd]       8          ;Move Direct Absolute Point
MIRP[min,black] estemwc 7  ;Move Indirect Relative Point
SRP0            7          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] estemw 11  ;Move Indirect Relative Point
SRP1            12         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] estemw 11  ;Move Indirect Relative Point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_4   3 9 4 0   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'l': """
                           #--- PUSHB_6   1 5 0 0 1 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 5 1      ;CALL function
                           #--- PUSHB_4   3 10 0 0  ;PUSH Bytes
                           #--- PUSHW_1   -12       ;PUSH Words
                           #--- PUSHB_5   0 3 4 3 5 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       5          ;Move Direct Absolute Point
MDRP[rp0,min,white] 3          ;Move Direct Relative Point
SRP1            4          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -12 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] estemw 3   ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'less': """
                           #--- PUSHB_6   2 6 1 6 6 5 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       5          ;Move Direct Absolute Point
MIRP[min,black] estemtc 6  ;Move Indirect Relative Point
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] estemtc 2  ;Move Indirect Relative Point
                           #--- PUSHB_3   9 1 8     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'logicalnot': """
                           #--- NPUSHB    13 64 3 1 9 3 4 10 4 8 0 64 4 3 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       3          ;Move Direct Absolute Point
CALL            4 64 0 8 4 ;CALL function
CALL            10 4 3     ;CALL function
CALL            9 1 3 64   ;CALL function
                           #--- NPUSHB    16 7 1 64 1 3 9 1 0 10 0 10 0 22 4 1 6 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       6          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
CALL            4 22 0 10 0 ;CALL function
CALL            10 0 1     ;CALL function
CALL            9 3 1 64   ;CALL function
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'm': """
                           #--- NPUSHB    15 33 7 6 24 18 3 0 13 3 0 2 28 12 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 12     ;CALL function
SHP[rp1]        28         ;SHift Point using reference point
SHP[rp1]        2          ;SHift Point using reference point
CALL            0 3 13     ;CALL function
CALL            0 3 18     ;CALL function
SHP[rp1]        24         ;SHift Point using reference point
MIRP[min,black] estemtc 7  ;Move Indirect Relative Point
SHP[rp2]        33         ;SHift Point using reference point
                           #--- NPUSHB    14 21 2 3 2 10 3 3 29 12 15 11 10 12 12 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 12 11 36 11 10 12 28 28 10 29 29 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   29 10 28 37 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       37         ;Move Direct Absolute Point
MDRP[rp0,min,white] 28         ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 29  ;Move Indirect Relative Point
SHPIX           -6 29      ;SHift point by a PIXel amount
MDAP[rnd]       29         ;Move Direct Absolute Point
MIRP[min,black] estemw 28  ;Move Indirect Relative Point
SRP0            28         ;Set Reference Point 0
MDRP[rp0,min,white] 12         ;Move Direct Relative Point
MIRP[min,white] estemw 11  ;Move Indirect Relative Point
SRP1            36         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
IP              12         ;Interpolate Point
SHPIX           -18 12     ;SHift point by a PIXel amount
MDAP[rnd]       12         ;Move Direct Absolute Point
MIRP[min,black] estemw 11  ;Move Indirect Relative Point
SHP[rp2]        15         ;SHift Point using reference point
SRP1            12         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
IP              3          ;Interpolate Point
MDAP[rnd]       3          ;Move Direct Absolute Point
MIRP[min,black] estemw 2   ;Move Indirect Relative Point
SRP1            3          ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
IP              21         ;Interpolate Point
                           #--- PUSHB_4   15 21 13 7 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            7          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
IP              21         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'macron': """
                           #--- PUSHB_5   2 7 2 7 1 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 1 4     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'minute': """
                           #--- PUSHB_6   3 6 0 7 4 2 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       2          ;Move Direct Absolute Point
CALL            4 7 0 6 3  ;CALL function
                           #--- NPUSHB    9 5 1 0 12 0 10 4 2 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
CALL            4 10 0 12 0 ;CALL function
CALL            1 5        ;CALL function
                           #--- PUSHB_3   0 3 2     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            2          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'mu': """
                           #--- NPUSHB    18 64 6 11 9 6 17 10 17 9 0 33 4 6 1 0 1 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 1      ;CALL function
CALL            0 1 6      ;CALL function
CALL            4 33 0 9 17 ;CALL function
CALL            10 17 6    ;CALL function
CALL            9 11 6 64  ;CALL function
                           #--- NPUSHB    30 3 1 6 20 10 24 1 1 1 10 0 22 4 0 0 10 0 30 4 20 1 10 13 10 10 0 30 4 11 23 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       23         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
CALL            4 30 0 10 10 ;CALL function
SHP[rp2]        13         ;SHift Point using reference point
SRP0            10         ;Set Reference Point 0
CALL            1 20       ;CALL function
CALL            4 30 0 10 0 ;CALL function
SRP0            0          ;Set Reference Point 0
CALL            4 22 0 10 1 ;CALL function
MDAP[rnd]       1          ;Move Direct Absolute Point
CALL            1 24       ;CALL function
SRP1            10         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
IP              6          ;Interpolate Point
SRP1            1          ;Set Reference Point 1
IP              3          ;Interpolate Point
                           #--- PUSHB_5   2 3 9 17 1 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            1          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IP              2          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'n': """
                           #--- NPUSHB    12 15 6 6 3 0 1 3 0 10 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        10         ;SHift Point using reference point
CALL            0 3 1      ;CALL function
CALL            0 3 6      ;CALL function
MIRP[min,black] estemtc 15 ;Move Indirect Relative Point
                           #--- PUSHB_5   3 19 10 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 19 20 19 10 0 10 10 10 11 11 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   11 10 10 21 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       21         ;Move Direct Absolute Point
MDRP[rp0,min,white] 10         ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 11  ;Move Indirect Relative Point
SHPIX           -6 11      ;SHift point by a PIXel amount
MDAP[rnd]       11         ;Move Direct Absolute Point
MIRP[min,black] estemw 10  ;Move Indirect Relative Point
SRP0            10         ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] estemw 19  ;Move Indirect Relative Point
SRP1            20         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] estemw 19  ;Move Indirect Relative Point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   3 1 15    ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            15         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'nine': """
                           #--- NPUSHB    24 13 6 13 25 0 19 13 31 6 19 5 0 64 7 3 9 7 0 10 7 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemtc 7  ;Move Indirect Relative Point
CALL            10 0 7     ;CALL function
CALL            9 3 7 64   ;CALL function
CALL            0 5 19     ;CALL function
MIRP[min,black] estemtc 31 ;Move Indirect Relative Point
CALL            13 19 0 25 13 ;CALL function
MIRP[min,black] estemtc 13 ;Move Indirect Relative Point
                           #--- NPUSHB    10 28 10 4 10 3 16 34 10 16 16 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 16 34 37 34 10 16 22 22 10 10 10 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   10 10 22 38 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       38         ;Move Direct Absolute Point
MDRP[rp0,min,white] 22         ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 10  ;Move Indirect Relative Point
SHPIX           -6 10      ;SHift point by a PIXel amount
MDAP[rnd]       10         ;Move Direct Absolute Point
MIRP[min,black] estemw 22  ;Move Indirect Relative Point
SRP0            22         ;Set Reference Point 0
MDRP[rp0,min,white] 16         ;Move Direct Relative Point
MIRP[min,white] estemw 34  ;Move Indirect Relative Point
SRP1            37         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
IP              16         ;Interpolate Point
SHPIX           -18 16     ;SHift point by a PIXel amount
MDAP[rnd]       16         ;Move Direct Absolute Point
MIRP[min,black] estemw 34  ;Move Indirect Relative Point
SRP0            16         ;Set Reference Point 0
MDRP[rp0,rnd,grey] 3          ;Move Direct Relative Point
MIRP[min,black] estemw 4   ;Move Indirect Relative Point
SRP0            10         ;Set Reference Point 0
MDRP[grey]      28         ;Move Direct Relative Point
                           #--- PUSHB_6   22 16 31 10 25 13 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            13         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
IP              10         ;Interpolate Point
SRP1            31         ;Set Reference Point 1
IP              16         ;Interpolate Point
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'numbersign': """
                           #--- NPUSHB    44 13 16 20 12 6 10 23 29 30 4 12 11 5 14 13 2 3 6 27 4 7 6 9 24 28 31 4 7 8 5 14 13 15 18 19 14 5 0 0 1 4 5 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 5      ;CALL function
SHP[rp1]        4          ;SHift Point using reference point
SHP[rp1]        1          ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
CALL            0 5 14     ;CALL function
SHP[rp1]        19         ;SHift Point using reference point
SHP[rp1]        18         ;SHift Point using reference point
SHP[rp1]        15         ;SHift Point using reference point
CALL            13 14 5 8 7 ;CALL function
SLOOP           4          ;Set LOOP variable
SHP[rp1]        31 28 24 9 ;SHift Point using reference point
MIRP[min,black] estemtc 7  ;Move Indirect Relative Point
SLOOP           4          ;Set LOOP variable
SHP[rp2]        27 6 3 2   ;SHift Point using reference point
CALL            13 14 5 11 12 ;CALL function
SLOOP           4          ;Set LOOP variable
SHP[rp1]        30 29 23 10 ;SHift Point using reference point
MIRP[min,black] estemtc 12 ;Move Indirect Relative Point
SHP[rp2]        20         ;SHift Point using reference point
SHP[rp2]        16         ;SHift Point using reference point
SHP[rp2]        13         ;SHift Point using reference point
                           #--- NPUSHB    103 64 0 1 2 3 4 5 6 9 10 13 14 15 16 18 19 23 24 27 28 29 30 31 31 4 30 19 4 29 1 18 19 28 1 18 19 1 27 0 19 19 24 0 19 19 23 0 19 19 0 9 5 10 19 6 5 10 19 5 3 4 30 19 4 2 1 18 19 1 18 10 19 0 10 1 19 1 1 18 14 13 15 16 13 13 15 13 13 14 10 13 30 4 13 5 30 5 5 10 54 33 1 32 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       32         ;Move Direct Absolute Point
CALL            1 33       ;CALL function
SMD             54         ;Set Minimum Distance
SDPVTL[orthog]  10 5       ;Set Dual Projection Vector To Line
MDAP[no-rnd]    5          ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
SRP0            5          ;Set Reference Point 0
MIRP[rp0,min,black] cvt_13 4   ;Move Indirect Relative Point
SRP0            30         ;Set Reference Point 0
MIRP[rp0,min,black] cvt_13 10  ;Move Indirect Relative Point
SDPVTL[orthog]  14 13      ;Set Dual Projection Vector To Line
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
SRP0            13         ;Set Reference Point 0
MIRP[rp0,min,black] cvt_13 16  ;Move Indirect Relative Point
SRP0            15         ;Set Reference Point 0
MIRP[rp0,min,black] cvt_13 14  ;Move Indirect Relative Point
SDPVTL[orthog]  18 1       ;Set Dual Projection Vector To Line
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    19         ;Move Direct Absolute Point
SRP0            1          ;Set Reference Point 0
MIRP[rp0,min,black] estemw 0   ;Move Indirect Relative Point
SRP0            19         ;Set Reference Point 0
MIRP[rp0,min,black] estemw 18  ;Move Indirect Relative Point
SRP0            1          ;Set Reference Point 0
CALL            19 18 1 2  ;CALL function
SRP0            4          ;Set Reference Point 0
CALL            19 30 4 3  ;CALL function
SRP0            5          ;Set Reference Point 0
CALL            19 10 5 6  ;CALL function
CALL            19 10 5 9  ;CALL function
SRP0            0          ;Set Reference Point 0
CALL            19 19 0 23 ;CALL function
CALL            19 19 0 24 ;CALL function
CALL            19 19 0 27 ;CALL function
SRP0            1          ;Set Reference Point 0
CALL            19 18 1 28 ;CALL function
CALL            19 18 1 29 ;CALL function
SRP0            4          ;Set Reference Point 0
CALL            19 30 4 31 ;CALL function
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    29         ;Move Direct Absolute Point
MDAP[no-rnd]    28         ;Move Direct Absolute Point
MDAP[no-rnd]    27         ;Move Direct Absolute Point
MDAP[no-rnd]    24         ;Move Direct Absolute Point
MDAP[no-rnd]    23         ;Move Direct Absolute Point
MDAP[no-rnd]    19         ;Move Direct Absolute Point
MDAP[no-rnd]    18         ;Move Direct Absolute Point
MDAP[no-rnd]    16         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    13         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    6          ;Move Direct Absolute Point
MDAP[no-rnd]    5          ;Move Direct Absolute Point
MDAP[no-rnd]    4          ;Move Direct Absolute Point
MDAP[no-rnd]    3          ;Move Direct Absolute Point
MDAP[no-rnd]    2          ;Move Direct Absolute Point
MDAP[no-rnd]    1          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
SMD             64         ;Set Minimum Distance
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'o': """
                           #--- NPUSHB    10 21 6 3 3 0 15 6 9 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 9      ;CALL function
MIRP[min,black] estemtc 15 ;Move Indirect Relative Point
CALL            0 3 3      ;CALL function
MIRP[min,black] estemtc 21 ;Move Indirect Relative Point
                           #--- PUSHB_4   12 31 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 12 24 12 31 0 6 6 31 18 18 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   18 31 6 25 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       25         ;Move Direct Absolute Point
MDRP[rp0,min,white] 6          ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 18 ;Move Indirect Relative Point
SHPIX           -6 18      ;SHift point by a PIXel amount
MDAP[rnd]       18         ;Move Direct Absolute Point
MIRP[min,black] estemwc 6  ;Move Indirect Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] estemwc 12 ;Move Indirect Relative Point
SRP1            24         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] estemwc 12 ;Move Indirect Relative Point
                           #--- PUSHB_3   0 21 15   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            15         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'one': """
                           #--- PUSHB_6   9 5 0 1 1 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 1      ;CALL function
CALL            0 5 9      ;CALL function
                           #--- PUSHB_4   0 10 1 1  ;PUSH Bytes
                           #--- PUSHW_1   -12       ;PUSH Words
                           #--- PUSHB_5   1 0 11 0 12 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       12         ;Move Direct Absolute Point
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
SRP1            11         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
IP              1          ;Interpolate Point
SHPIX           -12 1      ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'ordfeminine': """
                           #--- NPUSHB    19 64 17 20 9 17 25 10 25 8 17 13 8 30 38 8 0 66 4 5 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       5          ;Move Direct Absolute Point
CALL            4 66 0 8 38 ;CALL function
MDAP[rnd]       30         ;Move Direct Absolute Point
MIRP[min,black] cvt_8 13   ;Move Indirect Relative Point
MDAP[rnd]       17         ;Move Direct Absolute Point
MIRP[min,black] cvt_8 25   ;Move Indirect Relative Point
CALL            10 25 17   ;CALL function
CALL            9 20 17 64 ;CALL function
                           #--- NPUSHB    28 5 17 25 1 20 21 22 35 8 42 1 0 10 0 22 4 13 29 1 1 35 35 10 0 22 4 8 41 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       41         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
CALL            4 22 0 10 35 ;CALL function
SRP0            35         ;Set Reference Point 0
CALL            1 1        ;CALL function
SHP[rp2]        29         ;SHift Point using reference point
SHP[rp2]        13         ;SHift Point using reference point
CALL            4 22 0 10 0 ;CALL function
CALL            1 42       ;CALL function
SRP1            8          ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
IP              22         ;Interpolate Point
IP              21         ;Interpolate Point
IP              20         ;Interpolate Point
SRP1            1          ;Set Reference Point 1
IP              25         ;Interpolate Point
IP              17         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- NPUSHB    9 22 25 17 8 30 0 2 38 5 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            5          ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
IP              2          ;Interpolate Point
IP              0          ;Interpolate Point
SRP1            30         ;Set Reference Point 1
IP              8          ;Interpolate Point
SRP1            17         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'p': """
                           #--- NPUSHB    20 23 6 7 3 0 2 3 0 64 13 0 9 13 17 10 17 6 13 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 13     ;CALL function
MIRP[min,black] estemtc 17 ;Move Indirect Relative Point
CALL            10 17 13   ;CALL function
CALL            9 0 13 64  ;CALL function
CALL            0 3 2      ;CALL function
CALL            0 3 7      ;CALL function
MIRP[min,black] estemtc 23 ;Move Indirect Relative Point
                           #--- PUSHB_6   4 26 0 10 1 1 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 1 0 29 0 10 1 10 10 31 20 20 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   20 31 10 30 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       30         ;Move Direct Absolute Point
MDRP[rp0,min,white] 10         ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 20 ;Move Indirect Relative Point
SHPIX           -6 20      ;SHift point by a PIXel amount
MDAP[rnd]       20         ;Move Direct Absolute Point
MIRP[min,black] estemwc 10 ;Move Indirect Relative Point
SRP0            10         ;Set Reference Point 0
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[min,white] estemw 0   ;Move Indirect Relative Point
SRP1            29         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
IP              1          ;Interpolate Point
SHPIX           -18 1      ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
SHP[rp2]        26         ;SHift Point using reference point
SHP[rp2]        4          ;SHift Point using reference point
                           #--- NPUSHB    8 4 2 10 26 23 16 17 13 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            13         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
IP              16         ;Interpolate Point
SRP1            23         ;Set Reference Point 1
IP              26         ;Interpolate Point
IP              10         ;Interpolate Point
SRP2            2          ;Set Reference Point 2
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'paragraph': """
                           #--- NPUSHB    11 10 64 13 1 9 13 8 10 8 7 13 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       13         ;Move Direct Absolute Point
MIRP[min,black] cvt_7 8    ;Move Indirect Relative Point
CALL            10 8 13    ;CALL function
CALL            9 1 13 64  ;CALL function
SHP[rp2]        10         ;SHift Point using reference point
                           #--- NPUSHB    24 15 1 10 10 0 13 4 11 1 0 5 5 12 0 7 4 0 0 10 0 13 4 1 14 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       14         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
CALL            4 13 0 10 0 ;CALL function
SRP0            0          ;Set Reference Point 0
CALL            4 7 0 12 5 ;CALL function
MDAP[rnd]       5          ;Move Direct Absolute Point
SRP0            0          ;Set Reference Point 0
CALL            1 11       ;CALL function
CALL            4 13 0 10 10 ;CALL function
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'parenleft': """
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 0      ;CALL function
                           #--- PUSHB_6   15 1 10 12 3 14 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       14         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
MIRP[min,black] ecstemw 10 ;Move Indirect Relative Point
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'parenright': """
                           #--- PUSHB_3   1 0 0     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 1      ;CALL function
                           #--- PUSHB_6   15 1 11 12 4 14 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       14         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
MIRP[min,black] ecstemw 11 ;Move Indirect Relative Point
CALL            1 15       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'percent': """
                           #--- NPUSHB    34 26 6 9 0 33 4 18 12 8 0 49 4 0 34 46 8 34 9 0 33 4 46 40 9 0 33 4 15 25 28 14 25 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 25     ;CALL function
CALL            14 28 25 15 ;CALL function
CALL            4 33 0 9 40 ;CALL function
MDAP[rnd]       46         ;Move Direct Absolute Point
CALL            4 33 0 9 34 ;CALL function
CALL            8 46 34 0  ;CALL function
CALL            4 49 0 8 12 ;CALL function
MDAP[rnd]       18         ;Move Direct Absolute Point
CALL            4 33 0 9 6 ;CALL function
SHP[rp2]        26         ;SHift Point using reference point
                           #--- NPUSHB    47 28 34 27 43 26 49 31 24 9 6 0 25 15 21 53 1 37 10 0 30 4 43 1 49 49 10 0 30 4 31 1 9 9 10 0 30 4 15 1 21 21 10 0 30 4 3 52 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       52         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
CALL            4 30 0 10 21 ;CALL function
SRP0            21         ;Set Reference Point 0
CALL            1 15       ;CALL function
CALL            4 30 0 10 9 ;CALL function
SRP0            9          ;Set Reference Point 0
CALL            1 31       ;CALL function
CALL            4 30 0 10 49 ;CALL function
SRP0            49         ;Set Reference Point 0
CALL            1 43       ;CALL function
CALL            4 30 0 10 37 ;CALL function
CALL            1 53       ;CALL function
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
IP              25         ;Interpolate Point
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SRP1            9          ;Set Reference Point 1
IP              24         ;Interpolate Point
SRP1            31         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
IP              26         ;Interpolate Point
SRP1            43         ;Set Reference Point 1
IP              27         ;Interpolate Point
IP              34         ;Interpolate Point
IP              28         ;Interpolate Point
                           #--- PUSHB_7   3 18 12 31 37 46 40 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            40         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
IP              37         ;Interpolate Point
IP              31         ;Interpolate Point
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'period': """
                           #--- NPUSHB    10 2 6 1 1 0 2 6 1 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 1      ;CALL function
MIRP[min,black] estemtc 2  ;Move Indirect Relative Point
CALL            0 1 1      ;CALL function
MIRP[min,black] estemtc 2  ;Move Indirect Relative Point
                           #--- NPUSHB    8 5 1 0 12 0 12 1 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
MIRP[min,black] ecstemw 0  ;Move Indirect Relative Point
MIRP[min,black] ecstemw 0  ;Move Indirect Relative Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'periodcentered': """
                           #--- NPUSHB    11 2 6 0 22 4 2 6 0 22 4 1 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
CALL            4 22 0 6 2 ;CALL function
CALL            4 22 0 6 2 ;CALL function
                           #--- NPUSHB    8 5 1 0 10 0 10 1 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'perthousand': """
                           #--- NPUSHB    25 11 7 36 4 7 41 29 49 8 71 29 7 77 49 85 56 7 64 24 16 22 14 16 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 16     ;CALL function
CALL            14 22 16 24 ;CALL function
SHP[rp1]        64         ;SHift Point using reference point
MIRP[min,black] cvt_7 56   ;Move Indirect Relative Point
SHP[rp2]        85         ;SHift Point using reference point
MDAP[rnd]       49         ;Move Direct Absolute Point
SHP[rp1]        77         ;SHift Point using reference point
MIRP[min,black] cvt_7 29   ;Move Indirect Relative Point
SHP[rp2]        71         ;SHift Point using reference point
CALL            8 49 29 41 ;CALL function
MIRP[min,black] cvt_7 4    ;Move Indirect Relative Point
MDAP[rnd]       36         ;Move Direct Absolute Point
MIRP[min,black] cvt_7 11   ;Move Indirect Relative Point
                           #--- NPUSHB    67 71 64 74 81 22 29 14 45 17 52 26 15 0 11 4 16 32 38 90 1 60 10 0 22 4 74 1 81 81 10 0 22 4 68 1 18 18 10 0 22 4 45 1 52 52 10 0 22 4 26 1 0 0 10 0 22 4 32 1 38 38 10 0 22 4 8 89 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       89         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
CALL            4 22 0 10 38 ;CALL function
SRP0            38         ;Set Reference Point 0
CALL            1 32       ;CALL function
CALL            4 22 0 10 0 ;CALL function
SRP0            0          ;Set Reference Point 0
CALL            1 26       ;CALL function
CALL            4 22 0 10 52 ;CALL function
SRP0            52         ;Set Reference Point 0
CALL            1 45       ;CALL function
CALL            4 22 0 10 18 ;CALL function
SRP0            18         ;Set Reference Point 0
CALL            1 68       ;CALL function
CALL            4 22 0 10 81 ;CALL function
SRP0            81         ;Set Reference Point 0
CALL            1 74       ;CALL function
CALL            4 22 0 10 60 ;CALL function
CALL            1 90       ;CALL function
SRP1            38         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
IP              16         ;Interpolate Point
IP              4          ;Interpolate Point
IP              11         ;Interpolate Point
SRP1            0          ;Set Reference Point 1
IP              15         ;Interpolate Point
SRP1            26         ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
IP              17         ;Interpolate Point
SRP1            45         ;Set Reference Point 1
IP              14         ;Interpolate Point
IP              29         ;Interpolate Point
IP              22         ;Interpolate Point
SRP1            81         ;Set Reference Point 1
SRP2            74         ;Set Reference Point 2
IP              64         ;Interpolate Point
IP              71         ;Interpolate Point
                           #--- NPUSHB    21 14 17 11 8 0 32 38 4 36 29 18 26 45 52 60 68 74 81 8 4 56 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            56         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
SLOOP           8          ;Set LOOP variable
IP              81 74 68 60 52 45 26 18 ;Interpolate Point
SRP1            29         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
SLOOP           4          ;Set LOOP variable
IP              38 32 0 8  ;Interpolate Point
SRP1            11         ;Set Reference Point 1
IP              17         ;Interpolate Point
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'plus': """
                           #--- NPUSHB    19 64 4 6 9 4 3 10 64 3 1 9 3 4 10 8 4 6 10 3 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       3          ;Move Direct Absolute Point
SHP[rp1]        10         ;SHift Point using reference point
MIRP[min,black] estemtc 4  ;Move Indirect Relative Point
SHP[rp2]        8          ;SHift Point using reference point
CALL            10 4 3     ;CALL function
CALL            9 1 3 64   ;CALL function
CALL            10 3 4     ;CALL function
CALL            9 6 4 64   ;CALL function
                           #--- NPUSHB    22 13 1 64 1 3 9 1 0 10 64 0 10 9 0 1 10 7 0 10 5 1 12 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       12         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
SHP[rp2]        5          ;SHift Point using reference point
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
SHP[rp2]        7          ;SHift Point using reference point
CALL            10 1 0     ;CALL function
CALL            9 10 0 64  ;CALL function
CALL            10 0 1     ;CALL function
CALL            9 3 1 64   ;CALL function
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'plusminus': """
                           #--- NPUSHB    22 64 6 8 9 6 5 10 10 6 8 0 65 4 12 5 14 2 8 0 65 4 1 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
CALL            4 65 0 8 2 ;CALL function
SHP[rp2]        14         ;SHift Point using reference point
MDAP[rnd]       5          ;Move Direct Absolute Point
SHP[rp1]        12         ;SHift Point using reference point
CALL            4 65 0 8 6 ;CALL function
SHP[rp2]        10         ;SHift Point using reference point
CALL            10 5 6     ;CALL function
CALL            9 8 6 64   ;CALL function
                           #--- NPUSHB    27 17 1 5 64 3 1 9 3 14 10 11 64 14 0 9 14 3 10 9 14 10 0 22 4 7 3 16 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       16         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
SHP[rp2]        7          ;SHift Point using reference point
CALL            4 22 0 10 14 ;CALL function
SHP[rp2]        9          ;SHift Point using reference point
CALL            10 3 14    ;CALL function
CALL            9 0 14 64  ;CALL function
SHP[rp2]        11         ;SHift Point using reference point
CALL            10 14 3    ;CALL function
CALL            9 1 3 64   ;CALL function
SHP[rp2]        5          ;SHift Point using reference point
CALL            1 17       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'q': """
                           #--- NPUSHB    20 23 6 11 3 0 15 3 0 64 5 1 9 5 17 10 17 6 5 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 5      ;CALL function
MIRP[min,black] estemtc 17 ;Move Indirect Relative Point
CALL            10 17 5    ;CALL function
CALL            9 1 5 64   ;CALL function
CALL            0 3 15     ;CALL function
CALL            0 3 11     ;CALL function
MIRP[min,black] estemtc 23 ;Move Indirect Relative Point
                           #--- PUSHB_4   26 31 8 8 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    13 8 26 29 26 31 8 0 0 10 14 20 1 1 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   1 10 0 30 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       30         ;Move Direct Absolute Point
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 1   ;Move Indirect Relative Point
SHPIX           -6 1       ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
ALIGNRP         20         ;ALIGN to Reference Point
ALIGNRP         14         ;ALIGN to Reference Point
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
SRP0            0          ;Set Reference Point 0
MDRP[rp0,min,white] 8          ;Move Direct Relative Point
MIRP[min,white] estemwc 26 ;Move Indirect Relative Point
SRP1            29         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
IP              8          ;Interpolate Point
SHPIX           -18 8      ;SHift point by a PIXel amount
MDAP[rnd]       8          ;Move Direct Absolute Point
MIRP[min,black] estemwc 26 ;Move Indirect Relative Point
                           #--- PUSHB_7   14 15 8 23 2 17 5 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            5          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
IP              2          ;Interpolate Point
SRP1            23         ;Set Reference Point 1
IP              8          ;Interpolate Point
SRP2            15         ;Set Reference Point 2
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'question': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 1 0    ;PUSH Bytes
CALL            0 1 25     ;CALL function
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] estemtc 26 ;Move Indirect Relative Point
                           #--- PUSHB_3   16 5 0    ;PUSH Bytes
CALL            0 5 16     ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] estemtc 9  ;Move Indirect Relative Point
                           #--- PUSHB_3   9 16 10   ;PUSH Bytes
CALL            10 16 9    ;CALL function
                           #--- PUSHB_4   64 9 13 9 ;PUSH Bytes
CALL            9 13 9 64  ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   28        ;PUSH Bytes
MDAP[rnd]       28         ;Move Direct Absolute Point
                           #--- PUSHB_1   13        ;PUSH Bytes
MDRP[rp0,rnd,white] 13         ;Move Direct Relative Point
                           #--- PUSHB_2   12 10     ;PUSH Bytes
MIRP[min,black] estemw 12  ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   24 12     ;PUSH Bytes
MIRP[min,black] ecstemw 24 ;Move Indirect Relative Point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP0            24         ;Set Reference Point 0
                           #--- PUSHB_2   6 1       ;PUSH Bytes
CALL            1 6        ;CALL function
                           #--- PUSHB_2   19 10     ;PUSH Bytes
MIRP[min,black] estemw 19  ;Move Indirect Relative Point
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   12 13     ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_2   0 25      ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_3   4 9 16    ;PUSH Bytes
IP              16         ;Interpolate Point
IP              9          ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_2   19 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   9 26      ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_2   0 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotedbl': """
                           #--- NPUSHB    10 6 1 6 0 9 4 9 3 5 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 5 3      ;CALL function
SHP[rp1]        9          ;SHift Point using reference point
CALL            4 9 0 6 1  ;CALL function
SHP[rp2]        6          ;SHift Point using reference point
                           #--- NPUSHB    41 13 1 6 10 0 13 4 7 7 10 0 13 4 6 11 8 8 11 10 8 1 5 0 10 0 13 4 1 1 10 0 13 4 0 5 2 8 5 10 2 12 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       12         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
MIRP[min,black] estemw 5   ;Move Indirect Relative Point
CALL            8 2 5 0    ;CALL function
CALL            4 13 0 10 1 ;CALL function
MDAP[rnd]       1          ;Move Direct Absolute Point
CALL            4 13 0 10 0 ;CALL function
SRP0            5          ;Set Reference Point 0
CALL            1 8        ;CALL function
MIRP[min,black] estemw 11  ;Move Indirect Relative Point
CALL            8 8 11 6   ;CALL function
CALL            4 13 0 10 7 ;CALL function
MDAP[rnd]       7          ;Move Direct Absolute Point
CALL            4 13 0 10 6 ;CALL function
CALL            1 13       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotedblbase': """
                           #--- NPUSHB    8 3 7 6 0 8 4 1 6 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       6          ;Move Direct Absolute Point
SHP[rp1]        1          ;SHift Point using reference point
CALL            4 8 0 6 7  ;CALL function
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_3   9 1 8     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
CALL            1 9        ;CALL function
                           #--- PUSHB_3   0 7 6     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            6          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotedblleft': """
                           #--- NPUSHB    8 6 2 6 0 8 4 0 4 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
SHP[rp1]        0          ;SHift Point using reference point
CALL            4 8 0 6 2  ;CALL function
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_3   9 1 8     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotedblright': """
                           #--- NPUSHB    8 0 7 6 0 8 4 1 6 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       6          ;Move Direct Absolute Point
SHP[rp1]        1          ;SHift Point using reference point
CALL            4 8 0 6 7  ;CALL function
SHP[rp2]        0          ;SHift Point using reference point
                           #--- PUSHB_3   9 1 8     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quoteleft': """
                           #--- PUSHB_6   3 6 0 8 4 1 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       1          ;Move Direct Absolute Point
CALL            4 8 0 6 3  ;CALL function
                           #--- NPUSHB    9 5 1 0 12 0 10 4 2 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
CALL            4 10 0 12 0 ;CALL function
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotereversed': """
                           #--- PUSHB_6   3 6 0 8 4 2 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       2          ;Move Direct Absolute Point
CALL            4 8 0 6 3  ;CALL function
                           #--- NPUSHB    9 5 1 0 12 0 11 4 2 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
CALL            4 11 0 12 0 ;CALL function
CALL            1 5        ;CALL function
                           #--- PUSHB_3   0 3 2     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            2          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quoteright': """
                           #--- PUSHB_6   3 6 0 8 4 2 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       2          ;Move Direct Absolute Point
CALL            4 8 0 6 3  ;CALL function
                           #--- NPUSHB    9 5 1 0 12 0 10 4 2 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
CALL            4 10 0 12 0 ;CALL function
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotesinglbase': """
                           #--- PUSHB_6   3 6 0 8 4 2 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       2          ;Move Direct Absolute Point
CALL            4 8 0 6 3  ;CALL function
                           #--- NPUSHB    9 5 1 0 12 0 11 4 2 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
CALL            4 11 0 12 0 ;CALL function
CALL            1 5        ;CALL function
                           #--- PUSHB_3   0 3 2     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            2          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'quotesingle': """
                           #--- NPUSHB    8 1 6 0 8 4 3 5 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 5 3      ;CALL function
CALL            4 8 0 6 1  ;CALL function
                           #--- NPUSHB    17 7 1 0 10 0 22 4 1 5 2 8 5 12 5 12 2 6 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       6          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
MIRP[min,black] ecstemw 5  ;Move Indirect Relative Point
MIRP[min,black] ecstemw 5  ;Move Indirect Relative Point
CALL            8 2 5 1    ;CALL function
CALL            4 22 0 10 0 ;CALL function
CALL            1 7        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'r': """
                           #--- NPUSHB    11 13 6 6 3 0 1 3 0 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 3 1      ;CALL function
CALL            0 3 6      ;CALL function
MIRP[min,black] estemtc 13 ;Move Indirect Relative Point
                           #--- PUSHB_5   3 17 10 0 0 ;PUSH Bytes
                           #--- PUSHW_1   -12       ;PUSH Words
                           #--- PUSHB_5   0 17 18 17 19 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       19         ;Move Direct Absolute Point
MDRP[rp0,min,white] 17         ;Move Direct Relative Point
SRP1            18         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -12 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] estemw 17  ;Move Indirect Relative Point
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_6   3 9 1 10 13 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
IP              10         ;Interpolate Point
SRP1            1          ;Set Reference Point 1
IP              9          ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'registered': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   12 7 0 56 4 ;PUSH Bytes
CALL            4 56 0 7 12 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_2   46 7      ;PUSH Bytes
MIRP[min,black] cvt_7 46   ;Move Indirect Relative Point
                           #--- PUSHB_3   27 46 10  ;PUSH Bytes
CALL            10 46 27   ;CALL function
                           #--- PUSHB_4   64 27 29 9 ;PUSH Bytes
CALL            9 29 27 64 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_1   45        ;PUSH Bytes
MDAP[rnd]       45         ;Move Direct Absolute Point
                           #--- PUSHB_2   31 7      ;PUSH Bytes
MIRP[min,black] cvt_7 31   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_5   6 7 0 56 4 ;PUSH Bytes
CALL            4 56 0 7 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   21 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_5   28 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 28 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_5   34 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   9 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 9 ;CALL function
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   41 28     ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_6   6 0 18 26 12 37 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              37 12 26 18 0 6 ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_5   9 15 21 3 37 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              37 3 21 15 9 ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    's': """
                           #--- NPUSHB    24 64 22 19 9 22 15 10 22 6 15 3 0 64 4 0 9 4 33 10 4 6 33 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 33     ;CALL function
MIRP[min,black] estemtc 4  ;Move Indirect Relative Point
CALL            10 33 4    ;CALL function
CALL            9 0 4 64   ;CALL function
CALL            0 3 15     ;CALL function
MIRP[min,black] estemtc 22 ;Move Indirect Relative Point
CALL            10 15 22   ;CALL function
CALL            9 19 22 64 ;CALL function
                           #--- NPUSHB    20 9 10 7 12 28 27 30 25 18 6 19 7 25 10 12 0 1 6 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 1 36 1 6 0 30 30 31 7 7 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   7 31 30 37 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       37         ;Move Direct Absolute Point
MDRP[rp0,min,white] 30         ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 7  ;Move Indirect Relative Point
SHPIX           -6 7       ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] estemwc 30 ;Move Indirect Relative Point
SRP0            30         ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] estemtc 1  ;Move Indirect Relative Point
SRP1            36         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] estemtc 1  ;Move Indirect Relative Point
SRP0            0          ;Set Reference Point 0
MDRP[rp0,rnd,grey] 12         ;Move Direct Relative Point
MIRP[min,black] estemw 25  ;Move Indirect Relative Point
SRP0            7          ;Set Reference Point 0
MDRP[rp0,rnd,grey] 19         ;Move Direct Relative Point
MIRP[min,black] estemtc 18 ;Move Indirect Relative Point
SRP1            25         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
IP              27         ;Interpolate Point
IP              28         ;Interpolate Point
SRP1            12         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              10         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_6   9 6 28 28 4 15 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            15         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
IP              28         ;Interpolate Point
SRP0            28         ;Set Reference Point 0
MIRP[min,black] estemtc 9  ;Move Indirect Relative Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'second': """
                           #--- NPUSHB    8 7 3 6 0 7 4 5 2 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       2          ;Move Direct Absolute Point
SHP[rp1]        5          ;SHift Point using reference point
CALL            4 7 0 6 3  ;CALL function
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   9 1 8     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
CALL            1 9        ;CALL function
                           #--- PUSHB_3   4 3 2     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            2          ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
IP              4          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'section': """
                           #--- NPUSHB    26 64 52 49 9 52 44 10 44 8 0 50 4 52 64 24 21 9 24 16 10 24 8 0 50 4 16 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       16         ;Move Direct Absolute Point
CALL            4 50 0 8 24 ;CALL function
CALL            10 16 24   ;CALL function
CALL            9 21 24 64 ;CALL function
MDAP[rnd]       52         ;Move Direct Absolute Point
CALL            4 50 0 8 44 ;CALL function
CALL            10 44 52   ;CALL function
CALL            9 49 52 64 ;CALL function
                           #--- NPUSHB    75 7 8 6 59 58 60 15 14 0 59 58 60 19 58 15 14 0 19 14 7 8 6 19 8 60 58 20 6 8 8 6 0 14 19 30 31 31 30 54 73 1 69 10 0 30 4 27 27 10 0 30 4 69 62 62 10 0 30 4 3 1 11 55 10 0 30 4 41 11 10 0 30 4 34 72 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       72         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
CALL            4 30 0 10 11 ;CALL function
DUP             41         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 30 0 10 55 ;CALL function
SRP0            11         ;Set Reference Point 0
CALL            1 3        ;CALL function
CALL            4 30 0 10 62 ;CALL function
SRP0            62         ;Set Reference Point 0
DUP             69         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 30 0 10 27 ;CALL function
MDAP[rnd]       27         ;Move Direct Absolute Point
CALL            4 30 0 10 69 ;CALL function
CALL            1 73       ;CALL function
SMD             54         ;Set Minimum Distance
SDPVTL[orthog]  30 31      ;Set Dual Projection Vector To Line
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDRP[grey]      30         ;Move Direct Relative Point
MIRP[rp0,min,black] cvt_19 14  ;Move Indirect Relative Point
MDRP[grey]      0          ;Move Direct Relative Point
SDPVTL[orthog]  6 8        ;Set Dual Projection Vector To Line
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDRP[grey]      6          ;Move Direct Relative Point
MIRP[rp0,min,black] cvt_20 58  ;Move Indirect Relative Point
MDRP[grey]      60         ;Move Direct Relative Point
SRP0            8          ;Set Reference Point 0
CALL            19 6 8 7   ;CALL function
SRP0            14         ;Set Reference Point 0
CALL            19 0 14 15 ;CALL function
SRP0            58         ;Set Reference Point 0
CALL            19 60 58 59 ;CALL function
DUP             0          ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 14 ;ROLL the top three stack elements
DUP             &_ROLL_1   ;DUPlicate top stack element
ROLL            &_DUP_1 &_DUP_2 &_ROLL_2 ;ROLL the top three stack elements
SWAP            &_ROLL_1 &_ROLL_2 ;SWAP the top two elements on the stack
SPVTL[parallel] &_SWAP_1 &_SWAP_2 ;Set Projection Vector To Line
SFVTPV                     ;Set Freedom Vector To Projection Vector
SRP1            &_ROLL_3   ;Set Reference Point 1
SRP2            &_ROLL_3   ;Set Reference Point 2
IP              15         ;Interpolate Point
SRP1            60         ;Set Reference Point 1
SRP2            58         ;Set Reference Point 2
IP              59         ;Interpolate Point
SRP1            6          ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
IP              7          ;Interpolate Point
                           #--- NPUSHB    10 0 6 7 8 14 15 30 31 58 59 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[no-rnd]    59         ;Move Direct Absolute Point
MDAP[no-rnd]    58         ;Move Direct Absolute Point
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    6          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
                           #--- NPUSHB    11 64 0 6 7 8 14 15 30 31 58 59 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[no-rnd]    59         ;Move Direct Absolute Point
MDAP[no-rnd]    58         ;Move Direct Absolute Point
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    15         ;Move Direct Absolute Point
MDAP[no-rnd]    14         ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
MDAP[no-rnd]    7          ;Move Direct Absolute Point
MDAP[no-rnd]    6          ;Move Direct Absolute Point
MDAP[no-rnd]    0          ;Move Direct Absolute Point
SMD             64         ;Set Minimum Distance
                           #--- NPUSHB    19 47 49 69 65 66 3 16 24 44 52 4 27 37 38 55 19 21 11 41 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            41         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
IP              21         ;Interpolate Point
IP              19         ;Interpolate Point
SRP1            55         ;Set Reference Point 1
IP              38         ;Interpolate Point
IP              37         ;Interpolate Point
SRP2            27         ;Set Reference Point 2
SLOOP           4          ;Set LOOP variable
IP              52 44 24 16 ;Interpolate Point
SRP1            3          ;Set Reference Point 1
IP              66         ;Interpolate Point
IP              65         ;Interpolate Point
SRP2            69         ;Set Reference Point 2
IP              49         ;Interpolate Point
IP              47         ;Interpolate Point
                           #--- NPUSHB    8 47 44 41 69 52 19 24 16 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            16         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
IP              19         ;Interpolate Point
SRP1            52         ;Set Reference Point 1
IP              69         ;Interpolate Point
IP              41         ;Interpolate Point
SRP2            44         ;Set Reference Point 2
IP              47         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'semicolon': """
                           #--- NPUSHB    10 1 6 2 3 0 10 9 9 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 9      ;CALL function
MIRP[min,black] estemt 10  ;Move Indirect Relative Point
CALL            0 3 2      ;CALL function
MIRP[min,black] estemtc 1  ;Move Indirect Relative Point
                           #--- NPUSHB    18 4 12 8 16 1 8 8 10 0 13 4 12 0 12 12 1 9 15 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       15         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
SHP[rp2]        1          ;SHift Point using reference point
MIRP[min,black] ecstemw 12 ;Move Indirect Relative Point
SHP[rp2]        0          ;SHift Point using reference point
SRP0            12         ;Set Reference Point 0
CALL            4 13 0 10 8 ;CALL function
MDAP[rnd]       8          ;Move Direct Absolute Point
CALL            1 16       ;CALL function
SRP1            8          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'seven': """
                           #--- NPUSHB    8 0 9 1 5 0 7 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 7      ;CALL function
CALL            0 5 1      ;CALL function
MIRP[min,black] estemt 0   ;Move Indirect Relative Point
                           #--- NPUSHB    17 0 0 11 3 6 10 7 7 10 11 3 10 10 10 10 3 12 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       12         ;Move Direct Absolute Point
MDRP[rp0,min,white] 3          ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 10  ;Move Indirect Relative Point
MDAP[rnd]       10         ;Move Direct Absolute Point
MIRP[min,black] estemw 3   ;Move Indirect Relative Point
SRP1            11         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
IP              7          ;Interpolate Point
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] estemw 6   ;Move Indirect Relative Point
SRP1            3          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
IP              0          ;Interpolate Point
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_3   3 0 7     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            7          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'six': """
                           #--- NPUSHB    24 10 6 10 34 16 22 13 64 4 1 9 4 22 10 4 6 22 5 0 28 6 16 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 16     ;CALL function
MIRP[min,black] estemtc 28 ;Move Indirect Relative Point
CALL            0 5 22     ;CALL function
MIRP[min,black] estemtc 4  ;Move Indirect Relative Point
CALL            10 22 4    ;CALL function
CALL            9 1 4 64   ;CALL function
CALL            13 22 16 34 10 ;CALL function
MIRP[min,black] estemtc 10 ;Move Indirect Relative Point
                           #--- NPUSHB    10 0 10 1 31 25 7 7 31 19 19 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 19 7 37 7 31 19 13 13 31 31 31 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   31 31 13 38 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       38         ;Move Direct Absolute Point
MDRP[rp0,min,white] 13         ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 31 ;Move Indirect Relative Point
SHPIX           -6 31      ;SHift point by a PIXel amount
MDAP[rnd]       31         ;Move Direct Absolute Point
MIRP[min,black] estemwc 13 ;Move Indirect Relative Point
SRP0            13         ;Set Reference Point 0
MDRP[rp0,min,white] 19         ;Move Direct Relative Point
MIRP[min,white] estemwc 7  ;Move Indirect Relative Point
SRP1            37         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              19         ;Interpolate Point
SHPIX           -18 19     ;SHift point by a PIXel amount
MDAP[rnd]       19         ;Move Direct Absolute Point
MIRP[min,black] estemwc 7  ;Move Indirect Relative Point
SRP0            7          ;Set Reference Point 0
MDRP[grey]      25         ;Move Direct Relative Point
SRP0            31         ;Set Reference Point 0
MDRP[rp0,rnd,grey] 1          ;Move Direct Relative Point
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_6   7 10 19 13 34 28 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            28         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
IP              13         ;Interpolate Point
IP              19         ;Interpolate Point
SRP1            10         ;Set Reference Point 1
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'slash': """
                           #--- PUSHB_6   2 5 0 1 1 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 1      ;CALL function
CALL            0 5 2      ;CALL function
                           #--- PUSHB_3   5 1 4     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'sterling': """
                           #--- NPUSHB    33 26 6 8 24 6 7 1 15 13 20 8 0 49 4 12 16 9 15 5 0 2 9 1 1 0 32 8 0 36 4 1 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 1      ;CALL function
CALL            4 36 0 8 32 ;CALL function
CALL            0 1 1      ;CALL function
MIRP[min,black] estemt 2   ;Move Indirect Relative Point
CALL            0 5 15     ;CALL function
MIRP[min,black] estemt 16  ;Move Indirect Relative Point
DUP             12         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 49 0 8 20 ;CALL function
CALL            13 15 1 7 6 ;CALL function
SHP[rp1]        24         ;SHift Point using reference point
MIRP[min,black] cvt_8 6    ;Move Indirect Relative Point
SHP[rp2]        26         ;SHift Point using reference point
                           #--- NPUSHB    33 35 1 64 5 6 9 64 5 1 9 5 28 10 64 28 26 9 64 28 0 9 28 5 10 23 28 10 0 30 4 8 5 34 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       34         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
SHP[rp2]        8          ;SHift Point using reference point
CALL            4 30 0 10 28 ;CALL function
SHP[rp2]        23         ;SHift Point using reference point
CALL            10 5 28    ;CALL function
CALL            9 0 28 64  ;CALL function
CALL            9 26 28 64 ;CALL function
CALL            10 28 5    ;CALL function
CALL            9 1 5 64   ;CALL function
CALL            9 6 5 64   ;CALL function
CALL            1 35       ;CALL function
                           #--- PUSHB_3   31 2 32   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            32         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    't': """
                           #--- NPUSHB    17 64 9 11 9 9 8 10 13 9 9 15 8 20 6 3 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 3      ;CALL function
MIRP[min,black] estemtc 20 ;Move Indirect Relative Point
MDAP[rnd]       8          ;Move Direct Absolute Point
SHP[rp1]        15         ;SHift Point using reference point
MIRP[min,black] estemt 9   ;Move Indirect Relative Point
SHP[rp2]        13         ;SHift Point using reference point
CALL            10 8 9     ;CALL function
CALL            9 11 9 64  ;CALL function
                           #--- PUSHB_6   13 17 10 10 6 6 ;PUSH Bytes
                           #--- PUSHW_1   -12       ;PUSH Words
                           #--- PUSHB_5   6 17 22 17 23 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       23         ;Move Direct Absolute Point
MDRP[rp0,min,white] 17         ;Move Direct Relative Point
SRP1            22         ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
IP              6          ;Interpolate Point
SHPIX           -12 6      ;SHift point by a PIXel amount
MDAP[rnd]       6          ;Move Direct Absolute Point
ALIGNRP         10         ;ALIGN to Reference Point
MIRP[min,black] estemw 17  ;Move Indirect Relative Point
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_5   0 8 1 20 3 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            3          ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
IP              1          ;Interpolate Point
SRP1            8          ;Set Reference Point 1
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'three': """
                           #--- NPUSHB    28 28 0 31 8 18 9 18 13 0 31 13 24 6 31 5 0 64 7 3 9 7 0 10 7 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemtc 7  ;Move Indirect Relative Point
CALL            10 0 7     ;CALL function
CALL            9 3 7 64   ;CALL function
CALL            0 5 31     ;CALL function
MIRP[min,black] estemtc 24 ;Move Indirect Relative Point
CALL            13 31 0 13 18 ;CALL function
MIRP[min,black] estemt 18  ;Move Indirect Relative Point
CALL            8 31 0 28  ;CALL function
                           #--- NPUSHB    13 34 10 21 10 27 10 28 15 3 4 10 3 3 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 3 4 43 4 10 3 40 40 31 10 10 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   10 31 40 44 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       44         ;Move Direct Absolute Point
MDRP[rp0,min,white] 40         ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 10 ;Move Indirect Relative Point
SHPIX           -6 10      ;SHift point by a PIXel amount
MDAP[rnd]       10         ;Move Direct Absolute Point
MIRP[min,black] estemwc 40 ;Move Indirect Relative Point
SRP0            40         ;Set Reference Point 0
MDRP[rp0,min,white] 3          ;Move Direct Relative Point
MIRP[min,white] estemw 4   ;Move Indirect Relative Point
SRP1            43         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
IP              3          ;Interpolate Point
SHPIX           -18 3      ;SHift point by a PIXel amount
MDAP[rnd]       3          ;Move Direct Absolute Point
MIRP[min,black] estemw 4   ;Move Indirect Relative Point
SRP0            3          ;Set Reference Point 0
MDRP[rnd,grey]  15         ;Move Direct Relative Point
MDRP[rp0,rnd,grey] 28         ;Move Direct Relative Point
MIRP[min,black] estemw 27  ;Move Indirect Relative Point
SRP0            10         ;Set Reference Point 0
MDRP[rp0,rnd,grey] 21         ;Move Direct Relative Point
MIRP[min,black] estemw 34  ;Move Indirect Relative Point
                           #--- NPUSHB    10 21 34 24 28 37 18 15 40 13 7 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            7          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
IP              40         ;Interpolate Point
IP              15         ;Interpolate Point
SRP1            18         ;Set Reference Point 1
IP              37         ;Interpolate Point
SRP1            28         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
IP              34         ;Interpolate Point
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'two': """
                           #--- NPUSHB    17 64 9 13 9 9 16 10 9 9 16 5 0 24 9 1 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 1      ;CALL function
MIRP[min,black] estemt 24  ;Move Indirect Relative Point
CALL            0 5 16     ;CALL function
MIRP[min,black] estemt 9   ;Move Indirect Relative Point
CALL            10 16 9    ;CALL function
CALL            9 13 9 64  ;CALL function
                           #--- NPUSHB    10 25 19 12 10 13 1 24 32 1 1 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 1 24 26 24 32 1 19 19 10 6 6 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   6 10 19 27 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       27         ;Move Direct Absolute Point
MDRP[rp0,min,white] 19         ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 6   ;Move Indirect Relative Point
SHPIX           -6 6       ;SHift point by a PIXel amount
MDAP[rnd]       6          ;Move Direct Absolute Point
MIRP[min,black] estemw 19  ;Move Indirect Relative Point
SRP0            19         ;Set Reference Point 0
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[min,white] 32 24      ;Move Indirect Relative Point
SRP1            26         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
IP              1          ;Interpolate Point
SHPIX           -18 1      ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] 32 24      ;Move Indirect Relative Point
SRP0            1          ;Set Reference Point 0
MDRP[rp0,rnd,grey] 13         ;Move Direct Relative Point
MIRP[min,black] estemw 12  ;Move Indirect Relative Point
SRP0            19         ;Set Reference Point 0
MDRP[grey]      25         ;Move Direct Relative Point
                           #--- PUSHB_4   3 19 9 24 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            24         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
IP              19         ;Interpolate Point
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'u': """
                           #--- NPUSHB    12 0 10 3 0 15 6 6 1 0 2 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 2      ;CALL function
CALL            0 1 6      ;CALL function
MIRP[min,black] estemtc 15 ;Move Indirect Relative Point
CALL            0 3 10     ;CALL function
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_4   11 10 10 10 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    12 10 11 20 11 10 10 1 1 10 3 19 19 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   19 10 1 21 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       21         ;Move Direct Absolute Point
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 19  ;Move Indirect Relative Point
SHPIX           -6 19      ;SHift point by a PIXel amount
MDAP[rnd]       19         ;Move Direct Absolute Point
ALIGNRP         3          ;ALIGN to Reference Point
MIRP[min,black] estemw 1   ;Move Indirect Relative Point
SRP0            1          ;Set Reference Point 0
MDRP[rp0,min,white] 10         ;Move Direct Relative Point
MIRP[min,white] estemw 11  ;Move Indirect Relative Point
SRP1            20         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
IP              10         ;Interpolate Point
SHPIX           -18 10     ;SHift point by a PIXel amount
MDAP[rnd]       10         ;Move Direct Absolute Point
MIRP[min,black] estemw 11  ;Move Indirect Relative Point
                           #--- PUSHB_3   3 15 2    ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            2          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'underscore': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] estemt 1   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 0 0     ;PUSH Bytes
CALL            0 0 0      ;CALL function
                           #--- PUSHB_2   1 9       ;PUSH Bytes
MIRP[min,black] estemt 1   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'underscoredbl': """
                           #--- NPUSHB    8 2 7 1 6 7 5 0 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 5      ;CALL function
MIRP[min,black] cvt_7 6    ;Move Indirect Relative Point
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   9 1 8     ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni00A0': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   5 1 0     ;PUSH Bytes
CALL            0 1 5      ;CALL function
                           #--- PUSHB_3   6 3 0     ;PUSH Bytes
CALL            0 3 6      ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 9       ;PUSH Bytes
MIRP[min,black] estemt 2   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   6         ;PUSH Bytes
MDRP[rp0,rnd,white] 6          ;Move Direct Relative Point
                           #--- PUSHB_5   7 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 7 ;CALL function
                           #--- PUSHB_4   22 6 1 14 ;PUSH Bytes
CALL            14 1 6 22  ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_5   0 10 0 30 4 ;PUSH Bytes
CALL            4 30 0 10 0 ;CALL function
                           #--- PUSHB_1   4         ;PUSH Bytes
SHP[rp2]        4          ;SHift Point using reference point
                           #--- PUSHB_2   9 1       ;PUSH Bytes
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni00AD': """
                           #--- NPUSHB    26 6 7 0 56 4 18 31 7 45 24 64 27 29 9 27 46 10 46 7 27 12 7 0 56 4 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       0          ;Move Direct Absolute Point
CALL            4 56 0 7 12 ;CALL function
MDAP[rnd]       27         ;Move Direct Absolute Point
MIRP[min,black] cvt_7 46   ;Move Indirect Relative Point
CALL            10 46 27   ;CALL function
CALL            9 29 27 64 ;CALL function
SHP[rp2]        24         ;SHift Point using reference point
MDAP[rnd]       45         ;Move Direct Absolute Point
MIRP[min,black] cvt_7 31   ;Move Indirect Relative Point
MDAP[rnd]       18         ;Move Direct Absolute Point
CALL            4 56 0 7 6 ;CALL function
                           #--- NPUSHB    47 24 15 25 34 6 0 18 26 12 37 6 41 28 48 1 9 10 0 13 4 15 1 34 34 10 0 22 4 41 1 28 45 28 10 0 22 4 29 1 21 21 10 0 13 4 3 47 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       47         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
CALL            4 13 0 10 21 ;CALL function
SRP0            21         ;Set Reference Point 0
CALL            1 29       ;CALL function
CALL            4 22 0 10 28 ;CALL function
SHP[rp2]        45         ;SHift Point using reference point
SRP0            28         ;Set Reference Point 0
CALL            1 41       ;CALL function
CALL            4 22 0 10 34 ;CALL function
SRP0            34         ;Set Reference Point 0
CALL            1 15       ;CALL function
CALL            4 13 0 10 9 ;CALL function
CALL            1 48       ;CALL function
SRP1            28         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
SLOOP           6          ;Set LOOP variable
IP              37 12 26 18 0 6 ;Interpolate Point
SRP1            34         ;Set Reference Point 1
IP              25         ;Interpolate Point
SRP2            15         ;Set Reference Point 2
IP              24         ;Interpolate Point
                           #--- NPUSHB    10 34 45 9 15 21 3 37 5 46 27 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            27         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
SLOOP           5          ;Set LOOP variable
IP              37 3 21 15 9 ;Interpolate Point
SRP1            45         ;Set Reference Point 1
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni00B2': """
                           #--- NPUSHB    14 27 8 1 11 8 19 15 9 0 33 4 16 5 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 5 16     ;CALL function
CALL            4 33 0 9 15 ;CALL function
DUP             19         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
MIRP[min,black] cvt_8 11   ;Move Indirect Relative Point
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] cvt_8 27   ;Move Indirect Relative Point
                           #--- NPUSHB    24 30 1 15 64 8 1 9 8 22 10 64 22 0 9 22 8 10 22 10 0 22 4 8 29 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       29         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
CALL            4 22 0 10 22 ;CALL function
CALL            10 8 22    ;CALL function
CALL            9 0 22 64  ;CALL function
CALL            10 22 8    ;CALL function
CALL            9 1 8 64   ;CALL function
SHP[rp2]        15         ;SHift Point using reference point
CALL            1 30       ;CALL function
                           #--- PUSHB_5   8 2 22 15 27 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            27         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
IP              22         ;Interpolate Point
IP              2          ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni00B3': """
                           #--- NPUSHB    15 31 8 23 16 8 15 4 9 0 33 4 3 8 8 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] cvt_8 8    ;Move Indirect Relative Point
DUP             3          ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 33 0 9 4 ;CALL function
MDAP[rnd]       15         ;Move Direct Absolute Point
MIRP[min,black] cvt_8 16   ;Move Indirect Relative Point
MDAP[rnd]       23         ;Move Direct Absolute Point
MIRP[min,black] cvt_8 31   ;Move Indirect Relative Point
                           #--- NPUSHB    22 45 1 34 10 0 22 4 20 20 10 0 22 4 34 41 41 10 0 22 4 11 44 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       44         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 11         ;Move Direct Relative Point
CALL            4 22 0 10 41 ;CALL function
SRP0            41         ;Set Reference Point 0
DUP             34         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
CALL            4 22 0 10 20 ;CALL function
MDAP[rnd]       20         ;Move Direct Absolute Point
CALL            4 22 0 10 34 ;CALL function
CALL            1 45       ;CALL function
                           #--- NPUSHB    13 28 31 26 27 34 23 37 38 16 11 41 15 4 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            4          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
IP              41         ;Interpolate Point
IP              11         ;Interpolate Point
SRP1            16         ;Set Reference Point 1
IP              38         ;Interpolate Point
IP              37         ;Interpolate Point
SRP2            23         ;Set Reference Point 2
IP              34         ;Interpolate Point
IP              27         ;Interpolate Point
IP              26         ;Interpolate Point
SRP1            31         ;Set Reference Point 1
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E01': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 1 0    ;PUSH Bytes
CALL            0 1 14     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 4 0    ;PUSH Bytes
CALL            0 4 21     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_2   13 10     ;PUSH Bytes
MIRP[min,black] estemw 13  ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   13 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   8 17      ;PUSH Bytes
IP              17         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_3   5 9 21    ;PUSH Bytes
IP              21         ;Interpolate Point
IP              9          ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E02': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 1 0    ;PUSH Bytes
CALL            0 1 23     ;CALL function
                           #--- PUSHB_2   18 9      ;PUSH Bytes
MIRP[min,black] estemt 18  ;Move Indirect Relative Point
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_3   12 4 0    ;PUSH Bytes
CALL            0 4 12     ;CALL function
                           #--- PUSHB_5   29 8 0 36 4 ;PUSH Bytes
CALL            4 36 0 8 29 ;CALL function
                           #--- PUSHB_5   31 6 23 12 13 ;PUSH Bytes
CALL            13 12 23 6 31 ;CALL function
                           #--- PUSHB_2   31 8      ;PUSH Bytes
MIRP[min,black] cvt_8 31   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   43        ;PUSH Bytes
MDAP[rnd]       43         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   40 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 40 ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   18 10     ;PUSH Bytes
MIRP[min,black] estemw 18  ;Move Indirect Relative Point
                           #--- PUSHB_4   3 18 24 8 ;PUSH Bytes
CALL            8 24 18 3  ;CALL function
                           #--- PUSHB_5   34 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
MDAP[rnd]       34         ;Move Direct Absolute Point
                           #--- PUSHB_5   3 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 3 ;CALL function
                           #--- PUSHB_4   26 18 24 8 ;PUSH Bytes
CALL            8 24 18 26 ;CALL function
                           #--- PUSHB_2   15 10     ;PUSH Bytes
MIRP[min,black] estemw 15  ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   22 10     ;PUSH Bytes
MIRP[min,black] estemw 22  ;Move Indirect Relative Point
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_2   34 40     ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_2   3 24      ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            3          ;Set Reference Point 2
                           #--- PUSHB_2   12 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              12         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_5   0 15 26 9 37 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              37 9 26 15 0 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E03': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   34 9      ;PUSH Bytes
MIRP[min,black] estemt 34  ;Move Indirect Relative Point
                           #--- PUSHB_3   36 4 0    ;PUSH Bytes
CALL            0 4 36     ;CALL function
                           #--- PUSHB_2   26 28     ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
SHP[rp1]        26         ;SHift Point using reference point
                           #--- PUSHB_3   14 2 0    ;PUSH Bytes
CALL            0 2 14     ;CALL function
                           #--- PUSHB_2   44 8      ;PUSH Bytes
MIRP[min,black] cvt_8 44   ;Move Indirect Relative Point
                           #--- PUSHB_5   38 20 1 14 13 ;PUSH Bytes
CALL            13 14 1 20 38 ;CALL function
                           #--- PUSHB_2   38 8      ;PUSH Bytes
MIRP[min,black] cvt_8 38   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   50        ;PUSH Bytes
MDAP[rnd]       50         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_5   47 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 47 ;CALL function
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP0            47         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   34 10     ;PUSH Bytes
MIRP[min,black] estemw 34  ;Move Indirect Relative Point
                           #--- PUSHB_4   17 34 2 8 ;PUSH Bytes
CALL            8 2 34 17  ;CALL function
                           #--- PUSHB_5   41 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 41 ;CALL function
                           #--- PUSHB_1   41        ;PUSH Bytes
MDAP[rnd]       41         ;Move Direct Absolute Point
                           #--- PUSHB_5   17 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 17 ;CALL function
                           #--- PUSHB_4   4 34 2 8  ;PUSH Bytes
CALL            8 2 34 4   ;CALL function
                           #--- PUSHB_2   31 10     ;PUSH Bytes
MIRP[min,black] estemw 31  ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
CALL            1 51       ;CALL function
                           #--- PUSHB_2   41 47     ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_5   9 14 20 26 12 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              12 26 20 14 9 ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_2   8 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   4 17      ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   44 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   23 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_4   4 12 8 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 8 12 4  ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_3   9 7 27    ;PUSH Bytes
IP              27         ;Interpolate Point
IP              7          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E04': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   38 4 0    ;PUSH Bytes
CALL            0 4 38     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   23 42 29 38 13 ;PUSH Bytes
CALL            13 38 29 42 23 ;CALL function
                           #--- PUSHB_2   23 8      ;PUSH Bytes
MIRP[min,black] cvt_8 23   ;Move Indirect Relative Point
                           #--- PUSHB_5   17 48 29 38 13 ;PUSH Bytes
CALL            13 38 29 48 17 ;CALL function
                           #--- PUSHB_2   17 8      ;PUSH Bytes
MIRP[min,black] cvt_8 17   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_2   8 10      ;PUSH Bytes
MIRP[min,black] estemw 8   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   20 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 20 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   8 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_1   29        ;PUSH Bytes
IP              29         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_6   5 17 23 28 38 51 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              51 38 28 23 17 5 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   11 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_3   8 35 20   ;PUSH Bytes
IP              20         ;Interpolate Point
IP              35         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E05': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   30 1 0    ;PUSH Bytes
CALL            0 1 30     ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_3   38 4 0    ;PUSH Bytes
CALL            0 4 38     ;CALL function
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp1]        40         ;SHift Point using reference point
                           #--- PUSHB_5   24 42 30 38 13 ;PUSH Bytes
CALL            13 38 30 42 24 ;CALL function
                           #--- PUSHB_2   24 8      ;PUSH Bytes
MIRP[min,black] cvt_8 24   ;Move Indirect Relative Point
                           #--- PUSHB_5   18 48 30 38 13 ;PUSH Bytes
CALL            13 38 30 48 18 ;CALL function
                           #--- PUSHB_2   18 8      ;PUSH Bytes
MIRP[min,black] cvt_8 18   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   36        ;PUSH Bytes
MDRP[rp0,rnd,white] 36         ;Move Direct Relative Point
                           #--- PUSHB_2   9 10      ;PUSH Bytes
MIRP[min,black] estemw 9   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   21 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   1 10      ;PUSH Bytes
MIRP[min,black] estemw 1   ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   9 36      ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_7   6 18 24 29 38 39 51 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              51 39 38 29 24 18 6 ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   5 40      ;PUSH Bytes
IP              40         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 30     ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   12 34     ;PUSH Bytes
IP              34         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_3   9 36 21   ;PUSH Bytes
IP              21         ;Interpolate Point
IP              36         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_2   38 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_4   6 7 5 39  ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              39 5 7 6   ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E06': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 1 0    ;PUSH Bytes
CALL            0 1 35     ;CALL function
                           #--- PUSHB_3   39 1 0    ;PUSH Bytes
CALL            0 1 39     ;CALL function
                           #--- PUSHB_2   62 8      ;PUSH Bytes
MIRP[min,black] cvt_8 62   ;Move Indirect Relative Point
                           #--- PUSHB_3   32 4 0    ;PUSH Bytes
CALL            0 4 32     ;CALL function
                           #--- PUSHB_2   22 24     ;PUSH Bytes
SHP[rp1]        24         ;SHift Point using reference point
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   56 8      ;PUSH Bytes
MIRP[min,black] cvt_8 56   ;Move Indirect Relative Point
                           #--- PUSHB_5   68 45 39 10 13 ;PUSH Bytes
CALL            13 10 39 45 68 ;CALL function
                           #--- PUSHB_2   68 8      ;PUSH Bytes
MIRP[min,black] cvt_8 68   ;Move Indirect Relative Point
                           #--- PUSHB_5   50 16 39 10 13 ;PUSH Bytes
CALL            13 10 39 16 50 ;CALL function
                           #--- PUSHB_2   50 8      ;PUSH Bytes
MIRP[min,black] cvt_8 50   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDRP[rp0,rnd,white] 42         ;Move Direct Relative Point
                           #--- PUSHB_5   71 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 71 ;CALL function
                           #--- PUSHB_4   59 71 42 8 ;PUSH Bytes
CALL            8 42 71 59 ;CALL function
                           #--- PUSHB_5   19 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_5   59 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 59 ;CALL function
                           #--- PUSHB_1   71        ;PUSH Bytes
SRP0            71         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_5   13 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   0 1       ;PUSH Bytes
CALL            1 0        ;CALL function
                           #--- PUSHB_2   27 10     ;PUSH Bytes
MIRP[min,black] estemw 27  ;Move Indirect Relative Point
                           #--- PUSHB_4   29 27 0 8 ;PUSH Bytes
CALL            8 0 27 29  ;CALL function
                           #--- PUSHB_2   47 10     ;PUSH Bytes
MIRP[min,black] estemw 47  ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SHP[rp1]        65         ;SHift Point using reference point
                           #--- PUSHB_2   29 10     ;PUSH Bytes
MIRP[min,black] estemw 29  ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   34 10     ;PUSH Bytes
MIRP[min,black] estemw 34  ;Move Indirect Relative Point
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_2   71 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            71         ;Set Reference Point 2
                           #--- PUSHB_7   5 10 16 22 50 56 8 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              8 56 50 22 16 10 5 ;Interpolate Point
                           #--- PUSHB_2   47 53     ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_6   23 4 45 39 62 68 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              68 62 39 45 4 23 ;Interpolate Point
                           #--- PUSHB_2   0 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   31 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   68 62     ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            68         ;Set Reference Point 2
                           #--- PUSHB_3   36 42 31  ;PUSH Bytes
IP              31         ;Interpolate Point
IP              42         ;Interpolate Point
IP              36         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_2   56 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_2   19 13     ;PUSH Bytes
IP              13         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_4   0 8 4 27  ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              27 4 8 0   ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_3   5 3 23    ;PUSH Bytes
IP              23         ;Interpolate Point
IP              3          ;Interpolate Point
IP              5          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E07': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   9 6       ;PUSH Bytes
MIRP[min,black] estemtc 9  ;Move Indirect Relative Point
                           #--- PUSHB_3   21 4 0    ;PUSH Bytes
CALL            0 4 21     ;CALL function
                           #--- PUSHB_2   34 8      ;PUSH Bytes
MIRP[min,black] cvt_8 34   ;Move Indirect Relative Point
                           #--- PUSHB_5   28 15 0 21 13 ;PUSH Bytes
CALL            13 21 0 15 28 ;CALL function
                           #--- PUSHB_2   28 8      ;PUSH Bytes
MIRP[min,black] cvt_8 28   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   37 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 37 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   12 1      ;PUSH Bytes
CALL            1 12       ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_2   25 10     ;PUSH Bytes
MIRP[min,black] estemw 25  ;Move Indirect Relative Point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   12 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_6   9 0 15 21 28 34 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              34 28 21 15 0 9 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   15 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E08': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   25 1 0    ;PUSH Bytes
CALL            0 1 25     ;CALL function
                           #--- PUSHB_2   4 6       ;PUSH Bytes
MIRP[min,black] estemtc 4  ;Move Indirect Relative Point
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] estemtc 11 ;Move Indirect Relative Point
                           #--- PUSHB_5   31 40 25 18 13 ;PUSH Bytes
CALL            13 18 25 40 31 ;CALL function
                           #--- PUSHB_2   31 8      ;PUSH Bytes
MIRP[min,black] cvt_8 31   ;Move Indirect Relative Point
                           #--- PUSHB_5   37 46 25 18 13 ;PUSH Bytes
CALL            13 18 25 46 37 ;CALL function
                           #--- PUSHB_2   37 8      ;PUSH Bytes
MIRP[min,black] cvt_8 37   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_5   49 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   1 10      ;PUSH Bytes
MIRP[min,black] estemw 1   ;Move Indirect Relative Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP0            1          ;Set Reference Point 0
                           #--- PUSHB_2   7 1       ;PUSH Bytes
CALL            1 7        ;CALL function
                           #--- PUSHB_2   22 10     ;PUSH Bytes
MIRP[min,black] estemw 22  ;Move Indirect Relative Point
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   49 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_4   31 37 40 46 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              46 40 37 31 ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   11 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   40 31     ;PUSH Bytes
SRP1            31         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_2   1 29      ;PUSH Bytes
IP              29         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_2   0 34      ;PUSH Bytes
IP              34         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_2   11 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   14 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E09': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   36 1 0    ;PUSH Bytes
CALL            0 1 36     ;CALL function
                           #--- PUSHB_2   52 8      ;PUSH Bytes
MIRP[min,black] cvt_8 52   ;Move Indirect Relative Point
                           #--- PUSHB_3   26 4 0    ;PUSH Bytes
CALL            0 4 26     ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] estemtc 19 ;Move Indirect Relative Point
                           #--- PUSHB_5   4 40 36 26 13 ;PUSH Bytes
CALL            13 26 36 40 4 ;CALL function
                           #--- PUSHB_2   4 8       ;PUSH Bytes
MIRP[min,black] cvt_8 4    ;Move Indirect Relative Point
                           #--- PUSHB_5   10 46 36 26 13 ;PUSH Bytes
CALL            13 26 36 46 10 ;CALL function
                           #--- PUSHB_2   10 8      ;PUSH Bytes
MIRP[min,black] cvt_8 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_5   49 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   14 10     ;PUSH Bytes
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   30 10     ;PUSH Bytes
MIRP[min,black] estemw 30  ;Move Indirect Relative Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP0            30         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_5   33 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 33 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   49 7      ;PUSH Bytes
SRP1            7          ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_4   4 10 40 46 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              46 40 10 4 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_3   19 26 39  ;PUSH Bytes
IP              39         ;Interpolate Point
IP              26         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_4   36 52 58 61 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              61 58 52 36 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 52      ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_4   14 33 39 58 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              58 39 33 14 ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_3   2 15 30   ;PUSH Bytes
IP              30         ;Interpolate Point
IP              15         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_2   19 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   22 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   42 9      ;PUSH Bytes
MIRP[min,black] estemt 42  ;Move Indirect Relative Point
                           #--- PUSHB_3   21 4 0    ;PUSH Bytes
CALL            0 4 21     ;CALL function
                           #--- PUSHB_5   7 8 0 36 4 ;PUSH Bytes
CALL            4 36 0 8 7 ;CALL function
                           #--- PUSHB_5   43 15 1 21 13 ;PUSH Bytes
CALL            13 21 1 15 43 ;CALL function
                           #--- PUSHB_2   43 8      ;PUSH Bytes
MIRP[min,black] cvt_8 43   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDRP[rp0,rnd,white] 18         ;Move Direct Relative Point
                           #--- PUSHB_5   52 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 52 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   42 10     ;PUSH Bytes
MIRP[min,black] estemw 42  ;Move Indirect Relative Point
                           #--- PUSHB_4   12 42 2 8 ;PUSH Bytes
CALL            8 2 42 12  ;CALL function
                           #--- PUSHB_5   46 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 46 ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
MDAP[rnd]       46         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 12 ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP0            42         ;Set Reference Point 0
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
DUP             27         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_2   30 10     ;PUSH Bytes
MIRP[min,black] estemw 30  ;Move Indirect Relative Point
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_2   46 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_2   15 9      ;PUSH Bytes
IP              9          ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_2   12 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   7 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_1   4         ;PUSH Bytes
IP              4          ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_2   24 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              24         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 43      ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_7   4 9 18 24 33 39 49 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              49 39 33 24 18 9 4 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   49 9      ;PUSH Bytes
MIRP[min,black] estemt 49  ;Move Indirect Relative Point
                           #--- PUSHB_3   26 4 0    ;PUSH Bytes
CALL            0 4 26     ;CALL function
                           #--- PUSHB_2   28 34     ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_3   14 2 0    ;PUSH Bytes
CALL            0 2 14     ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp1]        31         ;SHift Point using reference point
                           #--- PUSHB_2   56 8      ;PUSH Bytes
MIRP[min,black] cvt_8 56   ;Move Indirect Relative Point
                           #--- PUSHB_5   50 20 1 14 13 ;PUSH Bytes
CALL            13 14 1 20 50 ;CALL function
                           #--- PUSHB_2   50 8      ;PUSH Bytes
MIRP[min,black] cvt_8 50   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_5   59 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 59 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_2   49 10     ;PUSH Bytes
MIRP[min,black] estemw 49  ;Move Indirect Relative Point
                           #--- PUSHB_4   17 49 2 8 ;PUSH Bytes
CALL            8 2 49 17  ;CALL function
                           #--- PUSHB_5   53 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 53 ;CALL function
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_5   17 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 17 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
DUP             34         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_2   37 10     ;PUSH Bytes
MIRP[min,black] estemw 37  ;Move Indirect Relative Point
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   53 59     ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_5   9 14 20 26 12 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              12 26 20 14 9 ;Interpolate Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
                           #--- PUSHB_2   8 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_2   49 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_3   7 4 28    ;PUSH Bytes
IP              28         ;Interpolate Point
IP              4          ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_2   31 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              31         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   56 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_3   23 17 46  ;PUSH Bytes
IP              46         ;Interpolate Point
IP              17         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_4   4 12 8 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 8 12 4  ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   9 7 27    ;PUSH Bytes
IP              27         ;Interpolate Point
IP              7          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   31 1 0    ;PUSH Bytes
CALL            0 1 31     ;CALL function
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp1]        5          ;SHift Point using reference point
                           #--- PUSHB_2   49 8      ;PUSH Bytes
MIRP[min,black] cvt_8 49   ;Move Indirect Relative Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SHP[rp2]        61         ;SHift Point using reference point
                           #--- PUSHB_3   47 4 0    ;PUSH Bytes
CALL            0 4 47     ;CALL function
                           #--- PUSHB_3   41 4 0    ;PUSH Bytes
CALL            0 4 41     ;CALL function
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] estemtc 15 ;Move Indirect Relative Point
                           #--- PUSHB_5   55 25 31 41 13 ;PUSH Bytes
CALL            13 41 31 25 55 ;CALL function
                           #--- PUSHB_2   55 8      ;PUSH Bytes
MIRP[min,black] cvt_8 55   ;Move Indirect Relative Point
                           #--- PUSHB_1   67        ;PUSH Bytes
SHP[rp2]        67         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   73        ;PUSH Bytes
MDAP[rnd]       73         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_2   23 10     ;PUSH Bytes
MIRP[min,black] estemw 23  ;Move Indirect Relative Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SHP[rp2]        58         ;SHift Point using reference point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_5   28 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 28 ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_5   70 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 70 ;CALL function
                           #--- PUSHB_1   70        ;PUSH Bytes
SRP0            70         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   45 10     ;PUSH Bytes
MIRP[min,black] estemw 45  ;Move Indirect Relative Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   74 1      ;PUSH Bytes
CALL            1 74       ;CALL function
                           #--- PUSHB_2   23 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_2   18 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_5   19 25 31 49 55 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              55 49 31 25 19 ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   15 41     ;PUSH Bytes
IP              41         ;Interpolate Point
IP              15         ;Interpolate Point
                           #--- PUSHB_2   45 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_4   5 61 64 67 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              67 64 61 5 ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   55 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_6   8 28 2 46 64 70 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              70 64 46 2 28 8 ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_3   11 23 45  ;PUSH Bytes
IP              45         ;Interpolate Point
IP              23         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_3   20 37 38  ;PUSH Bytes
IP              38         ;Interpolate Point
IP              37         ;Interpolate Point
IP              20         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_2   70 8      ;PUSH Bytes
MIRP[min,black] cvt_8 70   ;Move Indirect Relative Point
                           #--- PUSHB_3   35 1 0    ;PUSH Bytes
CALL            0 1 35     ;CALL function
                           #--- PUSHB_2   54 8      ;PUSH Bytes
MIRP[min,black] cvt_8 54   ;Move Indirect Relative Point
                           #--- PUSHB_3   50 4 0    ;PUSH Bytes
CALL            0 4 50     ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] estemtc 24 ;Move Indirect Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDAP[rnd]       5          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   66 8      ;PUSH Bytes
MIRP[min,black] cvt_8 66   ;Move Indirect Relative Point
                           #--- PUSHB_5   60 41 35 50 13 ;PUSH Bytes
CALL            13 50 35 41 60 ;CALL function
                           #--- PUSHB_2   60 8      ;PUSH Bytes
MIRP[min,black] cvt_8 60   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   76        ;PUSH Bytes
MDAP[rnd]       76         ;Move Direct Absolute Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[rp0,rnd,white] 38         ;Move Direct Relative Point
                           #--- PUSHB_5   63 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 63 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   31 10     ;PUSH Bytes
MIRP[min,black] estemw 31  ;Move Indirect Relative Point
                           #--- PUSHB_1   73        ;PUSH Bytes
SHP[rp2]        73         ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   57 10     ;PUSH Bytes
MIRP[min,black] estemw 57  ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_5   8 10 0 30 4 ;PUSH Bytes
CALL            4 30 0 10 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SRP0            31         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_2   63 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            63         ;Set Reference Point 2
                           #--- PUSHB_1   47        ;PUSH Bytes
IP              47         ;Interpolate Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
                           #--- PUSHB_4   35 41 54 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              60 54 41 35 ;Interpolate Point
                           #--- PUSHB_2   31 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   27 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_7   1 5 11 24 28 50 68 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              68 50 28 24 11 5 1 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   70 66     ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
SRP2            70         ;Set Reference Point 2
                           #--- PUSHB_3   8 3 20    ;PUSH Bytes
IP              20         ;Interpolate Point
IP              3          ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   54 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_3   32 38 15  ;PUSH Bytes
IP              15         ;Interpolate Point
IP              38         ;Interpolate Point
IP              32         ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   43        ;PUSH Bytes
IP              43         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_3   31 46 47  ;PUSH Bytes
IP              47         ;Interpolate Point
IP              46         ;Interpolate Point
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E0F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   41 1 0    ;PUSH Bytes
CALL            0 1 41     ;CALL function
                           #--- PUSHB_2   60 8      ;PUSH Bytes
MIRP[min,black] cvt_8 60   ;Move Indirect Relative Point
                           #--- PUSHB_3   56 4 0    ;PUSH Bytes
CALL            0 4 56     ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] estemtc 30 ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDAP[rnd]       8          ;Move Direct Absolute Point
                           #--- PUSHB_2   0 3       ;PUSH Bytes
SHP[rp1]        3          ;SHift Point using reference point
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   72 8      ;PUSH Bytes
MIRP[min,black] cvt_8 72   ;Move Indirect Relative Point
                           #--- PUSHB_1   76        ;PUSH Bytes
MDAP[rnd]       76         ;Move Direct Absolute Point
                           #--- PUSHB_2   14 8      ;PUSH Bytes
MIRP[min,black] cvt_8 14   ;Move Indirect Relative Point
                           #--- PUSHB_5   66 47 41 56 13 ;PUSH Bytes
CALL            13 56 41 47 66 ;CALL function
                           #--- PUSHB_2   66 8      ;PUSH Bytes
MIRP[min,black] cvt_8 66   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   82        ;PUSH Bytes
MDAP[rnd]       82         ;Move Direct Absolute Point
                           #--- PUSHB_1   44        ;PUSH Bytes
MDRP[rp0,rnd,white] 44         ;Move Direct Relative Point
                           #--- PUSHB_5   69 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 69 ;CALL function
                           #--- PUSHB_1   69        ;PUSH Bytes
SRP0            69         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   37 10     ;PUSH Bytes
MIRP[min,black] estemw 37  ;Move Indirect Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   63 10     ;PUSH Bytes
MIRP[min,black] estemw 63  ;Move Indirect Relative Point
                           #--- PUSHB_1   63        ;PUSH Bytes
MDAP[rnd]       63         ;Move Direct Absolute Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   19 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   83 1      ;PUSH Bytes
CALL            1 83       ;CALL function
                           #--- PUSHB_2   69 44     ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
SRP2            69         ;Set Reference Point 2
                           #--- PUSHB_1   53        ;PUSH Bytes
IP              53         ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_5   41 47 11 60 66 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              66 60 11 47 41 ;Interpolate Point
                           #--- PUSHB_2   37 63     ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_6   14 8 33 52 72 79 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              79 72 52 33 8 14 ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_2   16 74     ;PUSH Bytes
IP              74         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_7   4 6 21 30 34 35 56 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              56 35 34 30 21 6 4 ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_3   1 3 23    ;PUSH Bytes
IP              23         ;Interpolate Point
IP              3          ;Interpolate Point
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   72 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            72         ;Set Reference Point 2
                           #--- PUSHB_2   2 6       ;PUSH Bytes
IP              6          ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   76        ;PUSH Bytes
SRP1            76         ;Set Reference Point 1
                           #--- PUSHB_3   11 26 23  ;PUSH Bytes
IP              23         ;Interpolate Point
IP              26         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   16 21 24 25 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              25 24 21 16 ;Interpolate Point
                           #--- PUSHB_2   60 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   66        ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
                           #--- PUSHB_3   38 44 18  ;PUSH Bytes
IP              18         ;Interpolate Point
IP              44         ;Interpolate Point
IP              38         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_3   37 52 53  ;PUSH Bytes
IP              53         ;Interpolate Point
IP              52         ;Interpolate Point
IP              37         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E10': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 1 0    ;PUSH Bytes
CALL            0 1 11     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   44 4 0    ;PUSH Bytes
CALL            0 4 44     ;CALL function
                           #--- PUSHB_2   36 38     ;PUSH Bytes
SHP[rp1]        38         ;SHift Point using reference point
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_3   24 2 0    ;PUSH Bytes
CALL            0 2 24     ;CALL function
                           #--- PUSHB_2   54 8      ;PUSH Bytes
MIRP[min,black] cvt_8 54   ;Move Indirect Relative Point
                           #--- PUSHB_5   48 30 11 24 13 ;PUSH Bytes
CALL            13 24 11 30 48 ;CALL function
                           #--- PUSHB_2   48 8      ;PUSH Bytes
MIRP[min,black] cvt_8 48   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_5   57 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 57 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   10 10     ;PUSH Bytes
MIRP[min,black] estemw 10  ;Move Indirect Relative Point
                           #--- PUSHB_4   27 10 11 8 ;PUSH Bytes
CALL            8 11 10 27 ;CALL function
                           #--- PUSHB_5   51 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_5   27 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 27 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   51 57     ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_5   19 24 30 36 22 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              22 36 30 24 19 ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_2   18 37     ;PUSH Bytes
IP              37         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_2   10 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_3   14 17 38  ;PUSH Bytes
IP              38         ;Interpolate Point
IP              17         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_2   41 44     ;PUSH Bytes
IP              44         ;Interpolate Point
IP              41         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   54 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_2   33 27     ;PUSH Bytes
IP              27         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_3   14 22 18  ;PUSH Bytes
IP              18         ;Interpolate Point
IP              22         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   44 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_4   17 19 37 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 37 19 17 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E10.descless': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] estemtc 19 ;Move Indirect Relative Point
                           #--- PUSHB_3   35 4 0    ;PUSH Bytes
CALL            0 4 35     ;CALL function
                           #--- PUSHB_3   29 4 0    ;PUSH Bytes
CALL            0 4 29     ;CALL function
                           #--- PUSHB_2   42 6      ;PUSH Bytes
MIRP[min,black] estemtc 42 ;Move Indirect Relative Point
                           #--- PUSHB_3   32 3 0    ;PUSH Bytes
CALL            0 3 32     ;CALL function
                           #--- PUSHB_2   39 6      ;PUSH Bytes
MIRP[min,black] estemtc 39 ;Move Indirect Relative Point
                           #--- PUSHB_5   6 52 0 32 13 ;PUSH Bytes
CALL            13 32 0 52 6 ;CALL function
                           #--- PUSHB_2   6 7       ;PUSH Bytes
MIRP[min,black] cvt_7 6    ;Move Indirect Relative Point
                           #--- PUSHB_5   12 58 0 32 13 ;PUSH Bytes
CALL            13 32 0 58 12 ;CALL function
                           #--- PUSHB_2   12 7      ;PUSH Bytes
MIRP[min,black] cvt_7 12   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_5   61 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 61 ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP0            61         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   15 10     ;PUSH Bytes
MIRP[min,black] estemw 15  ;Move Indirect Relative Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   22 1      ;PUSH Bytes
CALL            1 22       ;CALL function
                           #--- PUSHB_2   49 10     ;PUSH Bytes
MIRP[min,black] estemw 49  ;Move Indirect Relative Point
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   55 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_4   3 6 12 45 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              45 12 6 3  ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_2   29 42     ;PUSH Bytes
IP              42         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
                           #--- PUSHB_2   32 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   52 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            52         ;Set Reference Point 2
                           #--- PUSHB_2   4 16      ;PUSH Bytes
IP              16         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   58        ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
                           #--- PUSHB_4   15 9 55 61 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              61 55 9 15 ;Interpolate Point
                           #--- PUSHB_2   39 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_2   36 45     ;PUSH Bytes
IP              45         ;Interpolate Point
IP              36         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E12': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp1]        44         ;SHift Point using reference point
                           #--- PUSHB_3   49 1 0    ;PUSH Bytes
CALL            0 1 49     ;CALL function
                           #--- PUSHB_2   68 8      ;PUSH Bytes
MIRP[min,black] cvt_8 68   ;Move Indirect Relative Point
                           #--- PUSHB_3   42 4 0    ;PUSH Bytes
CALL            0 4 42     ;CALL function
                           #--- PUSHB_2   35 37     ;PUSH Bytes
SHP[rp1]        37         ;SHift Point using reference point
SHP[rp1]        35         ;SHift Point using reference point
                           #--- PUSHB_5   14 56 49 35 13 ;PUSH Bytes
CALL            13 35 49 56 14 ;CALL function
                           #--- PUSHB_2   14 8      ;PUSH Bytes
MIRP[min,black] cvt_8 14   ;Move Indirect Relative Point
                           #--- PUSHB_5   20 62 49 35 13 ;PUSH Bytes
CALL            13 35 49 62 20 ;CALL function
                           #--- PUSHB_2   20 8      ;PUSH Bytes
MIRP[min,black] cvt_8 20   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   6 10      ;PUSH Bytes
MIRP[min,black] estemw 6   ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_5   65 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 65 ;CALL function
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP0            65         ;Set Reference Point 0
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_5   23 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_1   77        ;PUSH Bytes
DUP             77         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_5   52 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 52 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_5   77 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 77 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   40 10     ;PUSH Bytes
MIRP[min,black] estemw 40  ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   44 10     ;PUSH Bytes
MIRP[min,black] estemw 44  ;Move Indirect Relative Point
                           #--- PUSHB_2   81 1      ;PUSH Bytes
CALL            1 81       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   31 30     ;PUSH Bytes
SDPVTL[orthog]  30 31      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[no-rnd]    31         ;Move Direct Absolute Point
                           #--- PUSHB_1   30        ;PUSH Bytes
MDRP[grey]      30         ;Move Direct Relative Point
                           #--- PUSHB_2   8 21      ;PUSH Bytes
MIRP[rp0,min,black] cvt_21 8   ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[grey]      9          ;Move Direct Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   8 9 30 31 ;PUSH Bytes
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   8 9 30 31 ;PUSH Bytes
MDAP[no-rnd]    31         ;Move Direct Absolute Point
MDAP[no-rnd]    30         ;Move Direct Absolute Point
MDAP[no-rnd]    9          ;Move Direct Absolute Point
MDAP[no-rnd]    8          ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   6 33      ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   27 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              27         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
                           #--- PUSHB_3   4 11 35   ;PUSH Bytes
IP              35         ;Interpolate Point
IP              11         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   65        ;PUSH Bytes
SRP2            65         ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_4   3 20 36 14 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              14 36 20 3 ;Interpolate Point
                           #--- PUSHB_2   23 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   77        ;PUSH Bytes
SRP1            77         ;Set Reference Point 1
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_2   40 55     ;PUSH Bytes
SRP1            55         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   49 68 71 74 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              74 71 68 49 ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_1   46        ;PUSH Bytes
IP              46         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 68     ;PUSH Bytes
SRP1            68         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_5   11 41 46 52 74 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              74 52 46 41 11 ;Interpolate Point
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP1            56         ;Set Reference Point 1
                           #--- PUSHB_2   40 55     ;PUSH Bytes
IP              55         ;Interpolate Point
IP              40         ;Interpolate Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP2            62         ;Set Reference Point 2
                           #--- PUSHB_4   6 23 33 17 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              17 33 23 6 ;Interpolate Point
                           #--- PUSHB_2   42 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_4   3 4 2 36  ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 2 4 3   ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E13': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_2   50 8      ;PUSH Bytes
MIRP[min,black] cvt_8 50   ;Move Indirect Relative Point
                           #--- PUSHB_1   62        ;PUSH Bytes
SHP[rp2]        62         ;SHift Point using reference point
                           #--- PUSHB_3   38 4 0    ;PUSH Bytes
CALL            0 4 38     ;CALL function
                           #--- PUSHB_3   31 4 0    ;PUSH Bytes
CALL            0 4 31     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   56 15 21 31 13 ;PUSH Bytes
CALL            13 31 21 15 56 ;CALL function
                           #--- PUSHB_2   56 8      ;PUSH Bytes
MIRP[min,black] cvt_8 56   ;Move Indirect Relative Point
                           #--- PUSHB_1   68        ;PUSH Bytes
SHP[rp2]        68         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   74        ;PUSH Bytes
MDAP[rnd]       74         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   13 10     ;PUSH Bytes
MIRP[min,black] estemw 13  ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SHP[rp2]        59         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_5   18 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   36 10     ;PUSH Bytes
MIRP[min,black] estemw 36  ;Move Indirect Relative Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   40 10     ;PUSH Bytes
MIRP[min,black] estemw 40  ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP0            40         ;Set Reference Point 0
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_5   43 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 43 ;CALL function
                           #--- PUSHB_2   75 1      ;PUSH Bytes
CALL            1 75       ;CALL function
                           #--- PUSHB_2   13 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   8 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP1            53         ;Set Reference Point 1
                           #--- PUSHB_5   9 15 21 50 56 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              56 50 21 15 9 ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   5 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_4   46 62 68 71 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              71 68 62 46 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   56 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_6   18 43 49 36 65 71 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              71 65 36 49 43 18 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_3   13 37 40  ;PUSH Bytes
IP              40         ;Interpolate Point
IP              37         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   10 27 28  ;PUSH Bytes
IP              28         ;Interpolate Point
IP              27         ;Interpolate Point
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E14': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   38 4 0    ;PUSH Bytes
CALL            0 4 38     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   16 42 29 38 13 ;PUSH Bytes
CALL            13 38 29 42 16 ;CALL function
                           #--- PUSHB_2   16 8      ;PUSH Bytes
MIRP[min,black] cvt_8 16   ;Move Indirect Relative Point
                           #--- PUSHB_5   22 48 29 38 13 ;PUSH Bytes
CALL            13 38 29 48 22 ;CALL function
                           #--- PUSHB_2   22 8      ;PUSH Bytes
MIRP[min,black] cvt_8 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_2   8 10      ;PUSH Bytes
MIRP[min,black] estemw 8   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   51 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   25 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   33 32     ;PUSH Bytes
SDPVTL[orthog]  32 33      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[grey]      32         ;Move Direct Relative Point
                           #--- PUSHB_2   10 21     ;PUSH Bytes
MIRP[rp0,min,black] cvt_21 10  ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[grey]      11         ;Move Direct Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   10 11 32 33 ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    11         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   10 11 32 33 ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    11         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   8 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   29 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_2   13 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_2   45 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_4   5 22 38 16 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              16 38 22 5 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_2   48 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_3   25 35 19  ;PUSH Bytes
IP              19         ;Interpolate Point
IP              35         ;Interpolate Point
IP              25         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E15': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   29 1 0    ;PUSH Bytes
CALL            0 1 29     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   37 4 0    ;PUSH Bytes
CALL            0 4 37     ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp1]        39         ;SHift Point using reference point
                           #--- PUSHB_5   16 42 29 37 13 ;PUSH Bytes
CALL            13 37 29 42 16 ;CALL function
                           #--- PUSHB_2   16 8      ;PUSH Bytes
MIRP[min,black] cvt_8 16   ;Move Indirect Relative Point
                           #--- PUSHB_5   22 48 29 37 13 ;PUSH Bytes
CALL            13 37 29 48 22 ;CALL function
                           #--- PUSHB_2   22 8      ;PUSH Bytes
MIRP[min,black] cvt_8 22   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[rp0,rnd,white] 35         ;Move Direct Relative Point
                           #--- PUSHB_2   8 10      ;PUSH Bytes
MIRP[min,black] estemw 8   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_5   51 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   25 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   33 32     ;PUSH Bytes
SDPVTL[orthog]  32 33      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   33        ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDRP[grey]      32         ;Move Direct Relative Point
                           #--- PUSHB_2   10 21     ;PUSH Bytes
MIRP[rp0,min,black] cvt_21 10  ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDRP[grey]      11         ;Move Direct Relative Point
SPVTCA[x-axis]             ;Set Projection Vector To Coordinate Axis
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   10 11 32 33 ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    11         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_4   10 11 32 33 ;PUSH Bytes
MDAP[no-rnd]    33         ;Move Direct Absolute Point
MDAP[no-rnd]    32         ;Move Direct Absolute Point
MDAP[no-rnd]    11         ;Move Direct Absolute Point
MDAP[no-rnd]    10         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
                           #--- PUSHB_2   8 35      ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   29 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_4   6 13 28 37 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              37 28 13 6 ;Interpolate Point
                           #--- PUSHB_2   45 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_4   5 22 38 16 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              16 38 22 5 ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   4 39      ;PUSH Bytes
IP              39         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   16 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            16         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_2   48 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_4   8 25 35 19 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              19 35 25 8 ;Interpolate Point
                           #--- PUSHB_2   37 22     ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_4   5 6 4 38  ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              38 4 6 5   ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E16': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   35 8      ;PUSH Bytes
MIRP[min,black] cvt_8 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 4 0    ;PUSH Bytes
CALL            0 4 31     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   41 15 21 31 13 ;PUSH Bytes
CALL            13 31 21 15 41 ;CALL function
                           #--- PUSHB_2   41 8      ;PUSH Bytes
MIRP[min,black] cvt_8 41   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   13 10     ;PUSH Bytes
MIRP[min,black] estemw 13  ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_5   18 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   13 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   8 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_5   9 15 21 35 41 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              41 35 21 15 9 ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   5 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   10 27 28  ;PUSH Bytes
IP              28         ;Interpolate Point
IP              27         ;Interpolate Point
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E17': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   9 1 0     ;PUSH Bytes
CALL            0 1 9      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   26 4 0    ;PUSH Bytes
CALL            0 4 26     ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp1]        18         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_3   26 4 0    ;PUSH Bytes
CALL            0 4 26     ;CALL function
                           #--- PUSHB_2   36 8      ;PUSH Bytes
MIRP[min,black] cvt_8 36   ;Move Indirect Relative Point
                           #--- PUSHB_5   30 12 9 26 13 ;PUSH Bytes
CALL            13 26 9 12 30 ;CALL function
                           #--- PUSHB_2   30 8      ;PUSH Bytes
MIRP[min,black] cvt_8 30   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   15        ;PUSH Bytes
MDRP[rp0,rnd,white] 15         ;Move Direct Relative Point
                           #--- PUSHB_5   39 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 39 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP0            39         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SHP[rp2]        9          ;SHift Point using reference point
                           #--- PUSHB_2   21 10     ;PUSH Bytes
MIRP[min,black] estemw 21  ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   33 39     ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_2   12 18     ;PUSH Bytes
IP              18         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_2   1 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 9      ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_2   36 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_3   15 33 39  ;PUSH Bytes
IP              39         ;Interpolate Point
IP              33         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E18': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   4 9       ;PUSH Bytes
MIRP[min,black] estemt 4   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 1 10    ;PUSH Bytes
CALL            10 1 4     ;CALL function
                           #--- PUSHB_4   64 4 2 9  ;PUSH Bytes
CALL            9 2 4 64   ;CALL function
                           #--- PUSHB_3   18 4 0    ;PUSH Bytes
CALL            0 4 18     ;CALL function
                           #--- PUSHB_3   12 4 0    ;PUSH Bytes
CALL            0 4 12     ;CALL function
                           #--- PUSHB_2   25 6      ;PUSH Bytes
MIRP[min,black] estemtc 25 ;Move Indirect Relative Point
                           #--- PUSHB_3   15 3 0    ;PUSH Bytes
CALL            0 3 15     ;CALL function
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] estemtc 22 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   4 10      ;PUSH Bytes
MIRP[min,black] estemw 4   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP0            4          ;Set Reference Point 0
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_2   4 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_2   12 25     ;PUSH Bytes
IP              25         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   15 22     ;PUSH Bytes
IP              22         ;Interpolate Point
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   22 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
                           #--- PUSHB_2   19 28     ;PUSH Bytes
IP              28         ;Interpolate Point
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E19': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   24 1 0    ;PUSH Bytes
CALL            0 1 24     ;CALL function
                           #--- PUSHB_2   40 8      ;PUSH Bytes
MIRP[min,black] cvt_8 40   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 4 0    ;PUSH Bytes
CALL            0 4 16     ;CALL function
                           #--- PUSHB_3   10 4 0    ;PUSH Bytes
CALL            0 4 10     ;CALL function
                           #--- PUSHB_2   34 8      ;PUSH Bytes
MIRP[min,black] cvt_8 34   ;Move Indirect Relative Point
                           #--- PUSHB_5   28 4 24 10 13 ;PUSH Bytes
CALL            13 10 24 4 28 ;CALL function
                           #--- PUSHB_2   28 8      ;PUSH Bytes
MIRP[min,black] cvt_8 28   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   52        ;PUSH Bytes
MDAP[rnd]       52         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   37 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 37 ;CALL function
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_2   14 10     ;PUSH Bytes
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   18 10     ;PUSH Bytes
MIRP[min,black] estemw 18  ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_5   21 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 21 ;CALL function
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_2   1 37      ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   4 10 28 34 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              34 28 10 4 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_4   24 40 46 49 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              49 46 40 24 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   4 40      ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_6   14 15 18 21 27 46 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              46 27 21 18 15 14 ;Interpolate Point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP1            28         ;Set Reference Point 1
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] estemt 14  ;Move Indirect Relative Point
                           #--- PUSHB_3   16 4 0    ;PUSH Bytes
CALL            0 4 16     ;CALL function
                           #--- PUSHB_3   10 4 0    ;PUSH Bytes
CALL            0 4 10     ;CALL function
                           #--- PUSHB_2   24 8      ;PUSH Bytes
MIRP[min,black] cvt_8 24   ;Move Indirect Relative Point
                           #--- PUSHB_5   18 4 1 10 13 ;PUSH Bytes
CALL            13 10 1 4 18 ;CALL function
                           #--- PUSHB_2   18 8      ;PUSH Bytes
MIRP[min,black] cvt_8 18   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   27 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   14 10     ;PUSH Bytes
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   1 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   4 10 18 24 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              24 18 10 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] estemt 14  ;Move Indirect Relative Point
                           #--- PUSHB_3   10 4 0    ;PUSH Bytes
CALL            0 4 10     ;CALL function
                           #--- PUSHB_2   24 8      ;PUSH Bytes
MIRP[min,black] cvt_8 24   ;Move Indirect Relative Point
                           #--- PUSHB_3   10 24 10  ;PUSH Bytes
CALL            10 24 10   ;CALL function
                           #--- PUSHB_4   64 10 16 9 ;PUSH Bytes
CALL            9 16 10 64 ;CALL function
                           #--- PUSHB_5   18 4 1 16 13 ;PUSH Bytes
CALL            13 16 1 4 18 ;CALL function
                           #--- PUSHB_2   18 8      ;PUSH Bytes
MIRP[min,black] cvt_8 18   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   27 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_2   14 10     ;PUSH Bytes
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   31 1      ;PUSH Bytes
CALL            1 31       ;CALL function
                           #--- PUSHB_2   1 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   4 10 18 24 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              24 18 10 4 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 4 0    ;PUSH Bytes
CALL            0 4 21     ;CALL function
                           #--- PUSHB_3   8 4 0     ;PUSH Bytes
CALL            0 4 8      ;CALL function
                           #--- PUSHB_2   29 8      ;PUSH Bytes
MIRP[min,black] cvt_8 29   ;Move Indirect Relative Point
                           #--- PUSHB_5   23 14 4 8 13 ;PUSH Bytes
CALL            13 8 4 14 23 ;CALL function
                           #--- PUSHB_2   23 8      ;PUSH Bytes
MIRP[min,black] cvt_8 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   32 10     ;PUSH Bytes
MIRP[min,black] estemw 32  ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   11 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   32 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_2   8 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   2 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   2 17 18 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 18 17 2 ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   8 4 0     ;PUSH Bytes
CALL            0 4 8      ;CALL function
                           #--- PUSHB_2   29 8      ;PUSH Bytes
MIRP[min,black] cvt_8 29   ;Move Indirect Relative Point
                           #--- PUSHB_5   23 14 4 8 13 ;PUSH Bytes
CALL            13 8 4 14 23 ;CALL function
                           #--- PUSHB_2   23 8      ;PUSH Bytes
MIRP[min,black] cvt_8 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_2   32 10     ;PUSH Bytes
MIRP[min,black] estemw 32  ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
SHP[rp2]        16         ;SHift Point using reference point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   11 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   32 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
                           #--- PUSHB_2   8 14      ;PUSH Bytes
IP              14         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   2 18      ;PUSH Bytes
IP              18         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   2 17 18 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 18 17 2 ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   21 4 0    ;PUSH Bytes
CALL            0 4 21     ;CALL function
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_2   29 8      ;PUSH Bytes
MIRP[min,black] cvt_8 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   18 3 0    ;PUSH Bytes
CALL            0 3 18     ;CALL function
                           #--- PUSHB_5   23 7 4 18 13 ;PUSH Bytes
CALL            13 18 4 7 23 ;CALL function
                           #--- PUSHB_2   23 8      ;PUSH Bytes
MIRP[min,black] cvt_8 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   32 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   17 10     ;PUSH Bytes
MIRP[min,black] estemw 17  ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   19 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   4 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_4   7 13 23 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 23 13 7 ;Interpolate Point
                           #--- PUSHB_2   19 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_3   2 17 20   ;PUSH Bytes
IP              20         ;Interpolate Point
IP              17         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E1F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_2   29 8      ;PUSH Bytes
MIRP[min,black] cvt_8 29   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 29 10  ;PUSH Bytes
CALL            10 29 13   ;CALL function
                           #--- PUSHB_4   64 13 21 9 ;PUSH Bytes
CALL            9 21 13 64 ;CALL function
                           #--- PUSHB_3   18 3 0    ;PUSH Bytes
CALL            0 3 18     ;CALL function
                           #--- PUSHB_5   23 7 4 18 13 ;PUSH Bytes
CALL            13 18 4 7 23 ;CALL function
                           #--- PUSHB_2   23 8      ;PUSH Bytes
MIRP[min,black] cvt_8 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   32 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 32 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP0            32         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SHP[rp2]        26         ;SHift Point using reference point
                           #--- PUSHB_2   17 10     ;PUSH Bytes
MIRP[min,black] estemw 17  ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
                           #--- PUSHB_5   19 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 19 ;CALL function
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_1   1         ;PUSH Bytes
SHP[rp2]        1          ;SHift Point using reference point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   36 1      ;PUSH Bytes
CALL            1 36       ;CALL function
                           #--- PUSHB_2   4 32      ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_4   7 13 23 29 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              29 23 13 7 ;Interpolate Point
                           #--- PUSHB_2   19 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_3   2 17 20   ;PUSH Bytes
IP              20         ;Interpolate Point
IP              17         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E20': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   35 8      ;PUSH Bytes
MIRP[min,black] cvt_8 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 4 0    ;PUSH Bytes
CALL            0 4 31     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   41 22 16 31 13 ;PUSH Bytes
CALL            13 31 16 22 41 ;CALL function
                           #--- PUSHB_2   41 8      ;PUSH Bytes
MIRP[min,black] cvt_8 41   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   44 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   24 1      ;PUSH Bytes
CALL            1 24       ;CALL function
                           #--- PUSHB_2   12 10     ;PUSH Bytes
MIRP[min,black] estemw 12  ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   38 10     ;PUSH Bytes
MIRP[min,black] estemw 38  ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   44 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_4   16 22 35 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 35 22 16 ;Interpolate Point
                           #--- PUSHB_2   12 38     ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   8 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_3   5 9 31    ;PUSH Bytes
IP              31         ;Interpolate Point
IP              9          ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_2   13 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   12 27 28  ;PUSH Bytes
IP              28         ;Interpolate Point
IP              27         ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E21': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   5 1 0     ;PUSH Bytes
CALL            0 1 5      ;CALL function
                           #--- PUSHB_2   42 8      ;PUSH Bytes
MIRP[min,black] cvt_8 42   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 4 0    ;PUSH Bytes
CALL            0 4 28     ;CALL function
                           #--- PUSHB_3   22 4 0    ;PUSH Bytes
CALL            0 4 22     ;CALL function
                           #--- PUSHB_2   36 8      ;PUSH Bytes
MIRP[min,black] cvt_8 36   ;Move Indirect Relative Point
                           #--- PUSHB_5   48 11 5 22 13 ;PUSH Bytes
CALL            13 22 5 11 48 ;CALL function
                           #--- PUSHB_2   48 8      ;PUSH Bytes
MIRP[min,black] cvt_8 48   ;Move Indirect Relative Point
                           #--- PUSHB_5   30 16 5 22 13 ;PUSH Bytes
CALL            13 22 5 16 30 ;CALL function
                           #--- PUSHB_2   30 8      ;PUSH Bytes
MIRP[min,black] cvt_8 30   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_5   51 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 51 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   13 33     ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
SHP[rp2]        13         ;SHift Point using reference point
                           #--- PUSHB_2   2 10      ;PUSH Bytes
MIRP[min,black] estemw 2   ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SHP[rp2]        25         ;SHift Point using reference point
                           #--- PUSHB_1   2         ;PUSH Bytes
SRP0            2          ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   45 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_4   5 11 16 22 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              22 16 11 5 ;Interpolate Point
                           #--- PUSHB_2   27 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   1         ;PUSH Bytes
IP              1          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_3   8 2 27    ;PUSH Bytes
IP              27         ;Interpolate Point
IP              2          ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_1   26        ;PUSH Bytes
IP              26         ;Interpolate Point
                           #--- PUSHB_2   30 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E22': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] estemt 28  ;Move Indirect Relative Point
                           #--- PUSHB_3   30 4 0    ;PUSH Bytes
CALL            0 4 30     ;CALL function
                           #--- PUSHB_3   11 4 0    ;PUSH Bytes
CALL            0 4 11     ;CALL function
                           #--- PUSHB_2   38 8      ;PUSH Bytes
MIRP[min,black] cvt_8 38   ;Move Indirect Relative Point
                           #--- PUSHB_5   24 23 1 11 13 ;PUSH Bytes
CALL            13 11 1 23 24 ;CALL function
                           #--- PUSHB_2   24 9      ;PUSH Bytes
MIRP[min,black] estemt 24  ;Move Indirect Relative Point
                           #--- PUSHB_5   32 17 1 11 13 ;PUSH Bytes
CALL            13 11 1 17 32 ;CALL function
                           #--- PUSHB_2   32 8      ;PUSH Bytes
MIRP[min,black] cvt_8 32   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   44        ;PUSH Bytes
MDAP[rnd]       44         ;Move Direct Absolute Point
                           #--- PUSHB_1   2         ;PUSH Bytes
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_2   28 10     ;PUSH Bytes
MIRP[min,black] estemw 28  ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SHP[rp2]        19         ;SHift Point using reference point
                           #--- PUSHB_1   28        ;PUSH Bytes
SRP0            28         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_5   14 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_2   28 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
                           #--- PUSHB_3   17 11 41  ;PUSH Bytes
IP              41         ;Interpolate Point
IP              11         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_2   23 24     ;PUSH Bytes
IP              24         ;Interpolate Point
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_2   32 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   8 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E23': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   42 8      ;PUSH Bytes
MIRP[min,black] cvt_8 42   ;Move Indirect Relative Point
                           #--- PUSHB_3   23 4 0    ;PUSH Bytes
CALL            0 4 23     ;CALL function
                           #--- PUSHB_3   15 4 0    ;PUSH Bytes
CALL            0 4 15     ;CALL function
                           #--- PUSHB_2   32 6      ;PUSH Bytes
MIRP[min,black] estemtc 32 ;Move Indirect Relative Point
                           #--- PUSHB_3   20 3 0    ;PUSH Bytes
CALL            0 3 20     ;CALL function
                           #--- PUSHB_2   27 6      ;PUSH Bytes
MIRP[min,black] estemtc 27 ;Move Indirect Relative Point
                           #--- PUSHB_5   48 6 0 20 13 ;PUSH Bytes
CALL            13 20 0 6 48 ;CALL function
                           #--- PUSHB_2   48 8      ;PUSH Bytes
MIRP[min,black] cvt_8 48   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   51 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
                           #--- PUSHB_2   39 10     ;PUSH Bytes
MIRP[min,black] estemw 39  ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   8 51      ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_6   0 6 15 32 42 48 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              48 42 32 15 6 0 ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_4   17 18 27 30 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              30 27 18 17 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
                           #--- PUSHB_2   24 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              24         ;Interpolate Point
                           #--- PUSHB_2   23 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E24': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 1 0    ;PUSH Bytes
CALL            0 1 21     ;CALL function
                           #--- PUSHB_2   35 8      ;PUSH Bytes
MIRP[min,black] cvt_8 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 4 0    ;PUSH Bytes
CALL            0 4 31     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   41 15 21 31 13 ;PUSH Bytes
CALL            13 31 21 15 41 ;CALL function
                           #--- PUSHB_2   41 8      ;PUSH Bytes
MIRP[min,black] cvt_8 41   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   13 10     ;PUSH Bytes
MIRP[min,black] estemw 13  ;Move Indirect Relative Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_5   18 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 18 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP0            18         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   13 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   8 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_5   9 15 21 35 41 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              41 35 21 15 9 ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   5 31      ;PUSH Bytes
IP              31         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   10 27 28  ;PUSH Bytes
IP              28         ;Interpolate Point
IP              27         ;Interpolate Point
IP              10         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E25': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   17 1 0    ;PUSH Bytes
CALL            0 1 17     ;CALL function
                           #--- PUSHB_2   42 8      ;PUSH Bytes
MIRP[min,black] cvt_8 42   ;Move Indirect Relative Point
                           #--- PUSHB_3   38 4 0    ;PUSH Bytes
CALL            0 4 38     ;CALL function
                           #--- PUSHB_2   31 6      ;PUSH Bytes
MIRP[min,black] estemtc 31 ;Move Indirect Relative Point
                           #--- PUSHB_5   48 11 17 38 13 ;PUSH Bytes
CALL            13 38 17 11 48 ;CALL function
                           #--- PUSHB_2   48 8      ;PUSH Bytes
MIRP[min,black] cvt_8 48   ;Move Indirect Relative Point
                           #--- PUSHB_5   24 5 17 38 13 ;PUSH Bytes
CALL            13 38 17 5 24 ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] estemtc 24 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   9 10      ;PUSH Bytes
MIRP[min,black] estemw 9   ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   14 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   9 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_4   11 17 42 48 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              48 42 17 11 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_4   5 24 31 38 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              38 31 24 5 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_2   31 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_2   34 35     ;PUSH Bytes
IP              35         ;Interpolate Point
IP              34         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E26': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   16 1 0    ;PUSH Bytes
CALL            0 1 16     ;CALL function
                           #--- PUSHB_2   35 8      ;PUSH Bytes
MIRP[min,black] cvt_8 35   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 4 0    ;PUSH Bytes
CALL            0 4 31     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_5   41 22 16 31 13 ;PUSH Bytes
CALL            13 31 16 22 41 ;CALL function
                           #--- PUSHB_2   41 8      ;PUSH Bytes
MIRP[min,black] cvt_8 41   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   44 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 44 ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP0            44         ;Set Reference Point 0
                           #--- PUSHB_2   38 1      ;PUSH Bytes
CALL            1 38       ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
SHP[rp2]        24         ;SHift Point using reference point
                           #--- PUSHB_2   13 10     ;PUSH Bytes
MIRP[min,black] estemw 13  ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_2   44 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_2   16 22     ;PUSH Bytes
IP              22         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_2   8 27      ;PUSH Bytes
IP              27         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_3   5 9 31    ;PUSH Bytes
IP              31         ;Interpolate Point
IP              9          ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   41 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            41         ;Set Reference Point 2
                           #--- PUSHB_2   13 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP1            22         ;Set Reference Point 1
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_3   12 27 28  ;PUSH Bytes
IP              28         ;Interpolate Point
IP              27         ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E27': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   26 7      ;PUSH Bytes
MIRP[min,black] cvt_7 26   ;Move Indirect Relative Point
                           #--- PUSHB_3   19 4 0    ;PUSH Bytes
CALL            0 4 19     ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] estemtc 12 ;Move Indirect Relative Point
                           #--- PUSHB_5   32 6 0 19 13 ;PUSH Bytes
CALL            13 19 0 6 32 ;CALL function
                           #--- PUSHB_2   32 7      ;PUSH Bytes
MIRP[min,black] cvt_7 32   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   35 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   8 1       ;PUSH Bytes
CALL            1 8        ;CALL function
                           #--- PUSHB_2   23 10     ;PUSH Bytes
MIRP[min,black] estemw 23  ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   29 10     ;PUSH Bytes
MIRP[min,black] estemw 29  ;Move Indirect Relative Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDAP[rnd]       29         ;Move Direct Absolute Point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   35 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            35         ;Set Reference Point 2
                           #--- PUSHB_2   12 19     ;PUSH Bytes
IP              19         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_4   0 6 26 32 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              32 26 6 0  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_1   3         ;PUSH Bytes
IP              3          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_2   15 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E28': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   35 1 0    ;PUSH Bytes
CALL            0 1 35     ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   44 4 0    ;PUSH Bytes
CALL            0 4 44     ;CALL function
                           #--- PUSHB_2   11 6      ;PUSH Bytes
MIRP[min,black] estemtc 11 ;Move Indirect Relative Point
                           #--- PUSHB_5   29 54 35 44 13 ;PUSH Bytes
CALL            13 44 35 54 29 ;CALL function
                           #--- PUSHB_2   29 8      ;PUSH Bytes
MIRP[min,black] cvt_8 29   ;Move Indirect Relative Point
                           #--- PUSHB_5   23 60 35 44 13 ;PUSH Bytes
CALL            13 44 35 60 23 ;CALL function
                           #--- PUSHB_2   23 8      ;PUSH Bytes
MIRP[min,black] cvt_8 23   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   41        ;PUSH Bytes
MDRP[rp0,rnd,white] 41         ;Move Direct Relative Point
                           #--- PUSHB_2   14 10     ;PUSH Bytes
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_5   26 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 26 ;CALL function
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   14 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_6   11 23 29 34 44 63 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              63 44 34 29 23 11 ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_3   6 7 9     ;PUSH Bytes
IP              9          ;Interpolate Point
IP              7          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_2   4 46      ;PUSH Bytes
IP              46         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   48 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              48         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   17 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              17         ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_3   14 41 26  ;PUSH Bytes
IP              26         ;Interpolate Point
IP              41         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   7 4       ;PUSH Bytes
IP              4          ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_2   46 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              46         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E29': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] estemt 14  ;Move Indirect Relative Point
                           #--- PUSHB_3   33 4 0    ;PUSH Bytes
CALL            0 4 33     ;CALL function
                           #--- PUSHB_3   10 4 0    ;PUSH Bytes
CALL            0 4 10     ;CALL function
                           #--- PUSHB_2   47 8      ;PUSH Bytes
MIRP[min,black] cvt_8 47   ;Move Indirect Relative Point
                           #--- PUSHB_5   18 30 1 10 13 ;PUSH Bytes
CALL            13 10 1 30 18 ;CALL function
                           #--- PUSHB_2   18 8      ;PUSH Bytes
MIRP[min,black] cvt_8 18   ;Move Indirect Relative Point
                           #--- PUSHB_5   41 4 1 10 13 ;PUSH Bytes
CALL            13 10 1 4 41 ;CALL function
                           #--- PUSHB_2   41 8      ;PUSH Bytes
MIRP[min,black] cvt_8 41   ;Move Indirect Relative Point
                           #--- PUSHB_1   59        ;PUSH Bytes
DUP             59         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_5   24 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 24 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   65        ;PUSH Bytes
MDAP[rnd]       65         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   50 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 50 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   44        ;PUSH Bytes
SHP[rp2]        44         ;SHift Point using reference point
                           #--- PUSHB_2   14 10     ;PUSH Bytes
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_5   62 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 62 ;CALL function
                           #--- PUSHB_1   62        ;PUSH Bytes
SRP0            62         ;Set Reference Point 0
                           #--- PUSHB_2   56 1      ;PUSH Bytes
CALL            1 56       ;CALL function
                           #--- PUSHB_5   27 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp2]        34         ;SHift Point using reference point
                           #--- PUSHB_2   66 1      ;PUSH Bytes
CALL            1 66       ;CALL function
                           #--- PUSHB_2   1 50      ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   4 10 41 47 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              47 41 10 4 ;Interpolate Point
                           #--- PUSHB_2   56 62     ;PUSH Bytes
SRP1            62         ;Set Reference Point 1
SRP2            56         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   18 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 18     ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_2   16 40     ;PUSH Bytes
IP              40         ;Interpolate Point
IP              16         ;Interpolate Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_5   27 21 32 38 53 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              53 38 32 21 27 ;Interpolate Point
                           #--- PUSHB_2   24 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_2   2 35      ;PUSH Bytes
IP              35         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   41        ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   17 1 0    ;PUSH Bytes
CALL            0 1 17     ;CALL function
                           #--- PUSHB_2   54 8      ;PUSH Bytes
MIRP[min,black] cvt_8 54   ;Move Indirect Relative Point
                           #--- PUSHB_3   44 4 0    ;PUSH Bytes
CALL            0 4 44     ;CALL function
                           #--- PUSHB_2   37 6      ;PUSH Bytes
MIRP[min,black] estemtc 37 ;Move Indirect Relative Point
                           #--- PUSHB_5   60 11 17 44 13 ;PUSH Bytes
CALL            13 44 17 11 60 ;CALL function
                           #--- PUSHB_2   60 8      ;PUSH Bytes
MIRP[min,black] cvt_8 60   ;Move Indirect Relative Point
                           #--- PUSHB_5   24 5 17 44 13 ;PUSH Bytes
CALL            13 44 17 5 24 ;CALL function
                           #--- PUSHB_2   24 6      ;PUSH Bytes
MIRP[min,black] estemtc 24 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   66        ;PUSH Bytes
MDAP[rnd]       66         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_2   9 10      ;PUSH Bytes
MIRP[min,black] estemw 9   ;Move Indirect Relative Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SHP[rp2]        63         ;SHift Point using reference point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   57 1      ;PUSH Bytes
CALL            1 57       ;CALL function
                           #--- PUSHB_5   14 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   67 1      ;PUSH Bytes
CALL            1 67       ;CALL function
                           #--- PUSHB_2   9 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP1            57         ;Set Reference Point 1
                           #--- PUSHB_4   11 17 54 60 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              60 54 17 11 ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_3   5 24 37   ;PUSH Bytes
IP              37         ;Interpolate Point
IP              24         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
                           #--- PUSHB_3   33 35 46  ;PUSH Bytes
IP              46         ;Interpolate Point
IP              35         ;Interpolate Point
IP              33         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_2   48 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              48         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   60 54     ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
SRP2            60         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_4   30 33 40 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 40 33 30 ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_2   46 51     ;PUSH Bytes
IP              51         ;Interpolate Point
IP              46         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   8 1 0     ;PUSH Bytes
CALL            0 1 8      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   17 4 0    ;PUSH Bytes
CALL            0 4 17     ;CALL function
                           #--- PUSHB_1   28        ;PUSH Bytes
SHP[rp1]        28         ;SHift Point using reference point
                           #--- PUSHB_2   42 8      ;PUSH Bytes
MIRP[min,black] cvt_8 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SHP[rp2]        54         ;SHift Point using reference point
                           #--- PUSHB_5   36 11 8 17 13 ;PUSH Bytes
CALL            13 17 8 11 36 ;CALL function
                           #--- PUSHB_2   36 8      ;PUSH Bytes
MIRP[min,black] cvt_8 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SHP[rp2]        48         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDRP[rp0,rnd,white] 14         ;Move Direct Relative Point
                           #--- PUSHB_5   45 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_2   20 10     ;PUSH Bytes
MIRP[min,black] estemw 20  ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP0            20         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   57 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 57 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SRP0            57         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_1   31        ;PUSH Bytes
SHP[rp2]        31         ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_5   51 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   39 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   11 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_2   57 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            57         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_2   51 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_2   48 54     ;PUSH Bytes
IP              54         ;Interpolate Point
IP              48         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_2   29 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              29         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   11 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_2   4 21      ;PUSH Bytes
IP              21         ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_3   9 24 33   ;PUSH Bytes
IP              33         ;Interpolate Point
IP              24         ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_3   26 31 14  ;PUSH Bytes
IP              14         ;Interpolate Point
IP              31         ;Interpolate Point
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 1 0     ;PUSH Bytes
CALL            0 1 4      ;CALL function
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_3   35 5 0    ;PUSH Bytes
CALL            0 5 35     ;CALL function
                           #--- PUSHB_3   29 5 0    ;PUSH Bytes
CALL            0 5 29     ;CALL function
                           #--- PUSHB_2   58 8      ;PUSH Bytes
MIRP[min,black] cvt_8 58   ;Move Indirect Relative Point
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_2   46 8      ;PUSH Bytes
MIRP[min,black] cvt_8 46   ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
DUP             52         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_2   23 8      ;PUSH Bytes
MIRP[min,black] cvt_8 23   ;Move Indirect Relative Point
                           #--- PUSHB_5   40 7 4 13 13 ;PUSH Bytes
CALL            13 13 4 7 40 ;CALL function
                           #--- PUSHB_2   40 8      ;PUSH Bytes
MIRP[min,black] cvt_8 40   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   49 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 49 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
SRP0            49         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   17 10     ;PUSH Bytes
MIRP[min,black] estemw 17  ;Move Indirect Relative Point
                           #--- PUSHB_1   3         ;PUSH Bytes
SHP[rp2]        3          ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   26 1      ;PUSH Bytes
CALL            1 26       ;CALL function
                           #--- PUSHB_5   61 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 61 ;CALL function
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP0            61         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
SHP[rp2]        20         ;SHift Point using reference point
                           #--- PUSHB_2   0 12      ;PUSH Bytes
MIRP[min,black] ecstemw 0  ;Move Indirect Relative Point
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   4 49      ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_4   7 13 40 46 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              46 40 13 7 ;Interpolate Point
                           #--- PUSHB_2   26 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   61        ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
                           #--- PUSHB_2   2 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   1         ;PUSH Bytes
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_4   23 29 52 58 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              58 52 29 23 ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_2   32 55     ;PUSH Bytes
IP              55         ;Interpolate Point
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   7 4       ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
                           #--- PUSHB_3   2 17 20   ;PUSH Bytes
IP              20         ;Interpolate Point
IP              17         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   5         ;PUSH Bytes
IP              5          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_3   10 19 18  ;PUSH Bytes
IP              18         ;Interpolate Point
IP              19         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_2   58 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            58         ;Set Reference Point 2
                           #--- PUSHB_3   26 36 32  ;PUSH Bytes
IP              32         ;Interpolate Point
IP              36         ;Interpolate Point
IP              26         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] estemt 14  ;Move Indirect Relative Point
                           #--- PUSHB_3   26 4 0    ;PUSH Bytes
CALL            0 4 26     ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] estemtc 19 ;Move Indirect Relative Point
                           #--- PUSHB_5   11 30 1 26 13 ;PUSH Bytes
CALL            13 26 1 30 11 ;CALL function
                           #--- PUSHB_2   11 8      ;PUSH Bytes
MIRP[min,black] cvt_8 11   ;Move Indirect Relative Point
                           #--- PUSHB_5   5 36 1 26 13 ;PUSH Bytes
CALL            13 26 1 36 5 ;CALL function
                           #--- PUSHB_2   5 8       ;PUSH Bytes
MIRP[min,black] cvt_8 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   14 10     ;PUSH Bytes
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   33 1      ;PUSH Bytes
CALL            1 33       ;CALL function
                           #--- PUSHB_5   8 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   43 1      ;PUSH Bytes
CALL            1 43       ;CALL function
                           #--- PUSHB_2   14 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   22        ;PUSH Bytes
IP              22         ;Interpolate Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
                           #--- PUSHB_4   5 11 30 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 30 11 5 ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP2            8          ;Set Reference Point 2
                           #--- PUSHB_2   19 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              19         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_2   19 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            19         ;Set Reference Point 2
                           #--- PUSHB_2   22 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   14 9      ;PUSH Bytes
MIRP[min,black] estemt 14  ;Move Indirect Relative Point
                           #--- PUSHB_3   26 4 0    ;PUSH Bytes
CALL            0 4 26     ;CALL function
                           #--- PUSHB_1   30        ;PUSH Bytes
SHP[rp1]        30         ;SHift Point using reference point
                           #--- PUSHB_5   40 9 0 33 4 ;PUSH Bytes
CALL            4 33 0 9 40 ;CALL function
                           #--- PUSHB_5   11 46 1 26 13 ;PUSH Bytes
CALL            13 26 1 46 11 ;CALL function
                           #--- PUSHB_2   11 8      ;PUSH Bytes
MIRP[min,black] cvt_8 11   ;Move Indirect Relative Point
                           #--- PUSHB_5   5 52 1 26 13 ;PUSH Bytes
CALL            13 26 1 52 5 ;CALL function
                           #--- PUSHB_2   5 8       ;PUSH Bytes
MIRP[min,black] cvt_8 5    ;Move Indirect Relative Point
                           #--- PUSHB_5   36 20 1 26 13 ;PUSH Bytes
CALL            13 26 1 20 36 ;CALL function
                           #--- PUSHB_5   36 8 0 50 4 ;PUSH Bytes
CALL            4 50 0 8 36 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   58        ;PUSH Bytes
MDAP[rnd]       58         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_2   14 10     ;PUSH Bytes
MIRP[min,black] estemw 14  ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp2]        43         ;SHift Point using reference point
                           #--- PUSHB_2   55 10     ;PUSH Bytes
MIRP[min,black] estemw 55  ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_5   8 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 8 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   59 1      ;PUSH Bytes
CALL            1 59       ;CALL function
                           #--- PUSHB_2   49 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_4   5 11 46 52 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              52 46 11 5 ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_4   20 26 36 40 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              40 36 26 20 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   18 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              18         ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_3   28 30 33  ;PUSH Bytes
IP              33         ;Interpolate Point
IP              30         ;Interpolate Point
IP              28         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   46 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   13        ;PUSH Bytes
IP              13         ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_2   36 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_2   23 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              23         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   28 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E2F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   11 4 0    ;PUSH Bytes
CALL            0 4 11     ;CALL function
                           #--- PUSHB_2   30 8      ;PUSH Bytes
MIRP[min,black] cvt_8 30   ;Move Indirect Relative Point
                           #--- PUSHB_5   19 5 1 11 13 ;PUSH Bytes
CALL            13 11 1 5 19 ;CALL function
                           #--- PUSHB_2   19 9      ;PUSH Bytes
MIRP[min,black] estemt 19  ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   33 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_5   14 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   27 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   11 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   5 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_4   8 14 2 24 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              24 2 14 8  ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
                           #--- PUSHB_2   22 23     ;PUSH Bytes
IP              23         ;Interpolate Point
IP              22         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E30': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   11 9      ;PUSH Bytes
MIRP[min,black] estemt 11  ;Move Indirect Relative Point
                           #--- PUSHB_3   44 3 0    ;PUSH Bytes
CALL            0 3 44     ;CALL function
                           #--- PUSHB_3   36 3 0    ;PUSH Bytes
CALL            0 3 36     ;CALL function
                           #--- PUSHB_2   54 8      ;PUSH Bytes
MIRP[min,black] cvt_8 54   ;Move Indirect Relative Point
                           #--- PUSHB_5   24 6 0 36 13 ;PUSH Bytes
CALL            13 36 0 6 24 ;CALL function
                           #--- PUSHB_2   24 8      ;PUSH Bytes
MIRP[min,black] cvt_8 24   ;Move Indirect Relative Point
                           #--- PUSHB_5   41 30 0 36 13 ;PUSH Bytes
CALL            13 36 0 30 41 ;CALL function
                           #--- PUSHB_2   41 9      ;PUSH Bytes
MIRP[min,black] estemt 41  ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp2]        33         ;SHift Point using reference point
                           #--- PUSHB_5   27 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 27 ;CALL function
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   21 1      ;PUSH Bytes
CALL            1 21       ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_5   9 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 9 ;CALL function
                           #--- PUSHB_1   39        ;PUSH Bytes
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   21 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_2   6 36      ;PUSH Bytes
IP              36         ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_4   0 11 30 41 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              41 30 11 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_3   9 3 18    ;PUSH Bytes
IP              18         ;Interpolate Point
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_2   14 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              14         ;Interpolate Point
                           #--- PUSHB_2   54 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_3   39 33 48  ;PUSH Bytes
IP              48         ;Interpolate Point
IP              33         ;Interpolate Point
IP              39         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP1            44         ;Set Reference Point 1
                           #--- PUSHB_1   45        ;PUSH Bytes
IP              45         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E31': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   11 5 0    ;PUSH Bytes
CALL            0 5 11     ;CALL function
                           #--- PUSHB_2   0 9       ;PUSH Bytes
MIRP[min,black] estemt 0   ;Move Indirect Relative Point
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 8       ;PUSH Bytes
MIRP[min,black] cvt_8 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   29 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   23 1      ;PUSH Bytes
CALL            1 23       ;CALL function
                           #--- PUSHB_5   9 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 9 ;CALL function
                           #--- PUSHB_2   23 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_2   0 11      ;PUSH Bytes
IP              11         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   26 11     ;PUSH Bytes
SRP1            11         ;Set Reference Point 1
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_4   9 3 16 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 16 3 9  ;Interpolate Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E32': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   5 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_2   8 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E33': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   14 5 0    ;PUSH Bytes
CALL            0 5 14     ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   11        ;PUSH Bytes
MDAP[rnd]       11         ;Move Direct Absolute Point
                           #--- PUSHB_2   5 8       ;PUSH Bytes
MIRP[min,black] cvt_8 5    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E35': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   17 5 0    ;PUSH Bytes
CALL            0 5 17     ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   14        ;PUSH Bytes
MDAP[rnd]       14         ;Move Direct Absolute Point
                           #--- PUSHB_2   5 8       ;PUSH Bytes
MIRP[min,black] cvt_8 5    ;Move Indirect Relative Point
                           #--- PUSHB_3   5 14 10   ;PUSH Bytes
CALL            10 14 5    ;CALL function
                           #--- PUSHB_4   64 5 9 9  ;PUSH Bytes
CALL            9 9 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   19        ;PUSH Bytes
MDAP[rnd]       19         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   10 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 10 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   17 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_2   5 14      ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E36': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   24 5 0    ;PUSH Bytes
CALL            0 5 24     ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
                           #--- PUSHB_3   16 5 0    ;PUSH Bytes
CALL            0 5 16     ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
MDAP[rnd]       21         ;Move Direct Absolute Point
                           #--- PUSHB_2   5 8       ;PUSH Bytes
MIRP[min,black] cvt_8 5    ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_2   10 7      ;PUSH Bytes
MIRP[min,black] cvt_7 10   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   29        ;PUSH Bytes
MDRP[rp0,rnd,white] 29         ;Move Direct Relative Point
                           #--- PUSHB_5   13 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 13 ;CALL function
                           #--- PUSHB_2   13 29     ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_2   5 21      ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            5          ;Set Reference Point 2
                           #--- PUSHB_5   7 13 26 29 35 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              35 29 26 13 7 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E37': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   23 5 0    ;PUSH Bytes
CALL            0 5 23     ;CALL function
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 8       ;PUSH Bytes
MIRP[min,black] cvt_8 6    ;Move Indirect Relative Point
                           #--- PUSHB_3   6 20 10   ;PUSH Bytes
CALL            10 20 6    ;CALL function
                           #--- PUSHB_4   64 6 10 9 ;PUSH Bytes
CALL            9 10 6 64  ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp2]        10         ;SHift Point using reference point
                           #--- PUSHB_5   12 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 12 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP0            12         ;Set Reference Point 0
                           #--- PUSHB_2   14 1      ;PUSH Bytes
CALL            1 14       ;CALL function
                           #--- PUSHB_5   16 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 16 ;CALL function
                           #--- PUSHB_2   14 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   23 2      ;PUSH Bytes
SRP1            2          ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
                           #--- PUSHB_1   17        ;PUSH Bytes
IP              17         ;Interpolate Point
                           #--- PUSHB_2   6 20      ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            6          ;Set Reference Point 2
                           #--- PUSHB_2   12 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E38': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   4 0 0     ;PUSH Bytes
CALL            0 0 4      ;CALL function
                           #--- PUSHB_5   14 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 14 ;CALL function
                           #--- PUSHB_3   4 14 10   ;PUSH Bytes
CALL            10 14 4    ;CALL function
                           #--- PUSHB_4   64 4 1 9  ;PUSH Bytes
CALL            9 1 4 64   ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   10 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   23 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   17        ;PUSH Bytes
SHP[rp2]        17         ;SHift Point using reference point
                           #--- PUSHB_5   0 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 0 ;CALL function
                           #--- PUSHB_2   1 23      ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   4 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   14 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   20        ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E39': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   14 8      ;PUSH Bytes
MIRP[min,black] cvt_8 14   ;Move Indirect Relative Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_5   18 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 18 ;CALL function
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   10 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 10 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   30        ;PUSH Bytes
MDAP[rnd]       30         ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
MDRP[rp0,rnd,white] 7          ;Move Direct Relative Point
                           #--- PUSHB_5   27 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 27 ;CALL function
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   2 1       ;PUSH Bytes
CALL            1 2        ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp2]        21         ;SHift Point using reference point
                           #--- PUSHB_5   14 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   0 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 0 ;CALL function
                           #--- PUSHB_2   2 27      ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
                           #--- PUSHB_2   4 10      ;PUSH Bytes
IP              10         ;Interpolate Point
IP              4          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_1   2         ;PUSH Bytes
IP              2          ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_2   16 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              16         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E3A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   6 6 0 23 4 ;PUSH Bytes
CALL            4 23 0 6 6 ;CALL function
                           #--- PUSHB_5   6 6 0 23 4 ;PUSH Bytes
CALL            4 23 0 6 6 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   9 12      ;PUSH Bytes
MIRP[min,black] ecstemw 9  ;Move Indirect Relative Point
                           #--- PUSHB_2   9 12      ;PUSH Bytes
MIRP[min,black] ecstemw 9  ;Move Indirect Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E3F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   2 1 0     ;PUSH Bytes
CALL            0 1 2      ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SHP[rp1]        21         ;SHift Point using reference point
                           #--- PUSHB_2   26 9      ;PUSH Bytes
MIRP[min,black] estemt 26  ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_3   2 26 10   ;PUSH Bytes
CALL            10 26 2    ;CALL function
                           #--- PUSHB_4   64 2 0 9  ;PUSH Bytes
CALL            9 0 2 64   ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
MDAP[rnd]       25         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
SHP[rp1]        33         ;SHift Point using reference point
                           #--- PUSHB_2   39 9      ;PUSH Bytes
MIRP[min,black] estemt 39  ;Move Indirect Relative Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SHP[rp2]        40         ;SHift Point using reference point
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SHP[rp1]        46         ;SHift Point using reference point
                           #--- PUSHB_2   5 9       ;PUSH Bytes
MIRP[min,black] estemt 5   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   5 38 10   ;PUSH Bytes
CALL            10 38 5    ;CALL function
                           #--- PUSHB_4   64 5 7 9  ;PUSH Bytes
CALL            9 7 5 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   26 10     ;PUSH Bytes
MIRP[min,black] estemw 26  ;Move Indirect Relative Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SHP[rp2]        38         ;SHift Point using reference point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP0            26         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_3   5 23 36   ;PUSH Bytes
SHP[rp2]        36         ;SHift Point using reference point
SHP[rp2]        23         ;SHift Point using reference point
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   0 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 0 ;CALL function
                           #--- PUSHB_3   7 34 47   ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
SHP[rp2]        34         ;SHift Point using reference point
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   30 1      ;PUSH Bytes
CALL            1 30       ;CALL function
                           #--- PUSHB_2   18 10     ;PUSH Bytes
MIRP[min,black] estemw 18  ;Move Indirect Relative Point
                           #--- PUSHB_1   43        ;PUSH Bytes
DUP             43         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_2   12 10     ;PUSH Bytes
MIRP[min,black] estemw 12  ;Move Indirect Relative Point
                           #--- PUSHB_2   50 1      ;PUSH Bytes
CALL            1 50       ;CALL function
                           #--- PUSHB_2   30 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   25 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP2            38         ;Set Reference Point 2
                           #--- PUSHB_1   12        ;PUSH Bytes
IP              12         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E40': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   14 8      ;PUSH Bytes
MIRP[min,black] cvt_8 14   ;Move Indirect Relative Point
                           #--- PUSHB_3   4 4 0     ;PUSH Bytes
CALL            0 4 4      ;CALL function
                           #--- PUSHB_5   20 8 0 4 13 ;PUSH Bytes
CALL            13 4 0 8 20 ;CALL function
                           #--- PUSHB_2   20 8      ;PUSH Bytes
MIRP[min,black] cvt_8 20   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   26        ;PUSH Bytes
MDAP[rnd]       26         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   6 10      ;PUSH Bytes
MIRP[min,black] estemw 6   ;Move Indirect Relative Point
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp2]        23         ;SHift Point using reference point
                           #--- PUSHB_1   6         ;PUSH Bytes
SRP0            6          ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_5   11 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 11 ;CALL function
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_2   17 6      ;PUSH Bytes
SRP1            6          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_4   0 8 14 20 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              20 14 8 0  ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   20 14     ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E41': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   42 8      ;PUSH Bytes
MIRP[min,black] cvt_8 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_2   36 8      ;PUSH Bytes
MIRP[min,black] cvt_8 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_2   10 6      ;PUSH Bytes
MIRP[min,black] estemtc 10 ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
DUP             22         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_2   15 6      ;PUSH Bytes
MIRP[min,black] estemtc 15 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   34 10     ;PUSH Bytes
MIRP[min,black] estemw 34  ;Move Indirect Relative Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SHP[rp2]        51         ;SHift Point using reference point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   39 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 39 ;CALL function
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   34 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_3   10 12 27  ;PUSH Bytes
IP              27         ;Interpolate Point
IP              12         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_7   13 24 25 0 36 42 48 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              48 42 36 0 25 24 13 ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   22 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              22         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 42     ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_2   3 39      ;PUSH Bytes
IP              39         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   34        ;PUSH Bytes
IP              34         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   7 4       ;PUSH Bytes
IP              4          ;Interpolate Point
IP              7          ;Interpolate Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
                           #--- PUSHB_2   19 30     ;PUSH Bytes
IP              30         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_2   10 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E43': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   43 8      ;PUSH Bytes
MIRP[min,black] cvt_8 43   ;Move Indirect Relative Point
                           #--- PUSHB_3   20 4 0    ;PUSH Bytes
CALL            0 4 20     ;CALL function
                           #--- PUSHB_2   55 8      ;PUSH Bytes
MIRP[min,black] cvt_8 55   ;Move Indirect Relative Point
                           #--- PUSHB_3   31 4 0    ;PUSH Bytes
CALL            0 4 31     ;CALL function
                           #--- PUSHB_5   49 37 0 55 13 ;PUSH Bytes
CALL            13 55 0 37 49 ;CALL function
                           #--- PUSHB_2   49 8      ;PUSH Bytes
MIRP[min,black] cvt_8 49   ;Move Indirect Relative Point
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 6      ;PUSH Bytes
MIRP[min,black] estemtc 26 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   67        ;PUSH Bytes
MDAP[rnd]       67         ;Move Direct Absolute Point
                           #--- PUSHB_1   23        ;PUSH Bytes
MDRP[rp0,rnd,white] 23         ;Move Direct Relative Point
                           #--- PUSHB_5   64 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 64 ;CALL function
                           #--- PUSHB_1   64        ;PUSH Bytes
SRP0            64         ;Set Reference Point 0
                           #--- PUSHB_2   3 1       ;PUSH Bytes
CALL            1 3        ;CALL function
                           #--- PUSHB_2   35 10     ;PUSH Bytes
MIRP[min,black] estemw 35  ;Move Indirect Relative Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SHP[rp2]        52         ;SHift Point using reference point
                           #--- PUSHB_1   58        ;PUSH Bytes
DUP             58         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_5   17 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 17 ;CALL function
                           #--- PUSHB_4   9 35 3 8  ;PUSH Bytes
CALL            8 3 35 9   ;CALL function
                           #--- PUSHB_2   29 10     ;PUSH Bytes
MIRP[min,black] estemw 29  ;Move Indirect Relative Point
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_5   40 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 40 ;CALL function
                           #--- PUSHB_2   68 1      ;PUSH Bytes
CALL            1 68       ;CALL function
                           #--- PUSHB_2   58 64     ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
SRP2            58         ;Set Reference Point 2
                           #--- PUSHB_2   20 14     ;PUSH Bytes
IP              14         ;Interpolate Point
IP              20         ;Interpolate Point
                           #--- PUSHB_2   17 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   12 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              12         ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_1   6         ;PUSH Bytes
IP              6          ;Interpolate Point
                           #--- PUSHB_2   46 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_5   31 0 37 43 49 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              49 43 37 0 31 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   49 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            49         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
                           #--- PUSHB_1   35        ;PUSH Bytes
IP              35         ;Interpolate Point
                           #--- PUSHB_2   55 20     ;PUSH Bytes
SRP1            20         ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_2   6 7       ;PUSH Bytes
IP              7          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_6   17 23 29 58 9 64 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              64 9 58 29 23 17 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E44': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   36 8      ;PUSH Bytes
MIRP[min,black] cvt_8 36   ;Move Indirect Relative Point
                           #--- PUSHB_1   42        ;PUSH Bytes
MDAP[rnd]       42         ;Move Direct Absolute Point
                           #--- PUSHB_2   30 8      ;PUSH Bytes
MIRP[min,black] cvt_8 30   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   45 10     ;PUSH Bytes
MIRP[min,black] estemw 45  ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SHP[rp2]        27         ;SHift Point using reference point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_5   33 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 33 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   39 45     ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
SRP2            39         ;Set Reference Point 2
                           #--- PUSHB_2   0 30      ;PUSH Bytes
IP              30         ;Interpolate Point
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 36     ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   3 33      ;PUSH Bytes
IP              33         ;Interpolate Point
IP              3          ;Interpolate Point
                           #--- PUSHB_1   30        ;PUSH Bytes
SRP1            30         ;Set Reference Point 1
                           #--- PUSHB_1   28        ;PUSH Bytes
IP              28         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E45': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 4 0    ;PUSH Bytes
CALL            0 4 13     ;CALL function
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   17        ;PUSH Bytes
MDAP[rnd]       17         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   18 1      ;PUSH Bytes
CALL            1 18       ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E46': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   21 4 0    ;PUSH Bytes
CALL            0 4 21     ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
                           #--- PUSHB_3   10 2 0    ;PUSH Bytes
CALL            0 2 10     ;CALL function
                           #--- PUSHB_2   32 8      ;PUSH Bytes
MIRP[min,black] cvt_8 32   ;Move Indirect Relative Point
                           #--- PUSHB_1   16        ;PUSH Bytes
MDAP[rnd]       16         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 8      ;PUSH Bytes
MIRP[min,black] cvt_8 26   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   38        ;PUSH Bytes
MDAP[rnd]       38         ;Move Direct Absolute Point
                           #--- PUSHB_1   19        ;PUSH Bytes
MDRP[rp0,rnd,white] 19         ;Move Direct Relative Point
                           #--- PUSHB_5   35 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 35 ;CALL function
                           #--- PUSHB_1   35        ;PUSH Bytes
SRP0            35         ;Set Reference Point 0
                           #--- PUSHB_2   29 1      ;PUSH Bytes
CALL            1 29       ;CALL function
                           #--- PUSHB_5   13 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 13 ;CALL function
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_2   29 35     ;PUSH Bytes
SRP1            35         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_5   6 10 16 21 8 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              8 21 16 10 6 ;Interpolate Point
                           #--- PUSHB_2   1 13      ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
                           #--- PUSHB_2   5 22      ;PUSH Bytes
IP              22         ;Interpolate Point
IP              5          ;Interpolate Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   32 26     ;PUSH Bytes
SRP1            26         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_2   19 13     ;PUSH Bytes
IP              13         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
                           #--- PUSHB_2   8 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_3   6 4 22    ;PUSH Bytes
IP              22         ;Interpolate Point
IP              4          ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E47': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_2   43 7      ;PUSH Bytes
MIRP[min,black] cvt_7 43   ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_4   3 43 0 8  ;PUSH Bytes
CALL            8 0 43 3   ;CALL function
                           #--- PUSHB_5   29 8 0 66 4 ;PUSH Bytes
CALL            4 66 0 8 29 ;CALL function
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_5   37 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 37 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] cvt_7 13   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   23 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_5   52 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 52 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_5   40 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 40 ;CALL function
                           #--- PUSHB_2   34 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_6   5 13 14 19 7 29 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              29 7 19 14 13 5 ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_2   0 32      ;PUSH Bytes
IP              32         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_4   26 40 46 52 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              52 46 40 26 ;Interpolate Point
                           #--- PUSHB_2   37 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   23 10     ;PUSH Bytes
IP              10         ;Interpolate Point
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E47.high': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp1]        7          ;SHift Point using reference point
                           #--- PUSHB_5   43 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 43 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_4   3 43 0 8  ;PUSH Bytes
CALL            8 0 43 3   ;CALL function
                           #--- PUSHB_2   29 7      ;PUSH Bytes
MIRP[min,black] cvt_7 29   ;Move Indirect Relative Point
                           #--- PUSHB_1   49        ;PUSH Bytes
MDAP[rnd]       49         ;Move Direct Absolute Point
                           #--- PUSHB_5   37 7 0 24 4 ;PUSH Bytes
CALL            4 24 0 7 37 ;CALL function
                           #--- PUSHB_1   20        ;PUSH Bytes
MDAP[rnd]       20         ;Move Direct Absolute Point
                           #--- PUSHB_5   13 7 0 56 4 ;PUSH Bytes
CALL            4 56 0 7 13 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   55        ;PUSH Bytes
MDAP[rnd]       55         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   23 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 23 ;CALL function
                           #--- PUSHB_1   23        ;PUSH Bytes
SRP0            23         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_5   52 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 52 ;CALL function
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP0            52         ;Set Reference Point 0
                           #--- PUSHB_2   46 1      ;PUSH Bytes
CALL            1 46       ;CALL function
                           #--- PUSHB_5   40 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 40 ;CALL function
                           #--- PUSHB_2   34 23     ;PUSH Bytes
SRP1            23         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_6   5 13 14 19 7 29 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              29 7 19 14 13 5 ;Interpolate Point
                           #--- PUSHB_1   52        ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
                           #--- PUSHB_2   0 32      ;PUSH Bytes
IP              32         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP2            46         ;Set Reference Point 2
                           #--- PUSHB_1   37        ;PUSH Bytes
IP              37         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 43     ;PUSH Bytes
SRP1            43         ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_4   26 40 46 52 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              52 46 40 26 ;Interpolate Point
                           #--- PUSHB_2   37 49     ;PUSH Bytes
SRP1            49         ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   23        ;PUSH Bytes
IP              23         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E48': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   2 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 2 ;CALL function
                           #--- PUSHB_5   2 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 2 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   0 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 0 ;CALL function
                           #--- PUSHB_5   0 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 0 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E48.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_5   2 6 0 12 4 ;PUSH Bytes
CALL            4 12 0 6 2 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   0 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 0 ;CALL function
                           #--- PUSHB_5   0 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 0 ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E49': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   3 7 0 87 4 ;PUSH Bytes
CALL            4 87 0 7 3 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 12 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   34 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_5   15 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 15 ;CALL function
                           #--- PUSHB_2   28 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_4   0 12 25 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 25 12 0 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_6   9 15 22 25 28 34 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              34 28 25 22 15 9 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E49.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   2         ;PUSH Bytes
MDAP[rnd]       2          ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_2   3 8       ;PUSH Bytes
MIRP[min,black] cvt_8 3    ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SHP[rp2]        18         ;SHift Point using reference point
                           #--- PUSHB_1   31        ;PUSH Bytes
MDAP[rnd]       31         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 7 0 71 4 ;PUSH Bytes
CALL            4 71 0 7 12 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   37        ;PUSH Bytes
MDAP[rnd]       37         ;Move Direct Absolute Point
                           #--- PUSHB_1   9         ;PUSH Bytes
MDRP[rp0,rnd,white] 9          ;Move Direct Relative Point
                           #--- PUSHB_1   2         ;PUSH Bytes
SHP[rp2]        2          ;SHift Point using reference point
                           #--- PUSHB_5   34 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 34 ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   28 1      ;PUSH Bytes
CALL            1 28       ;CALL function
                           #--- PUSHB_5   15 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 15 ;CALL function
                           #--- PUSHB_2   28 34     ;PUSH Bytes
SRP1            34         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_4   0 12 25 31 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              31 25 12 0 ;Interpolate Point
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
                           #--- PUSHB_1   18        ;PUSH Bytes
IP              18         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   31 3      ;PUSH Bytes
SRP1            3          ;Set Reference Point 1
SRP2            31         ;Set Reference Point 2
                           #--- PUSHB_6   9 15 22 25 28 34 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              34 28 25 22 15 9 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   41 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 41 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 12 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_5   50 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 50 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_5   15 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_5   29 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_1   38        ;PUSH Bytes
SMD             38         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 37     ;PUSH Bytes
MDAP[no-rnd]    37         ;Move Direct Absolute Point
MDRP[min,black] 36         ;Move Direct Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 36     ;PUSH Bytes
MDAP[no-rnd]    36         ;Move Direct Absolute Point
MDRP[min,black] 37         ;Move Direct Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   35 36     ;PUSH Bytes
SDPVTL[orthog]  36 35      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[grey]      35         ;Move Direct Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[grey]      38         ;Move Direct Relative Point
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_2   35 38     ;PUSH Bytes
MDAP[no-rnd]    38         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 38     ;PUSH Bytes
MDAP[no-rnd]    38         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   44 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_7   8 12 18 24 41 47 10 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              10 47 41 24 18 12 8 ;Interpolate Point
                           #--- PUSHB_2   4 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_6   1 6 7 2 25 26 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              26 25 2 7 6 1 ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_3   2 21 15   ;PUSH Bytes
IP              15         ;Interpolate Point
IP              21         ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_3   4 7 29    ;PUSH Bytes
IP              29         ;Interpolate Point
IP              7          ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_3   6 25 8    ;PUSH Bytes
IP              8          ;Interpolate Point
IP              25         ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4A.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SHP[rp1]        0          ;SHift Point using reference point
                           #--- PUSHB_5   41 7 0 56 4 ;PUSH Bytes
CALL            4 56 0 7 41 ;CALL function
                           #--- PUSHB_1   32        ;PUSH Bytes
SHP[rp2]        32         ;SHift Point using reference point
                           #--- PUSHB_1   47        ;PUSH Bytes
MDAP[rnd]       47         ;Move Direct Absolute Point
                           #--- PUSHB_5   12 7 0 56 4 ;PUSH Bytes
CALL            4 56 0 7 12 ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   53        ;PUSH Bytes
MDAP[rnd]       53         ;Move Direct Absolute Point
                           #--- PUSHB_1   21        ;PUSH Bytes
MDRP[rp0,rnd,white] 21         ;Move Direct Relative Point
                           #--- PUSHB_5   50 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 50 ;CALL function
                           #--- PUSHB_1   50        ;PUSH Bytes
SRP0            50         ;Set Reference Point 0
                           #--- PUSHB_2   44 1      ;PUSH Bytes
CALL            1 44       ;CALL function
                           #--- PUSHB_5   15 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 15 ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SRP0            15         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_5   29 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_1   38        ;PUSH Bytes
SMD             38         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 37     ;PUSH Bytes
MDAP[no-rnd]    37         ;Move Direct Absolute Point
MDRP[min,black] 36         ;Move Direct Relative Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 36     ;PUSH Bytes
MDAP[no-rnd]    36         ;Move Direct Absolute Point
MDRP[min,black] 37         ;Move Direct Relative Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SMD             54         ;Set Minimum Distance
                           #--- PUSHB_2   35 36     ;PUSH Bytes
SDPVTL[orthog]  36 35      ;Set Dual Projection Vector To Line
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP0            36         ;Set Reference Point 0
                           #--- PUSHB_1   35        ;PUSH Bytes
MDRP[grey]      35         ;Move Direct Relative Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP0            37         ;Set Reference Point 0
                           #--- PUSHB_1   38        ;PUSH Bytes
MDRP[grey]      38         ;Move Direct Relative Point
SPVTCA[y-axis]             ;Set Projection Vector To Coordinate Axis
                           #--- PUSHB_2   35 38     ;PUSH Bytes
MDAP[no-rnd]    38         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   35 38     ;PUSH Bytes
MDAP[no-rnd]    38         ;Move Direct Absolute Point
MDAP[no-rnd]    35         ;Move Direct Absolute Point
                           #--- PUSHB_1   64        ;PUSH Bytes
SMD             64         ;Set Minimum Distance
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   44 50     ;PUSH Bytes
SRP1            50         ;Set Reference Point 1
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_6   8 12 18 24 41 47 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              47 41 24 18 12 8 ;Interpolate Point
                           #--- PUSHB_2   4 15      ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_5   1 2 7 25 26 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              26 25 7 2 1 ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_1   32        ;PUSH Bytes
IP              32         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   47 41     ;PUSH Bytes
SRP1            41         ;Set Reference Point 1
SRP2            47         ;Set Reference Point 2
                           #--- PUSHB_5   2 21 15 44 50 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              50 44 15 21 2 ;Interpolate Point
                           #--- PUSHB_1   12        ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
                           #--- PUSHB_3   4 7 29    ;PUSH Bytes
IP              29         ;Interpolate Point
IP              7          ;Interpolate Point
IP              4          ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_3   6 8 25    ;PUSH Bytes
IP              25         ;Interpolate Point
IP              8          ;Interpolate Point
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_2   4 7       ;PUSH Bytes
MIRP[min,black] cvt_7 4    ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   3 4 10    ;PUSH Bytes
CALL            10 4 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_3   4 3 10    ;PUSH Bytes
CALL            10 3 4     ;CALL function
                           #--- PUSHB_4   64 4 6 9  ;PUSH Bytes
CALL            9 6 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   0 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 0 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   0 1 10    ;PUSH Bytes
CALL            10 1 0     ;CALL function
                           #--- PUSHB_4   64 0 10 9 ;PUSH Bytes
CALL            9 10 0 64  ;CALL function
                           #--- PUSHB_3   1 0 10    ;PUSH Bytes
CALL            10 0 1     ;CALL function
                           #--- PUSHB_4   64 1 3 9  ;PUSH Bytes
CALL            9 3 1 64   ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4B.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   3         ;PUSH Bytes
MDAP[rnd]       3          ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
SHP[rp1]        10         ;SHift Point using reference point
                           #--- PUSHB_5   4 8 0 66 4 ;PUSH Bytes
CALL            4 66 0 8 4 ;CALL function
                           #--- PUSHB_1   8         ;PUSH Bytes
SHP[rp2]        8          ;SHift Point using reference point
                           #--- PUSHB_3   3 4 10    ;PUSH Bytes
CALL            10 4 3     ;CALL function
                           #--- PUSHB_4   64 3 1 9  ;PUSH Bytes
CALL            9 1 3 64   ;CALL function
                           #--- PUSHB_3   4 3 10    ;PUSH Bytes
CALL            10 3 4     ;CALL function
                           #--- PUSHB_4   64 4 6 9  ;PUSH Bytes
CALL            9 6 4 64   ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SHP[rp2]        5          ;SHift Point using reference point
                           #--- PUSHB_5   0 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 0 ;CALL function
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   0 1 10    ;PUSH Bytes
CALL            10 1 0     ;CALL function
                           #--- PUSHB_4   64 0 10 9 ;PUSH Bytes
CALL            9 10 0 64  ;CALL function
                           #--- PUSHB_3   1 0 10    ;PUSH Bytes
CALL            10 0 1     ;CALL function
                           #--- PUSHB_4   64 1 3 9  ;PUSH Bytes
CALL            9 3 1 64   ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4C': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   17 7 0 40 4 ;PUSH Bytes
CALL            4 40 0 7 17 ;CALL function
                           #--- PUSHB_1   12        ;PUSH Bytes
MDAP[rnd]       12         ;Move Direct Absolute Point
                           #--- PUSHB_2   7 7       ;PUSH Bytes
MIRP[min,black] cvt_7 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_5   22 7 0 56 4 ;PUSH Bytes
CALL            4 56 0 7 22 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   25 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_5   14 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 14 ;CALL function
                           #--- PUSHB_2   20 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_3   14 20 25  ;PUSH Bytes
IP              25         ;Interpolate Point
IP              20         ;Interpolate Point
IP              14         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4C.low': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   12 5 0    ;PUSH Bytes
CALL            0 5 12     ;CALL function
                           #--- PUSHB_2   7 8       ;PUSH Bytes
MIRP[min,black] cvt_8 7    ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SRP0            7          ;Set Reference Point 0
                           #--- PUSHB_2   22 7      ;PUSH Bytes
MIRP[min,black] cvt_7 22   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_5   17 7 0 71 4 ;PUSH Bytes
CALL            4 71 0 7 17 ;CALL function
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   25 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 25 ;CALL function
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   20 1      ;PUSH Bytes
CALL            1 20       ;CALL function
                           #--- PUSHB_5   14 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 14 ;CALL function
                           #--- PUSHB_2   20 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            20         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   12 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            12         ;Set Reference Point 2
                           #--- PUSHB_4   3 14 20 25 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              25 20 14 3 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4D': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   0         ;PUSH Bytes
MDAP[rnd]       0          ;Move Direct Absolute Point
                           #--- PUSHB_2   12 8      ;PUSH Bytes
MIRP[min,black] cvt_8 12   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 8       ;PUSH Bytes
MIRP[min,black] cvt_8 6    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_5   21 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   9 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 9 ;CALL function
                           #--- PUSHB_2   15 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4D.high': """

""",

    'uni0E4E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   33 7      ;PUSH Bytes
MIRP[min,black] cvt_7 33   ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
MDAP[rnd]       27         ;Move Direct Absolute Point
                           #--- PUSHB_2   24 7      ;PUSH Bytes
MIRP[min,black] cvt_7 24   ;Move Indirect Relative Point
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   13 7      ;PUSH Bytes
MIRP[min,black] cvt_7 13   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   35        ;PUSH Bytes
MDAP[rnd]       35         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_5   21 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 21 ;CALL function
                           #--- PUSHB_3   21 10 10  ;PUSH Bytes
CALL            10 10 21   ;CALL function
                           #--- PUSHB_4   64 21 0 9 ;PUSH Bytes
CALL            9 0 21 64  ;CALL function
                           #--- PUSHB_1   15        ;PUSH Bytes
SHP[rp2]        15         ;SHift Point using reference point
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_1   4         ;PUSH Bytes
DUP             4          ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_5   30 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 30 ;CALL function
                           #--- PUSHB_2   30 10     ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   24 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_1   7         ;PUSH Bytes
IP              7          ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_2   10 16     ;PUSH Bytes
IP              16         ;Interpolate Point
IP              10         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   15        ;PUSH Bytes
IP              15         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E4F': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] estemtc 12 ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_5   30 6 0 14 4 ;PUSH Bytes
CALL            4 14 0 6 30 ;CALL function
                           #--- PUSHB_1   18        ;PUSH Bytes
MDAP[rnd]       18         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] estemtc 6  ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   36        ;PUSH Bytes
MDAP[rnd]       36         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   21 10     ;PUSH Bytes
MIRP[min,black] estemw 21  ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_5   33 12 0 20 4 ;PUSH Bytes
CALL            4 20 0 12 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   9 10      ;PUSH Bytes
MIRP[min,black] estemw 9   ;Move Indirect Relative Point
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   33 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            33         ;Set Reference Point 2
                           #--- PUSHB_5   6 12 18 24 30 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              30 24 18 12 6 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 24     ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_5   9 15 21 27 33 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              33 27 21 15 9 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E50': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] estemtc 12 ;Move Indirect Relative Point
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_2   18 6      ;PUSH Bytes
MIRP[min,black] estemtc 18 ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   21 10     ;PUSH Bytes
MIRP[min,black] estemw 21  ;Move Indirect Relative Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_2   9 10      ;PUSH Bytes
MIRP[min,black] estemw 9   ;Move Indirect Relative Point
                           #--- PUSHB_2   25 1      ;PUSH Bytes
CALL            1 25       ;CALL function
                           #--- PUSHB_2   15 21     ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
SRP2            15         ;Set Reference Point 2
                           #--- PUSHB_2   6 0       ;PUSH Bytes
IP              0          ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   18 12     ;PUSH Bytes
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_2   9 3       ;PUSH Bytes
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E51': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   13 1 0    ;PUSH Bytes
CALL            0 1 13     ;CALL function
                           #--- PUSHB_2   12 6      ;PUSH Bytes
MIRP[min,black] estemtc 12 ;Move Indirect Relative Point
                           #--- PUSHB_3   6 2 0     ;PUSH Bytes
CALL            0 2 6      ;CALL function
                           #--- PUSHB_2   19 6      ;PUSH Bytes
MIRP[min,black] estemtc 19 ;Move Indirect Relative Point
                           #--- PUSHB_5   0 36 12 6 13 ;PUSH Bytes
CALL            13 6 12 36 0 ;CALL function
                           #--- PUSHB_5   0 6 0 42 4 ;PUSH Bytes
CALL            4 42 0 6 0 ;CALL function
                           #--- PUSHB_5   30 42 12 6 13 ;PUSH Bytes
CALL            13 6 12 42 30 ;CALL function
                           #--- PUSHB_2   30 7      ;PUSH Bytes
MIRP[min,black] cvt_7 30   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   22 10     ;PUSH Bytes
MIRP[min,black] estemw 22  ;Move Indirect Relative Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP0            22         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_5   45 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 45 ;CALL function
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP0            45         ;Set Reference Point 0
                           #--- PUSHB_2   39 1      ;PUSH Bytes
CALL            1 39       ;CALL function
                           #--- PUSHB_5   33 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   16 1      ;PUSH Bytes
CALL            1 16       ;CALL function
                           #--- PUSHB_2   9 10      ;PUSH Bytes
MIRP[min,black] estemw 9   ;Move Indirect Relative Point
                           #--- PUSHB_3   16 9 10   ;PUSH Bytes
CALL            10 9 16    ;CALL function
                           #--- PUSHB_4   64 16 12 9 ;PUSH Bytes
CALL            9 12 16 64 ;CALL function
                           #--- PUSHB_2   49 1      ;PUSH Bytes
CALL            1 49       ;CALL function
                           #--- PUSHB_2   45 27     ;PUSH Bytes
SRP1            27         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_2   0 25      ;PUSH Bytes
IP              25         ;Interpolate Point
IP              0          ;Interpolate Point
                           #--- PUSHB_1   39        ;PUSH Bytes
SRP1            39         ;Set Reference Point 1
                           #--- PUSHB_3   6 19 30   ;PUSH Bytes
IP              30         ;Interpolate Point
IP              19         ;Interpolate Point
IP              6          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   36 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            36         ;Set Reference Point 2
                           #--- PUSHB_1   25        ;PUSH Bytes
IP              25         ;Interpolate Point
                           #--- PUSHB_1   42        ;PUSH Bytes
SRP1            42         ;Set Reference Point 1
                           #--- PUSHB_6   3 16 22 9 33 27 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              27 33 9 22 16 3 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E52': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] estemtc 16 ;Move Indirect Relative Point
                           #--- PUSHB_1   32        ;PUSH Bytes
MDAP[rnd]       32         ;Move Direct Absolute Point
                           #--- PUSHB_2   42 8      ;PUSH Bytes
MIRP[min,black] cvt_8 42   ;Move Indirect Relative Point
                           #--- PUSHB_1   48        ;PUSH Bytes
MDAP[rnd]       48         ;Move Direct Absolute Point
                           #--- PUSHB_2   26 8      ;PUSH Bytes
MIRP[min,black] cvt_8 26   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   13 10     ;PUSH Bytes
MIRP[min,black] estemw 13  ;Move Indirect Relative Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP0            13         ;Set Reference Point 0
                           #--- PUSHB_2   35 1      ;PUSH Bytes
CALL            1 35       ;CALL function
                           #--- PUSHB_5   51 10 0 30 4 ;PUSH Bytes
CALL            4 30 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   29 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 29 ;CALL function
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP0            29         ;Set Reference Point 0
                           #--- PUSHB_2   17 1      ;PUSH Bytes
CALL            1 17       ;CALL function
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   13 4      ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
SRP2            13         ;Set Reference Point 2
                           #--- PUSHB_1   9         ;PUSH Bytes
IP              9          ;Interpolate Point
                           #--- PUSHB_2   45 51     ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_4   22 32 37 24 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              24 37 32 22 ;Interpolate Point
                           #--- PUSHB_1   29        ;PUSH Bytes
SRP1            29         ;Set Reference Point 1
                           #--- PUSHB_2   21 38     ;PUSH Bytes
IP              38         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP2            17         ;Set Reference Point 2
                           #--- PUSHB_2   20 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              20         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   42 32     ;PUSH Bytes
SRP1            32         ;Set Reference Point 1
SRP2            42         ;Set Reference Point 2
                           #--- PUSHB_2   13 4      ;PUSH Bytes
IP              4          ;Interpolate Point
IP              13         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_2   35 29     ;PUSH Bytes
IP              29         ;Interpolate Point
IP              35         ;Interpolate Point
                           #--- PUSHB_1   26        ;PUSH Bytes
SRP2            26         ;Set Reference Point 2
                           #--- PUSHB_2   24 21     ;PUSH Bytes
IP              21         ;Interpolate Point
IP              24         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E53': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   27 1 0    ;PUSH Bytes
CALL            0 1 27     ;CALL function
                           #--- PUSHB_2   48 8      ;PUSH Bytes
MIRP[min,black] cvt_8 48   ;Move Indirect Relative Point
                           #--- PUSHB_3   36 2 0    ;PUSH Bytes
CALL            0 2 36     ;CALL function
                           #--- PUSHB_1   42        ;PUSH Bytes
SHP[rp1]        42         ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] estemtc 14 ;Move Indirect Relative Point
                           #--- PUSHB_1   6         ;PUSH Bytes
SHP[rp2]        6          ;SHift Point using reference point
                           #--- PUSHB_5   54 21 27 36 13 ;PUSH Bytes
CALL            13 36 27 21 54 ;CALL function
                           #--- PUSHB_2   54 8      ;PUSH Bytes
MIRP[min,black] cvt_8 54   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   60        ;PUSH Bytes
MDAP[rnd]       60         ;Move Direct Absolute Point
                           #--- PUSHB_1   33        ;PUSH Bytes
MDRP[rp0,rnd,white] 33         ;Move Direct Relative Point
                           #--- PUSHB_2   17 10     ;PUSH Bytes
MIRP[min,black] estemw 17  ;Move Indirect Relative Point
                           #--- PUSHB_1   57        ;PUSH Bytes
SHP[rp2]        57         ;SHift Point using reference point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   10 1      ;PUSH Bytes
CALL            1 10       ;CALL function
                           #--- PUSHB_2   9 10      ;PUSH Bytes
MIRP[min,black] estemw 9   ;Move Indirect Relative Point
                           #--- PUSHB_4   24 9 10 8 ;PUSH Bytes
CALL            8 10 9 24  ;CALL function
                           #--- PUSHB_5   51 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
MDAP[rnd]       51         ;Move Direct Absolute Point
                           #--- PUSHB_5   24 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 24 ;CALL function
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_2   45 10     ;PUSH Bytes
MIRP[min,black] estemw 45  ;Move Indirect Relative Point
                           #--- PUSHB_2   61 1      ;PUSH Bytes
CALL            1 61       ;CALL function
                           #--- PUSHB_2   51 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_4   14 21 27 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 27 21 14 ;Interpolate Point
                           #--- PUSHB_2   9 24      ;PUSH Bytes
SRP1            24         ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
                           #--- PUSHB_1   4         ;PUSH Bytes
SRP1            4          ;Set Reference Point 1
                           #--- PUSHB_2   1 42      ;PUSH Bytes
IP              42         ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP2            45         ;Set Reference Point 2
                           #--- PUSHB_1   0         ;PUSH Bytes
IP              0          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   54 48     ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
SRP2            54         ;Set Reference Point 2
                           #--- PUSHB_1   24        ;PUSH Bytes
IP              24         ;Interpolate Point
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP1            21         ;Set Reference Point 1
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP2            14         ;Set Reference Point 2
                           #--- PUSHB_5   4 9 17 33 45 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              45 33 17 9 4 ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   39        ;PUSH Bytes
IP              39         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E54': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   28 9      ;PUSH Bytes
MIRP[min,black] estemt 28  ;Move Indirect Relative Point
                           #--- PUSHB_3   13 2 0    ;PUSH Bytes
CALL            0 2 13     ;CALL function
                           #--- PUSHB_2   22 9      ;PUSH Bytes
MIRP[min,black] estemt 22  ;Move Indirect Relative Point
                           #--- PUSHB_5   35 51 7 13 13 ;PUSH Bytes
CALL            13 13 7 51 35 ;CALL function
                           #--- PUSHB_2   35 8      ;PUSH Bytes
MIRP[min,black] cvt_8 35   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   57        ;PUSH Bytes
MDAP[rnd]       57         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   25 10     ;PUSH Bytes
MIRP[min,black] estemw 25  ;Move Indirect Relative Point
                           #--- PUSHB_1   25        ;PUSH Bytes
SRP0            25         ;Set Reference Point 0
                           #--- PUSHB_2   32 1      ;PUSH Bytes
CALL            1 32       ;CALL function
                           #--- PUSHB_5   54 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 54 ;CALL function
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP0            54         ;Set Reference Point 0
                           #--- PUSHB_2   48 1      ;PUSH Bytes
CALL            1 48       ;CALL function
                           #--- PUSHB_5   38 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 38 ;CALL function
                           #--- PUSHB_2   58 1      ;PUSH Bytes
CALL            1 58       ;CALL function
                           #--- PUSHB_2   32 25     ;PUSH Bytes
SRP1            25         ;Set Reference Point 1
SRP2            32         ;Set Reference Point 2
                           #--- PUSHB_4   13 22 7 28 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              28 7 22 13 ;Interpolate Point
                           #--- PUSHB_1   54        ;PUSH Bytes
SRP1            54         ;Set Reference Point 1
                           #--- PUSHB_1   30        ;PUSH Bytes
IP              30         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_5   5 4 21 14 35 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              35 14 21 4 5 ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_2   2 41      ;PUSH Bytes
IP              41         ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   28 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_2   2 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP1            51         ;Set Reference Point 1
                           #--- PUSHB_6   10 25 32 38 44 45 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              45 44 38 32 25 10 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E55': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_3   7 1 0     ;PUSH Bytes
CALL            0 1 7      ;CALL function
                           #--- PUSHB_2   37 9      ;PUSH Bytes
MIRP[min,black] estemt 37  ;Move Indirect Relative Point
                           #--- PUSHB_3   66 2 0    ;PUSH Bytes
CALL            0 2 66     ;CALL function
                           #--- PUSHB_2   13 23     ;PUSH Bytes
SHP[rp1]        23         ;SHift Point using reference point
SHP[rp1]        13         ;SHift Point using reference point
                           #--- PUSHB_2   31 9      ;PUSH Bytes
MIRP[min,black] estemt 31  ;Move Indirect Relative Point
                           #--- PUSHB_5   44 60 7 23 13 ;PUSH Bytes
CALL            13 23 7 60 44 ;CALL function
                           #--- PUSHB_2   44 8      ;PUSH Bytes
MIRP[min,black] cvt_8 44   ;Move Indirect Relative Point
                           #--- PUSHB_1   72        ;PUSH Bytes
MDAP[rnd]       72         ;Move Direct Absolute Point
                           #--- PUSHB_2   18 8      ;PUSH Bytes
MIRP[min,black] cvt_8 18   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   78        ;PUSH Bytes
MDAP[rnd]       78         ;Move Direct Absolute Point
                           #--- PUSHB_1   10        ;PUSH Bytes
MDRP[rp0,rnd,white] 10         ;Move Direct Relative Point
                           #--- PUSHB_2   34 10     ;PUSH Bytes
MIRP[min,black] estemw 34  ;Move Indirect Relative Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP0            34         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   75 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 75 ;CALL function
                           #--- PUSHB_1   75        ;PUSH Bytes
SRP0            75         ;Set Reference Point 0
                           #--- PUSHB_2   41 11     ;PUSH Bytes
CALL            11 41      ;CALL function
                           #--- PUSHB_5   63 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 63 ;CALL function
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP0            63         ;Set Reference Point 0
                           #--- PUSHB_2   69 1      ;PUSH Bytes
CALL            1 69       ;CALL function
                           #--- PUSHB_5   21 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 21 ;CALL function
                           #--- PUSHB_1   21        ;PUSH Bytes
SRP0            21         ;Set Reference Point 0
                           #--- PUSHB_2   57 11     ;PUSH Bytes
CALL            11 57      ;CALL function
                           #--- PUSHB_5   47 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 47 ;CALL function
                           #--- PUSHB_2   79 1      ;PUSH Bytes
CALL            1 79       ;CALL function
                           #--- PUSHB_2   75 15     ;PUSH Bytes
SRP1            15         ;Set Reference Point 1
SRP2            75         ;Set Reference Point 2
                           #--- PUSHB_4   7 13 31 37 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              37 31 13 7 ;Interpolate Point
                           #--- PUSHB_1   63        ;PUSH Bytes
SRP1            63         ;Set Reference Point 1
                           #--- PUSHB_4   18 39 66 72 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              72 66 39 18 ;Interpolate Point
                           #--- PUSHB_2   21 69     ;PUSH Bytes
SRP1            69         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
                           #--- PUSHB_7   5 4 23 30 44 54 60 ;PUSH Bytes
                           #--- DEPTH     #7        ;DEPTH of the stack
SLOOP           7          ;Set LOOP variable
IP              60 54 44 30 23 4 5 ;Interpolate Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SRP1            47         ;Set Reference Point 1
                           #--- PUSHB_2   2 50      ;PUSH Bytes
IP              50         ;Interpolate Point
IP              2          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   37 0      ;PUSH Bytes
SRP1            0          ;Set Reference Point 1
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_2   2 5       ;PUSH Bytes
IP              5          ;Interpolate Point
IP              2          ;Interpolate Point
                           #--- PUSHB_1   60        ;PUSH Bytes
SRP1            60         ;Set Reference Point 1
                           #--- PUSHB_6   10 34 41 47 53 54 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              54 53 47 41 34 10 ;Interpolate Point
                           #--- PUSHB_2   72 66     ;PUSH Bytes
SRP1            66         ;Set Reference Point 1
SRP2            72         ;Set Reference Point 2
                           #--- PUSHB_2   21 15     ;PUSH Bytes
IP              15         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   18        ;PUSH Bytes
SRP1            18         ;Set Reference Point 1
                           #--- PUSHB_1   27        ;PUSH Bytes
IP              27         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E56': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] estemtc 16 ;Move Indirect Relative Point
                           #--- PUSHB_3   36 2 0    ;PUSH Bytes
CALL            0 2 36     ;CALL function
                           #--- PUSHB_2   22 6      ;PUSH Bytes
MIRP[min,black] estemtc 22 ;Move Indirect Relative Point
                           #--- PUSHB_5   8 48 0 36 13 ;PUSH Bytes
CALL            13 36 0 48 8 ;CALL function
                           #--- PUSHB_2   8 8       ;PUSH Bytes
MIRP[min,black] cvt_8 8    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   54        ;PUSH Bytes
MDAP[rnd]       54         ;Move Direct Absolute Point
                           #--- PUSHB_1   5         ;PUSH Bytes
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
                           #--- PUSHB_5   51 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 51 ;CALL function
                           #--- PUSHB_1   51        ;PUSH Bytes
SRP0            51         ;Set Reference Point 0
                           #--- PUSHB_2   45 1      ;PUSH Bytes
CALL            1 45       ;CALL function
                           #--- PUSHB_5   11 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 11 ;CALL function
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP0            11         ;Set Reference Point 0
                           #--- PUSHB_2   19 1      ;PUSH Bytes
CALL            1 19       ;CALL function
                           #--- PUSHB_2   39 10     ;PUSH Bytes
MIRP[min,black] estemw 39  ;Move Indirect Relative Point
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_2   51 5      ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
SRP2            51         ;Set Reference Point 2
                           #--- PUSHB_2   25 33     ;PUSH Bytes
IP              33         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_1   45        ;PUSH Bytes
SRP1            45         ;Set Reference Point 1
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
                           #--- PUSHB_1   11        ;PUSH Bytes
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_1   14        ;PUSH Bytes
IP              14         ;Interpolate Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
                           #--- PUSHB_4   0 16 22 36 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              36 22 16 0 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_5   11 5 42 45 51 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              51 45 42 5 11 ;Interpolate Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
                           #--- PUSHB_2   19 39     ;PUSH Bytes
IP              39         ;Interpolate Point
IP              19         ;Interpolate Point
                           #--- PUSHB_1   22        ;PUSH Bytes
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_2   25 26     ;PUSH Bytes
IP              26         ;Interpolate Point
IP              25         ;Interpolate Point
                           #--- PUSHB_1   36        ;PUSH Bytes
SRP1            36         ;Set Reference Point 1
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E57': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   28 1 0    ;PUSH Bytes
CALL            0 1 28     ;CALL function
                           #--- PUSHB_2   58 8      ;PUSH Bytes
MIRP[min,black] cvt_8 58   ;Move Indirect Relative Point
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] estemtc 48 ;Move Indirect Relative Point
                           #--- PUSHB_3   37 2 0    ;PUSH Bytes
CALL            0 2 37     ;CALL function
                           #--- PUSHB_1   43        ;PUSH Bytes
SHP[rp1]        43         ;SHift Point using reference point
                           #--- PUSHB_2   14 6      ;PUSH Bytes
MIRP[min,black] estemtc 14 ;Move Indirect Relative Point
                           #--- PUSHB_1   7         ;PUSH Bytes
SHP[rp2]        7          ;SHift Point using reference point
                           #--- PUSHB_3   14 37 10  ;PUSH Bytes
CALL            10 37 14   ;CALL function
                           #--- PUSHB_4   64 14 11 9 ;PUSH Bytes
CALL            9 11 14 64 ;CALL function
                           #--- PUSHB_5   64 22 28 37 13 ;PUSH Bytes
CALL            13 37 28 22 64 ;CALL function
                           #--- PUSHB_2   64 8      ;PUSH Bytes
MIRP[min,black] cvt_8 64   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   70        ;PUSH Bytes
MDAP[rnd]       70         ;Move Direct Absolute Point
                           #--- PUSHB_1   34        ;PUSH Bytes
MDRP[rp0,rnd,white] 34         ;Move Direct Relative Point
                           #--- PUSHB_2   17 10     ;PUSH Bytes
MIRP[min,black] estemw 17  ;Move Indirect Relative Point
                           #--- PUSHB_1   17        ;PUSH Bytes
SRP0            17         ;Set Reference Point 0
                           #--- PUSHB_2   11 1      ;PUSH Bytes
CALL            1 11       ;CALL function
                           #--- PUSHB_2   10 10     ;PUSH Bytes
MIRP[min,black] estemw 10  ;Move Indirect Relative Point
                           #--- PUSHB_4   61 10 11 8 ;PUSH Bytes
CALL            8 11 10 61 ;CALL function
                           #--- PUSHB_5   25 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 25 ;CALL function
                           #--- PUSHB_1   10        ;PUSH Bytes
SRP0            10         ;Set Reference Point 0
                           #--- PUSHB_2   4 1       ;PUSH Bytes
CALL            1 4        ;CALL function
                           #--- PUSHB_2   46 10     ;PUSH Bytes
MIRP[min,black] estemw 46  ;Move Indirect Relative Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP0            46         ;Set Reference Point 0
                           #--- PUSHB_2   52 1      ;PUSH Bytes
CALL            1 52       ;CALL function
                           #--- PUSHB_2   55 10     ;PUSH Bytes
MIRP[min,black] estemw 55  ;Move Indirect Relative Point
                           #--- PUSHB_2   71 1      ;PUSH Bytes
CALL            1 71       ;CALL function
                           #--- PUSHB_2   11 17     ;PUSH Bytes
SRP1            17         ;Set Reference Point 1
SRP2            11         ;Set Reference Point 2
                           #--- PUSHB_6   22 28 37 58 64 67 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              67 64 58 37 28 22 ;Interpolate Point
                           #--- PUSHB_2   25 61     ;PUSH Bytes
SRP1            61         ;Set Reference Point 1
SRP2            25         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
                           #--- PUSHB_2   4 10      ;PUSH Bytes
SRP1            10         ;Set Reference Point 1
SRP2            4          ;Set Reference Point 2
                           #--- PUSHB_3   1 2 43    ;PUSH Bytes
IP              43         ;Interpolate Point
IP              2          ;Interpolate Point
IP              1          ;Interpolate Point
                           #--- PUSHB_1   46        ;PUSH Bytes
SRP1            46         ;Set Reference Point 1
                           #--- PUSHB_1   48        ;PUSH Bytes
IP              48         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   48 58     ;PUSH Bytes
SRP1            58         ;Set Reference Point 1
SRP2            48         ;Set Reference Point 2
                           #--- PUSHB_4   25 2 61 67 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              67 61 2 25 ;Interpolate Point
                           #--- PUSHB_2   22 64     ;PUSH Bytes
SRP1            64         ;Set Reference Point 1
SRP2            22         ;Set Reference Point 2
                           #--- PUSHB_1   19        ;PUSH Bytes
IP              19         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_4   4 17 34 46 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              46 34 17 4 ;Interpolate Point
                           #--- PUSHB_1   37        ;PUSH Bytes
SRP2            37         ;Set Reference Point 2
                           #--- PUSHB_1   40        ;PUSH Bytes
IP              40         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E58': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   43 1 0    ;PUSH Bytes
CALL            0 1 43     ;CALL function
                           #--- PUSHB_2   29 6      ;PUSH Bytes
MIRP[min,black] estemtc 29 ;Move Indirect Relative Point
                           #--- PUSHB_3   7 2 0     ;PUSH Bytes
CALL            0 2 7      ;CALL function
                           #--- PUSHB_2   16 6      ;PUSH Bytes
MIRP[min,black] estemtc 16 ;Move Indirect Relative Point
                           #--- PUSHB_5   48 24 43 7 13 ;PUSH Bytes
CALL            13 7 43 24 48 ;CALL function
                           #--- PUSHB_2   48 6      ;PUSH Bytes
MIRP[min,black] estemtc 48 ;Move Indirect Relative Point
                           #--- PUSHB_5   37 56 43 7 13 ;PUSH Bytes
CALL            13 7 43 56 37 ;CALL function
                           #--- PUSHB_2   37 8      ;PUSH Bytes
MIRP[min,black] cvt_8 37   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   62        ;PUSH Bytes
MDAP[rnd]       62         ;Move Direct Absolute Point
                           #--- PUSHB_1   4         ;PUSH Bytes
MDRP[rp0,rnd,white] 4          ;Move Direct Relative Point
                           #--- PUSHB_2   19 10     ;PUSH Bytes
MIRP[min,black] estemw 19  ;Move Indirect Relative Point
                           #--- PUSHB_1   19        ;PUSH Bytes
SRP0            19         ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_5   59 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 59 ;CALL function
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP0            59         ;Set Reference Point 0
                           #--- PUSHB_2   53 1      ;PUSH Bytes
CALL            1 53       ;CALL function
                           #--- PUSHB_5   40 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 40 ;CALL function
                           #--- PUSHB_2   63 1      ;PUSH Bytes
CALL            1 63       ;CALL function
                           #--- PUSHB_2   34 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_6   7 8 15 0 27 45 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              45 27 0 15 8 7 ;Interpolate Point
                           #--- PUSHB_1   59        ;PUSH Bytes
SRP1            59         ;Set Reference Point 1
                           #--- PUSHB_2   29 43     ;PUSH Bytes
IP              43         ;Interpolate Point
IP              29         ;Interpolate Point
                           #--- PUSHB_1   53        ;PUSH Bytes
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_2   37 31     ;PUSH Bytes
IP              31         ;Interpolate Point
IP              37         ;Interpolate Point
                           #--- PUSHB_1   40        ;PUSH Bytes
SRP1            40         ;Set Reference Point 1
                           #--- PUSHB_1   11        ;PUSH Bytes
IP              11         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   29 1      ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            29         ;Set Reference Point 2
                           #--- PUSHB_2   45 46     ;PUSH Bytes
IP              46         ;Interpolate Point
IP              45         ;Interpolate Point
                           #--- PUSHB_1   48        ;PUSH Bytes
SRP1            48         ;Set Reference Point 1
                           #--- PUSHB_3   21 22 31  ;PUSH Bytes
IP              31         ;Interpolate Point
IP              22         ;Interpolate Point
IP              21         ;Interpolate Point
                           #--- PUSHB_1   24        ;PUSH Bytes
SRP2            24         ;Set Reference Point 2
                           #--- PUSHB_8   4 19 27 34 40 50 53 59 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              59 53 50 40 34 27 19 4 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E59': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_3   19 1 0    ;PUSH Bytes
CALL            0 1 19     ;CALL function
                           #--- PUSHB_2   52 8      ;PUSH Bytes
MIRP[min,black] cvt_8 52   ;Move Indirect Relative Point
                           #--- PUSHB_3   28 2 0    ;PUSH Bytes
CALL            0 2 28     ;CALL function
                           #--- PUSHB_1   34        ;PUSH Bytes
SHP[rp1]        34         ;SHift Point using reference point
                           #--- PUSHB_2   5 6       ;PUSH Bytes
MIRP[min,black] estemtc 5  ;Move Indirect Relative Point
                           #--- PUSHB_1   47        ;PUSH Bytes
SHP[rp2]        47         ;SHift Point using reference point
                           #--- PUSHB_4   37 28 5 8 ;PUSH Bytes
CALL            8 5 28 37  ;CALL function
                           #--- PUSHB_2   44 9      ;PUSH Bytes
MIRP[min,black] estemt 44  ;Move Indirect Relative Point
                           #--- PUSHB_5   58 13 19 28 13 ;PUSH Bytes
CALL            13 28 19 13 58 ;CALL function
                           #--- PUSHB_2   58 8      ;PUSH Bytes
MIRP[min,black] cvt_8 58   ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   64        ;PUSH Bytes
MDAP[rnd]       64         ;Move Direct Absolute Point
                           #--- PUSHB_1   25        ;PUSH Bytes
MDRP[rp0,rnd,white] 25         ;Move Direct Relative Point
                           #--- PUSHB_2   8 10      ;PUSH Bytes
MIRP[min,black] estemw 8   ;Move Indirect Relative Point
                           #--- PUSHB_1   8         ;PUSH Bytes
SRP0            8          ;Set Reference Point 0
                           #--- PUSHB_2   55 1      ;PUSH Bytes
CALL            1 55       ;CALL function
                           #--- PUSHB_5   16 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 16 ;CALL function
                           #--- PUSHB_1   16        ;PUSH Bytes
SRP0            16         ;Set Reference Point 0
                           #--- PUSHB_2   40 1      ;PUSH Bytes
CALL            1 40       ;CALL function
                           #--- PUSHB_5   41 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 41 ;CALL function
                           #--- PUSHB_2   65 1      ;PUSH Bytes
CALL            1 65       ;CALL function
                           #--- PUSHB_2   55 8      ;PUSH Bytes
SRP1            8          ;Set Reference Point 1
SRP2            55         ;Set Reference Point 2
                           #--- PUSHB_5   5 13 19 28 61 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              61 28 19 13 5 ;Interpolate Point
                           #--- PUSHB_2   40 16     ;PUSH Bytes
SRP1            16         ;Set Reference Point 1
SRP2            40         ;Set Reference Point 2
                           #--- PUSHB_5   1 0 31 47 49 ;PUSH Bytes
                           #--- DEPTH     #5        ;DEPTH of the stack
SLOOP           5          ;Set LOOP variable
IP              49 47 31 0 1 ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   58 52     ;PUSH Bytes
SRP1            52         ;Set Reference Point 1
SRP2            58         ;Set Reference Point 2
                           #--- PUSHB_1   16        ;PUSH Bytes
IP              16         ;Interpolate Point
                           #--- PUSHB_1   13        ;PUSH Bytes
SRP1            13         ;Set Reference Point 1
                           #--- PUSHB_1   10        ;PUSH Bytes
IP              10         ;Interpolate Point
                           #--- PUSHB_1   44        ;PUSH Bytes
SRP2            44         ;Set Reference Point 2
                           #--- PUSHB_2   8 25      ;PUSH Bytes
IP              25         ;Interpolate Point
IP              8          ;Interpolate Point
                           #--- PUSHB_1   5         ;PUSH Bytes
SRP1            5          ;Set Reference Point 1
                           #--- PUSHB_1   49        ;PUSH Bytes
IP              49         ;Interpolate Point
                           #--- PUSHB_2   28 37     ;PUSH Bytes
SRP1            37         ;Set Reference Point 1
SRP2            28         ;Set Reference Point 2
                           #--- PUSHB_1   31        ;PUSH Bytes
IP              31         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E5A': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   1 1 0     ;PUSH Bytes
CALL            0 1 1      ;CALL function
                           #--- PUSHB_1   36        ;PUSH Bytes
SHP[rp1]        36         ;SHift Point using reference point
                           #--- PUSHB_3   38 4 0    ;PUSH Bytes
CALL            0 4 38     ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp1]        22         ;SHift Point using reference point
                           #--- PUSHB_3   11 4 0    ;PUSH Bytes
CALL            0 4 11     ;CALL function
                           #--- PUSHB_2   30 8      ;PUSH Bytes
MIRP[min,black] cvt_8 30   ;Move Indirect Relative Point
                           #--- PUSHB_3   38 4 0    ;PUSH Bytes
CALL            0 4 38     ;CALL function
                           #--- PUSHB_5   19 5 1 11 13 ;PUSH Bytes
CALL            13 11 1 5 19 ;CALL function
                           #--- PUSHB_2   19 9      ;PUSH Bytes
MIRP[min,black] estemt 19  ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   40        ;PUSH Bytes
MDAP[rnd]       40         ;Move Direct Absolute Point
                           #--- PUSHB_1   8         ;PUSH Bytes
MDRP[rp0,rnd,white] 8          ;Move Direct Relative Point
                           #--- PUSHB_5   33 10 0 22 4 ;PUSH Bytes
CALL            4 22 0 10 33 ;CALL function
                           #--- PUSHB_1   33        ;PUSH Bytes
SRP0            33         ;Set Reference Point 0
                           #--- PUSHB_2   27 1      ;PUSH Bytes
CALL            1 27       ;CALL function
                           #--- PUSHB_5   14 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 14 ;CALL function
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP0            14         ;Set Reference Point 0
                           #--- PUSHB_2   1 1       ;PUSH Bytes
CALL            1 1        ;CALL function
                           #--- PUSHB_1   22        ;PUSH Bytes
SHP[rp2]        22         ;SHift Point using reference point
                           #--- PUSHB_2   0 10      ;PUSH Bytes
MIRP[min,black] estemw 0   ;Move Indirect Relative Point
                           #--- PUSHB_1   0         ;PUSH Bytes
SRP0            0          ;Set Reference Point 0
                           #--- PUSHB_2   37 1      ;PUSH Bytes
CALL            1 37       ;CALL function
                           #--- PUSHB_2   36 12     ;PUSH Bytes
MIRP[min,black] ecstemw 36 ;Move Indirect Relative Point
                           #--- PUSHB_2   41 1      ;PUSH Bytes
CALL            1 41       ;CALL function
                           #--- PUSHB_2   27 33     ;PUSH Bytes
SRP1            33         ;Set Reference Point 1
SRP2            27         ;Set Reference Point 2
                           #--- PUSHB_2   11 17     ;PUSH Bytes
IP              17         ;Interpolate Point
IP              11         ;Interpolate Point
                           #--- PUSHB_1   14        ;PUSH Bytes
SRP1            14         ;Set Reference Point 1
                           #--- PUSHB_2   5 19      ;PUSH Bytes
IP              19         ;Interpolate Point
IP              5          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   30 19     ;PUSH Bytes
SRP1            19         ;Set Reference Point 1
SRP2            30         ;Set Reference Point 2
                           #--- PUSHB_4   8 14 2 24 ;PUSH Bytes
                           #--- DEPTH     #4        ;DEPTH of the stack
SLOOP           4          ;Set LOOP variable
IP              24 2 14 8  ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni0E5B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_3   0 1 0     ;PUSH Bytes
CALL            0 1 0      ;CALL function
                           #--- PUSHB_2   30 6      ;PUSH Bytes
MIRP[min,black] estemtc 30 ;Move Indirect Relative Point
                           #--- PUSHB_1   56        ;PUSH Bytes
MDAP[rnd]       56         ;Move Direct Absolute Point
                           #--- PUSHB_2   53 9      ;PUSH Bytes
MIRP[min,black] estemt 53  ;Move Indirect Relative Point
                           #--- PUSHB_2   39 45     ;PUSH Bytes
SHP[rp2]        45         ;SHift Point using reference point
SHP[rp2]        39         ;SHift Point using reference point
                           #--- PUSHB_3   56 53 10  ;PUSH Bytes
CALL            10 53 56   ;CALL function
                           #--- PUSHB_4   64 56 68 9 ;PUSH Bytes
CALL            9 68 56 64 ;CALL function
                           #--- PUSHB_4   64 56 62 9 ;PUSH Bytes
CALL            9 62 56 64 ;CALL function
                           #--- PUSHB_3   53 56 10  ;PUSH Bytes
CALL            10 56 53   ;CALL function
                           #--- PUSHB_4   64 53 36 9 ;PUSH Bytes
CALL            9 36 53 64 ;CALL function
                           #--- PUSHB_4   64 53 42 9 ;PUSH Bytes
CALL            9 42 53 64 ;CALL function
                           #--- PUSHB_4   64 53 48 9 ;PUSH Bytes
CALL            9 48 53 64 ;CALL function
                           #--- PUSHB_1   56        ;PUSH Bytes
SRP0            56         ;Set Reference Point 0
                           #--- PUSHB_1   12        ;PUSH Bytes
DUP             12         ;DUPlicate top stack element
MDRP[rp0,rnd,white] &_DUP_1    ;Move Direct Relative Point
SRP1            &_DUP_2    ;Set Reference Point 1
                           #--- PUSHB_2   74 8      ;PUSH Bytes
MIRP[min,black] cvt_8 74   ;Move Indirect Relative Point
                           #--- PUSHB_1   80        ;PUSH Bytes
MDAP[rnd]       80         ;Move Direct Absolute Point
                           #--- PUSHB_2   18 8      ;PUSH Bytes
MIRP[min,black] cvt_8 18   ;Move Indirect Relative Point
                           #--- PUSHB_1   24        ;PUSH Bytes
MDAP[rnd]       24         ;Move Direct Absolute Point
                           #--- PUSHB_2   6 6       ;PUSH Bytes
MIRP[min,black] estemtc 6  ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   86        ;PUSH Bytes
MDAP[rnd]       86         ;Move Direct Absolute Point
                           #--- PUSHB_1   3         ;PUSH Bytes
MDRP[rp0,rnd,white] 3          ;Move Direct Relative Point
                           #--- PUSHB_2   27 10     ;PUSH Bytes
MIRP[min,black] estemw 27  ;Move Indirect Relative Point
                           #--- PUSHB_1   27        ;PUSH Bytes
SRP0            27         ;Set Reference Point 0
                           #--- PUSHB_2   15 1      ;PUSH Bytes
CALL            1 15       ;CALL function
                           #--- PUSHB_5   83 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 83 ;CALL function
                           #--- PUSHB_1   83        ;PUSH Bytes
SRP0            83         ;Set Reference Point 0
                           #--- PUSHB_2   77 1      ;PUSH Bytes
CALL            1 77       ;CALL function
                           #--- PUSHB_2   9 12      ;PUSH Bytes
MIRP[min,black] ecstemw 9  ;Move Indirect Relative Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP0            9          ;Set Reference Point 0
                           #--- PUSHB_2   34 1      ;PUSH Bytes
CALL            1 34       ;CALL function
                           #--- PUSHB_2   38 12     ;PUSH Bytes
MIRP[min,black] ecstemw 38 ;Move Indirect Relative Point
                           #--- PUSHB_2   87 1      ;PUSH Bytes
CALL            1 87       ;CALL function
                           #--- PUSHB_2   77 83     ;PUSH Bytes
SRP1            83         ;Set Reference Point 1
SRP2            77         ;Set Reference Point 2
                           #--- PUSHB_6   6 12 0 24 30 18 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              18 30 24 0 12 6 ;Interpolate Point
                           #--- PUSHB_1   9         ;PUSH Bytes
SRP1            9          ;Set Reference Point 1
                           #--- PUSHB_1   21        ;PUSH Bytes
IP              21         ;Interpolate Point
                           #--- PUSHB_1   34        ;PUSH Bytes
SRP2            34         ;Set Reference Point 2
                           #--- PUSHB_1   33        ;PUSH Bytes
IP              33         ;Interpolate Point
                           #--- PUSHB_1   38        ;PUSH Bytes
SRP1            38         ;Set Reference Point 1
                           #--- PUSHB_1   71        ;PUSH Bytes
IP              71         ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_2   53 74     ;PUSH Bytes
SRP1            74         ;Set Reference Point 1
SRP2            53         ;Set Reference Point 2
                           #--- PUSHB_8   3 27 15 59 65 71 77 83 ;PUSH Bytes
                           #--- DEPTH     #8        ;DEPTH of the stack
SLOOP           8          ;Set LOOP variable
IP              83 77 71 65 59 15 27 3 ;Interpolate Point
                           #--- PUSHB_2   18 80     ;PUSH Bytes
SRP1            80         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
                           #--- PUSHB_6   9 21 33 34 50 51 ;PUSH Bytes
                           #--- DEPTH     #6        ;DEPTH of the stack
SLOOP           6          ;Set LOOP variable
IP              51 50 34 33 21 9 ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni200B': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   15        ;PUSH Bytes
MDAP[rnd]       15         ;Move Direct Absolute Point
                           #--- PUSHB_1   1         ;PUSH Bytes
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
                           #--- PUSHB_5   0 10 0 13 4 ;PUSH Bytes
CALL            4 13 0 10 0 ;CALL function
                           #--- PUSHB_2   0 1       ;PUSH Bytes
SRP1            1          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
                           #--- PUSHB_1   8         ;PUSH Bytes
IP              8          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni2010': """
                           #--- PUSHB_5   0 6 0 6 3 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       3          ;Move Direct Absolute Point
MIRP[min,black] estemtc 0  ;Move Indirect Relative Point
MIRP[min,black] estemtc 0  ;Move Indirect Relative Point
                           #--- NPUSHB    10 5 1 2 12 0 7 4 3 1 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
CALL            1 3        ;CALL function
CALL            4 7 0 12 2 ;CALL function
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni203E': """
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   1         ;PUSH Bytes
MDAP[rnd]       1          ;Move Direct Absolute Point
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
                           #--- PUSHB_2   2 7       ;PUSH Bytes
MIRP[min,black] cvt_7 2    ;Move Indirect Relative Point
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
                           #--- PUSHB_1   4         ;PUSH Bytes
MDAP[rnd]       4          ;Move Direct Absolute Point
                           #--- PUSHB_2   5 1       ;PUSH Bytes
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uni207F': """
                           #--- PUSHB_3   23 8 10   ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       10         ;Move Direct Absolute Point
MIRP[min,black] cvt_8 23   ;Move Indirect Relative Point
                           #--- NPUSHB    21 23 1 15 29 1 0 10 0 22 4 1 1 15 18 15 10 0 22 4 16 28 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       28         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 16         ;Move Direct Relative Point
CALL            4 22 0 10 15 ;CALL function
SHP[rp2]        18         ;SHift Point using reference point
SRP0            15         ;Set Reference Point 0
CALL            1 1        ;CALL function
CALL            4 22 0 10 0 ;CALL function
CALL            1 29       ;CALL function
SRP1            15         ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              23         ;Interpolate Point
                           #--- PUSHB_4   17 19 23 10 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            10         ;Set Reference Point 1
SRP2            23         ;Set Reference Point 2
IP              19         ;Interpolate Point
IP              17         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uniF71B': """
                           #--- PUSHB_3   3 3 0     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 3 3      ;CALL function
                           #--- NPUSHB    14 5 1 1 12 0 7 4 1 12 0 7 4 2 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 2          ;Move Direct Relative Point
CALL            4 7 0 12 1 ;CALL function
CALL            4 7 0 12 1 ;CALL function
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uniF71C': """
                           #--- NPUSHB    8 1 6 0 23 4 0 0 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 0      ;CALL function
CALL            4 23 0 6 1 ;CALL function
                           #--- NPUSHB    9 5 1 2 12 0 11 4 0 4 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       4          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 0          ;Move Direct Relative Point
CALL            4 11 0 12 2 ;CALL function
CALL            1 5        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'uniF71D': """
                           #--- NPUSHB    17 3 7 0 40 4 6 1 0 6 1 0 0 5 9 6 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 6      ;CALL function
MIRP[min,black] estemt 5   ;Move Indirect Relative Point
SHP[rp2]        0          ;SHift Point using reference point
CALL            0 1 6      ;CALL function
CALL            0 1 6      ;CALL function
CALL            4 40 0 7 3 ;CALL function
                           #--- NPUSHB    17 9 1 0 10 0 13 4 1 1 4 4 10 0 13 4 5 8 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 5          ;Move Direct Relative Point
CALL            4 13 0 10 4 ;CALL function
SRP0            4          ;Set Reference Point 0
CALL            1 1        ;CALL function
CALL            4 13 0 10 0 ;CALL function
CALL            1 9        ;CALL function
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'v': """
                           #--- PUSHB_7   4 1 3 0 0 1 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
CALL            0 3 1      ;CALL function
SHP[rp1]        4          ;SHift Point using reference point
                           #--- PUSHB_4   2 31 1 1  ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 1 2 7 2 31 1 5 5 31 4 4 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   4 31 5 8  ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       8          ;Move Direct Absolute Point
MDRP[rp0,min,white] 5          ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 4  ;Move Indirect Relative Point
SHPIX           -6 4       ;SHift point by a PIXel amount
MDAP[rnd]       4          ;Move Direct Absolute Point
MIRP[min,black] estemwc 5  ;Move Indirect Relative Point
SRP0            5          ;Set Reference Point 0
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[min,white] estemwc 2  ;Move Indirect Relative Point
SRP1            7          ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
IP              1          ;Interpolate Point
SHPIX           -18 1      ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] estemwc 2  ;Move Indirect Relative Point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'w': """
                           #--- NPUSHB    9 5 7 1 3 0 10 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
SHP[rp1]        10         ;SHift Point using reference point
CALL            0 3 1      ;CALL function
SHP[rp1]        7          ;SHift Point using reference point
SHP[rp1]        5          ;SHift Point using reference point
                           #--- NPUSHB    10 5 9 4 4 7 1 2 31 1 1 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 1 2 14 2 31 1 8 8 31 7 7 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   7 31 8 15 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       15         ;Move Direct Absolute Point
MDRP[rp0,min,white] 8          ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 7  ;Move Indirect Relative Point
SHPIX           -6 7       ;SHift point by a PIXel amount
MDAP[rnd]       7          ;Move Direct Absolute Point
MIRP[min,black] estemwc 8  ;Move Indirect Relative Point
SRP0            8          ;Set Reference Point 0
MDRP[rp0,min,white] 1          ;Move Direct Relative Point
MIRP[min,white] estemwc 2  ;Move Indirect Relative Point
SRP1            14         ;Set Reference Point 1
SRP2            2          ;Set Reference Point 2
IP              1          ;Interpolate Point
SHPIX           -18 1      ;SHift point by a PIXel amount
MDAP[rnd]       1          ;Move Direct Absolute Point
MIRP[min,black] estemwc 2  ;Move Indirect Relative Point
SRP1            1          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              4          ;Interpolate Point
MDAP[rnd]       4          ;Move Direct Absolute Point
MIRP[min,black] estemt 5   ;Move Indirect Relative Point
                           #--- PUSHB_3   3 1 0     ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            1          ;Set Reference Point 2
IP              3          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'x': """
                           #--- NPUSHB    8 1 10 3 0 4 8 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 8      ;CALL function
SHP[rp1]        4          ;SHift Point using reference point
CALL            0 3 10     ;CALL function
SHP[rp1]        1          ;SHift Point using reference point
                           #--- PUSHB_4   7 31 8 8  ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 8 7 12 7 31 8 4 4 31 5 5 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   5 31 4 13 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       13         ;Move Direct Absolute Point
MDRP[rp0,min,white] 4          ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 5  ;Move Indirect Relative Point
SHPIX           -6 5       ;SHift point by a PIXel amount
MDAP[rnd]       5          ;Move Direct Absolute Point
MIRP[min,black] estemwc 4  ;Move Indirect Relative Point
SRP0            4          ;Set Reference Point 0
MDRP[rp0,min,white] 8          ;Move Direct Relative Point
MIRP[min,white] estemwc 7  ;Move Indirect Relative Point
SRP1            12         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              8          ;Interpolate Point
SHPIX           -18 8      ;SHift point by a PIXel amount
MDAP[rnd]       8          ;Move Direct Absolute Point
MIRP[min,black] estemwc 7  ;Move Indirect Relative Point
                           #--- PUSHB_4   0 6 10 8  ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            8          ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
IP              6          ;Interpolate Point
IP              0          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'y': """
                           #--- NPUSHB    9 12 9 3 0 3 6 17 0 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 0 17     ;CALL function
MIRP[min,black] estemtc 3  ;Move Indirect Relative Point
CALL            0 3 9      ;CALL function
SHP[rp1]        12         ;SHift Point using reference point
                           #--- PUSHB_4   10 31 9 9 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 9 10 19 10 31 9 13 13 31 12 12 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   12 31 13 20 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       20         ;Move Direct Absolute Point
MDRP[rp0,min,white] 13         ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 12 ;Move Indirect Relative Point
SHPIX           -6 12      ;SHift point by a PIXel amount
MDAP[rnd]       12         ;Move Direct Absolute Point
MIRP[min,black] estemwc 13 ;Move Indirect Relative Point
SRP0            13         ;Set Reference Point 0
MDRP[rp0,min,white] 9          ;Move Direct Relative Point
MIRP[min,white] estemwc 10 ;Move Indirect Relative Point
SRP1            19         ;Set Reference Point 1
SRP2            10         ;Set Reference Point 2
IP              9          ;Interpolate Point
SHPIX           -18 9      ;SHift point by a PIXel amount
MDAP[rnd]       9          ;Move Direct Absolute Point
MIRP[min,black] estemwc 10 ;Move Indirect Relative Point
                           #--- PUSHB_3   11 9 3    ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            3          ;Set Reference Point 1
SRP2            9          ;Set Reference Point 2
IP              11         ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'yen': """
                           #--- NPUSHB    8 13 4 8 15 3 1 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 1      ;CALL function
MDAP[rnd]       3          ;Move Direct Absolute Point
SHP[rp1]        15         ;SHift Point using reference point
MIRP[min,black] cvt_8 4    ;Move Indirect Relative Point
SHP[rp2]        13         ;SHift Point using reference point
                           #--- NPUSHB    28 9 0 1 18 1 64 1 3 9 1 0 10 64 0 15 9 0 1 10 12 0 10 0 30 4 5 1 17 ;PUSH N Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       17         ;Move Direct Absolute Point
MDRP[rp0,rnd,white] 1          ;Move Direct Relative Point
SHP[rp2]        5          ;SHift Point using reference point
CALL            4 30 0 10 0 ;CALL function
SHP[rp2]        12         ;SHift Point using reference point
CALL            10 1 0     ;CALL function
CALL            9 15 0 64  ;CALL function
CALL            10 0 1     ;CALL function
CALL            9 3 1 64   ;CALL function
CALL            1 18       ;CALL function
SRP1            1          ;Set Reference Point 1
SRP2            0          ;Set Reference Point 2
IP              9          ;Interpolate Point
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'z': """
                           #--- NPUSHB    10 3 9 4 3 0 7 9 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemt 7   ;Move Indirect Relative Point
CALL            0 3 4      ;CALL function
MIRP[min,black] estemt 3   ;Move Indirect Relative Point
                           #--- NPUSHB    8 9 6 3 0 7 31 0 0 ;PUSH N Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 0 7 10 7 31 0 6 6 31 2 2 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   2 31 6 11 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       11         ;Move Direct Absolute Point
MDRP[rp0,min,white] 6          ;Move Direct Relative Point
MIRP[rp0,min,white] estemwc 2  ;Move Indirect Relative Point
SHPIX           -6 2       ;SHift point by a PIXel amount
MDAP[rnd]       2          ;Move Direct Absolute Point
MIRP[min,black] estemwc 6  ;Move Indirect Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[rp0,min,white] 0          ;Move Direct Relative Point
MIRP[min,white] estemwc 7  ;Move Indirect Relative Point
SRP1            10         ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              0          ;Interpolate Point
SHPIX           -18 0      ;SHift point by a PIXel amount
MDAP[rnd]       0          ;Move Direct Absolute Point
MIRP[min,black] estemwc 7  ;Move Indirect Relative Point
SRP0            0          ;Set Reference Point 0
MDRP[grey]      3          ;Move Direct Relative Point
SRP0            6          ;Set Reference Point 0
MDRP[grey]      9          ;Move Direct Relative Point
                           #--- PUSHB_5   6 3 1 7 0 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            0          ;Set Reference Point 1
SRP2            7          ;Set Reference Point 2
IP              1          ;Interpolate Point
SRP1            3          ;Set Reference Point 1
IP              6          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

    'zero': """
                           #--- NPUSHB    10 18 6 6 5 0 12 6 0 1 0 ;PUSH N Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
CALL            0 1 0      ;CALL function
MIRP[min,black] estemtc 12 ;Move Indirect Relative Point
CALL            0 5 6      ;CALL function
MIRP[min,black] estemtc 18 ;Move Indirect Relative Point
                           #--- PUSHB_4   21 10 3 3 ;PUSH Bytes
                           #--- PUSHW_1   -18       ;PUSH Words
                           #--- NPUSHB    11 3 21 24 21 10 3 9 9 10 15 15 ;PUSH N Bytes
                           #--- PUSHW_1   -6        ;PUSH Words
                           #--- PUSHB_4   15 10 9 25 ;PUSH Bytes
SVTCA[x-axis]              ;Set freedom and projection Vectors To Coordinate Axis
MDAP[rnd]       25         ;Move Direct Absolute Point
MDRP[rp0,min,white] 9          ;Move Direct Relative Point
MIRP[rp0,min,white] estemw 15  ;Move Indirect Relative Point
SHPIX           -6 15      ;SHift point by a PIXel amount
MDAP[rnd]       15         ;Move Direct Absolute Point
MIRP[min,black] estemw 9   ;Move Indirect Relative Point
SRP0            9          ;Set Reference Point 0
MDRP[rp0,min,white] 3          ;Move Direct Relative Point
MIRP[min,white] estemw 21  ;Move Indirect Relative Point
SRP1            24         ;Set Reference Point 1
SRP2            21         ;Set Reference Point 2
IP              3          ;Interpolate Point
SHPIX           -18 3      ;SHift point by a PIXel amount
MDAP[rnd]       3          ;Move Direct Absolute Point
MIRP[min,black] estemw 21  ;Move Indirect Relative Point
                           #--- PUSHB_4   9 3 18 12 ;PUSH Bytes
SVTCA[y-axis]              ;Set freedom and projection Vectors To Coordinate Axis
SRP1            12         ;Set Reference Point 1
SRP2            18         ;Set Reference Point 2
IP              3          ;Interpolate Point
IP              9          ;Interpolate Point
IUP[y]                     ;Interpolate Untouched Points through the outline
IUP[x]                     ;Interpolate Untouched Points through the outline
""",

}
